package com.selfservit.util;

import static com.selfservit.util.mInterfaceUtil.decrypt;

import android.content.Context;
import android.util.Log;

import com.onesignal.OSNotification;
import com.onesignal.OSNotificationReceivedEvent;
import com.onesignal.OneSignal;

import org.json.JSONException;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Date;
import java.util.Locale;

public class backgroundNotification implements OneSignal.OSRemoteNotificationReceivedHandler {


    String[] baseDirectory;
    File notificationsFile, fileDirectory;
    JSONObject msgBody, msgHeader;
    public static final Locale locale = Locale.US;


    @Override
    public void remoteNotificationReceived(Context context, OSNotificationReceivedEvent osNotificationReceivedEvent) {
        /* Do something with notification payload */
        OSNotification notification = osNotificationReceivedEvent.getNotification();
        try {
            msgHeader = (JSONObject) notification.getAdditionalData().get("msgHeader");
            String packageName = msgHeader.getString("appID");
            baseDirectory = packageName.split("\\.");
            String clientID = msgHeader.getString("clientID");
            String countryCode = msgHeader.getString("countryCode");
            msgBody = (JSONObject) notification.getAdditionalData().get("msgBody");
            msgBody.put("notificationID", notification.getNotificationId());
            String scrID = msgBody.getString("scrID");
            String key = msgBody.getString("key");
            String subKey = msgBody.getString("subKey");

            if (!scrID.contains("_chat")) {
                fileDirectory = new File(mInterfaceUtil.rootDirectory + "/" + baseDirectory[(baseDirectory.length - 1)] + "/" + clientID + "/" + countryCode + "/" + "notifications" + "/" + "unread");
                if (!fileDirectory.exists()) {
                    boolean success = fileDirectory.mkdirs();
                    if (!success) {
                        System.out.println("Directory not created");
                    }
                }
                notificationsFile = new File(fileDirectory, notification.getNotificationId() + ".json");
                Date date = new Date();
                msgBody.put("dateTime", Date.parse(date.toString()));
                JSONObject jsonObj = notification.toJSONObject();
                jsonObj.remove("rawPayload");
                FileWriter fw = new FileWriter(notificationsFile);
                fw.write(mInterfaceUtil.encrypt(jsonObj.toString()));
                fw.close();
            }
        } catch (JSONException | IOException e) {
            e.printStackTrace();
        }
        JSONObject data = notification.getAdditionalData();
        Log.i("OneSignalExample", "Received Notification Data: " + data);

        // If complete isn't call within a time period of 25 seconds, OneSignal internal logic will show the original notification
        // To omit displaying a notification, pass `null` to complete()
        osNotificationReceivedEvent.complete(notification);
    }
}