package com.selfservit.util;

import static com.selfservit.util.mInterfaceUtil.decrypt;
import static com.selfservit.util.mInterfaceUtil.rootDirectory;

import android.Manifest;
import android.annotation.TargetApi;
import android.app.AlarmManager;
import android.app.PendingIntent;
import android.app.Service;
import android.content.Context;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.location.Location;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.AsyncTask;
import android.os.Build;
import android.os.Bundle;
import android.os.Handler;
import android.os.IBinder;
import android.os.Looper;
import android.os.SystemClock;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.annotation.RequiresApi;

import com.google.android.gms.common.ConnectionResult;
import com.google.android.gms.common.GoogleApiAvailability;
import com.google.android.gms.common.api.GoogleApiClient;
import com.google.android.gms.common.api.PendingResult;
import com.google.android.gms.common.api.Status;
import com.google.android.gms.location.LocationRequest;
import com.google.android.gms.location.LocationServices;
import com.google.android.gms.location.Priority;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.URL;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.Timer;
import java.util.TimerTask;

@TargetApi(Build.VERSION_CODES.O)
public class mInterfaceService extends Service implements com.google.android.gms.location.LocationListener, GoogleApiClient.ConnectionCallbacks, GoogleApiClient.OnConnectionFailedListener {
    public Timer setQueueInterval,
            setQueueToServerInterval,
            setTimerInterval,
            setLocationTimeInterval;
    GoogleApiClient mGoogleApiClient;
    LocationRequest mLocationRequest;
    Location mCurrentLocation;
    String mLastUpdateTime;
    private static long MINIMUM_INTERVAL = 0;
    private static TimerTask setProcessIntervalObj;
    private static Timer setProcessInterval;
    private static Context context;
    public static boolean appStateTimerStatus = false;
    String locationUpdateInd = "false";

    TimerTask setQueueIntervalObj;

    @Override
    public IBinder onBind(Intent intent) {
        return null;
    }

    @Override
    @TargetApi(Build.VERSION_CODES.O)
    public int onStartCommand(Intent intent, int flags, int startId) {
        try {
            context = getApplicationContext();
            if (mInterfaceUtil.packageName.equals("")) {
                mInterfaceUtil.packageName = getApplicationContext().getPackageName().split("\\.")[2];
            }
            Intent serviceIntent = new Intent(getApplicationContext(), mInterfaceReceiver.class);
            serviceIntent.setAction("com.example.checkservice");
            final PendingIntent pIntent;
            if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.S) {
                pIntent = PendingIntent.getBroadcast(getApplicationContext(),
                        0,
                        serviceIntent,
                        PendingIntent.FLAG_IMMUTABLE);
            } else {
                pIntent = PendingIntent.getBroadcast(getApplicationContext(),
                        0,
                        serviceIntent,
                        PendingIntent.FLAG_UPDATE_CURRENT);
            }
            long firstMillis = System.currentTimeMillis();
            AlarmManager alarm = (AlarmManager) getSystemService(Context.ALARM_SERVICE);
            alarm.setRepeating(AlarmManager.RTC_WAKEUP, firstMillis,
                    300000, pIntent);

            setQueueToServerInterval = new Timer();
            setQueueIntervalObj = new TimerTask() {
                public void run() {
                    if (isConnected()) {
                        new DispatchQueueMoveToServer().execute();
                    }
                }
            };
            setQueueToServerInterval.schedule(setQueueIntervalObj, 2000, 2000);
            // App State Info Process //
            mInterfaceUtil.validateAppStateInfo(getApplicationContext());
            if (!isGooglePlayServicesAvailable()) {
                System.out.println("Play services not available..");
            }
            String currentLine;
            StringBuilder locConfigObj = new StringBuilder();
            File baseDirectory = rootDirectory;
            File locConfigFile = new File(baseDirectory, "/" + mInterfaceUtil.packageName + "/app_controller.json");
            if (locConfigFile.exists()) {
                BufferedReader readerObj = new BufferedReader(new FileReader(locConfigFile));
                while ((currentLine = readerObj.readLine()) != null) {
                    locConfigObj.append(currentLine);
                }
                readerObj.close();
                JSONObject serverDateObj = new JSONObject(decrypt(locConfigObj.toString()));
                if (serverDateObj.has("location_check")) {
                    boolean locationCheck = serverDateObj.getBoolean("location_check");
                    if (!locationCheck) {
                        TimerTask timerTask = new TimerTask() {
                            @Override
                            public void run() {
                                try {
                                    getPeriodicalLocationUpdates();
                                    update();
                                } catch (Exception e) {
                                    e.printStackTrace();
                                }
                            }
                        };
                        if (setLocationTimeInterval == null) {
                            setLocationTimeInterval = new Timer();
                            JSONObject locationConfig = serverDateObj.getJSONObject("location_configuration");
                            setLocationTimeInterval.schedule(timerTask, (Integer.parseInt(locationConfig.getString("location_fetch_interval_in_seconds")) * 1000L), (Integer.parseInt(locationConfig.getString("location_fetch_interval_in_seconds")) * 1000L));
                            MINIMUM_INTERVAL = Long.parseLong(locationConfig.getString("location_fetch_interval_in_seconds"));
                            createLocationRequest();
                            this.mGoogleApiClient = new GoogleApiClient.Builder(this)
                                    .addConnectionCallbacks(this)
                                    .addOnConnectionFailedListener(this)
                                    .addApi(LocationServices.API)
                                    .build();
                            mGoogleApiClient.connect();
                        }
                        getPeriodicalLocationUpdates();
                        update();
                    }
                }
            } else {
                System.out.println("There is no location config file...");
            }
            File existLastKnownLocation = new File(baseDirectory, mInterfaceUtil.packageName + "/" + "LastKnownLocation.txt");
            File existMyLocation = new File(baseDirectory, mInterfaceUtil.packageName + "/" + "MyLocation.txt");
            if (existLastKnownLocation.exists()) {
                existLastKnownLocation.delete();
            }
            if (existMyLocation.exists()) {
                existMyLocation.delete();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return START_STICKY;
    }

    public static void handleAppStateTimer(String status) {
        try {
            if (status.equalsIgnoreCase("failure")) {
                if (!appStateTimerStatus) {
                    setProcessInterval = new Timer();
                    setProcessIntervalObj = new TimerTask() {
                        public void run() {
                            appStateTimerStatus = true;
                            mInterfaceUtil.validateAppStateInfo(context);
                        }
                    };
                    setProcessInterval.schedule(setProcessIntervalObj,
                            60000,
                            60000);
                }
            } else {
                if (setProcessInterval != null) {
                    appStateTimerStatus = false;
                    setProcessInterval.cancel();
                    setProcessInterval.purge();
                }
                if (setProcessIntervalObj != null) {
                    setProcessIntervalObj.cancel();
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private boolean isGooglePlayServicesAvailable() {
        try {
            int resultCode = GoogleApiAvailability.getInstance().isGooglePlayServicesAvailable(this);
            return ConnectionResult.SUCCESS == resultCode;
        } catch (Exception e) {
            e.printStackTrace();
        }
        return false;
    }

    public void createLocationRequest() {
        try {
            mLocationRequest = LocationRequest.create();
            mLocationRequest.setInterval(MINIMUM_INTERVAL * 1000);
            mLocationRequest.setFastestInterval(MINIMUM_INTERVAL * 1000);
            mLocationRequest.setPriority(Priority.PRIORITY_HIGH_ACCURACY);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    protected void startLocationUpdates(Context context) {
        boolean isPermissionGranted;
        try {
            if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M) {
                if (context.checkSelfPermission(Manifest.permission.ACCESS_FINE_LOCATION) != PackageManager.PERMISSION_GRANTED && checkSelfPermission(Manifest.permission.ACCESS_COARSE_LOCATION) != PackageManager.PERMISSION_GRANTED) {
                    isPermissionGranted = false;
                } else {
                    isPermissionGranted = true;
                }
            } else {
                isPermissionGranted = true;
            }
            if (isPermissionGranted) {
                PendingResult<Status> pendingResult = LocationServices.FusedLocationApi.requestLocationUpdates(mGoogleApiClient, mLocationRequest, this, Looper.getMainLooper());
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @Override
    public void onLocationChanged(@NonNull Location location) {
        try {
            if (locationUpdateInd.equals("true")) {
                locationUpdateInd = "false";
                mCurrentLocation = location;
                mLastUpdateTime = DateFormat.getTimeInstance().format(new Date());
                String lat = String.valueOf(mCurrentLocation.getLatitude());
                String lng = String.valueOf(mCurrentLocation.getLongitude());
                if (!isLocationDuplicate(lat, lng)) {
                    new UpdateLocation(lat, lng).execute("");
                    if (isConnected()) {
                        new SendLocation().execute();
                    }
                }
                String string = ("Latitude : " + lat + "Longitude : " + lng + "\n");
                System.out.println(string);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private boolean isLocationDuplicate(String lat, String lng) {
        BufferedReader readerObj;
        StringBuilder locationData;
        File baseDirectory;
        String currentLine;
        String[] lastKnownLocation;
        boolean result = false;
        try {
            baseDirectory = rootDirectory;
            locationData = new StringBuilder();
            File lastKnownLocationFile = new File(baseDirectory, "/" + mInterfaceUtil.packageName + "/last_known_location.txt");
            if (lastKnownLocationFile.exists()) {
                readerObj = new BufferedReader(new FileReader(lastKnownLocationFile));
                while ((currentLine = readerObj.readLine()) != null) {
                    locationData.append(decrypt(currentLine));
                }
                readerObj.close();
                lastKnownLocation = locationData.toString().split(",");
                result = lastKnownLocation[0].equals(lat) && lastKnownLocation[1].equals(lng);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return result;
    }

    @Override
    public void onConnected(@Nullable Bundle bundle) {
        try {
            if (mGoogleApiClient.isConnected()) {
                startLocationUpdates(mInterfaceService.this);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @Override
    public void onConnectionSuspended(int i) {

    }

    @Override
    public void onConnectionFailed(@NonNull ConnectionResult connectionResult) {

    }

    private class DispatchQueueMoveToServer extends AsyncTask<String,
            Void,
            String> {
        @Override
        protected String doInBackground(String... params) {
            String statusIndication = "false";
            try {
                String clientID, countryCode, userID, clientUrl;
                ArrayList<JSONObject> accountsList;
                if (new File(rootDirectory, "/" + mInterfaceUtil.packageName + "/my_accounts").exists()) {
                    accountsList = mInterface.getJsonDataFromFiles(new File(rootDirectory, "/" + mInterfaceUtil.packageName + "/my_accounts").getPath());
                    if (isConnected()) {
                        for (JSONObject currentAccount : accountsList) {
                            clientID = currentAccount.optString("client_id");
                            countryCode = currentAccount.optString("country_code");
                            userID = currentAccount.optString("user_id");
                            clientUrl = currentAccount.optString("client_url");
                            File baseDirectory = rootDirectory;
                            File databaseDir = new File(baseDirectory + "/" + mInterfaceUtil.packageName + "/" + clientID + "/" + countryCode + "/database");
                            if (databaseDir.exists()) {
                                String attachmentsPath = rootDirectory + "/" + mInterfaceUtil.packageName + "/" + clientID + "/" + countryCode + "/database/attachments";
                                String queuesPath = baseDirectory + "/" + mInterfaceUtil.packageName + "/" + clientID + "/" + countryCode + "/database/queue";
                                if (new File(attachmentsPath).exists()) {
                                    File[] attachmentsFiles = new File(attachmentsPath).listFiles();
                                    if (attachmentsFiles != null) {
                                        for (int attachIndex = 0; attachIndex < attachmentsFiles.length; attachIndex++) {
                                            Arrays.sort(attachmentsFiles);
                                            if (attachmentsFiles[attachIndex].length() == 0) {
                                                break;
                                            }
                                            String[] fileName = attachmentsFiles[attachIndex].toString().split("/");
                                            String attachURL = clientUrl + "/common/components/QueueManager/QueueUpload.aspx?file_path=attachments&client_id=" + clientID + "&country_code=" + countryCode + "&user_id=" + userID + "&file_name=" + fileName[fileName.length - 1];
                                            statusIndication = new mInterfaceUtil().sendFilesToServer(attachmentsFiles[attachIndex].toString(), fileName[fileName.length - 1], attachURL);
                                            if (statusIndication.equals("true")) {
                                                break;
                                            }
                                        }
                                    }
                                }
                                if (statusIndication.equals("false")) {
                                    if (new File(queuesPath).exists()) {
                                        File[] queueFiles = new File(queuesPath).listFiles();
                                        if (queueFiles != null) {
                                            for (int queueIndex = 0; queueIndex < queueFiles.length; queueIndex++) {
                                                Arrays.sort(queueFiles);
                                                if (queueFiles[queueIndex].length() == 0) {
                                                    break;
                                                }
                                                String[] fileName = queueFiles[queueIndex].toString().split("/");
                                                String queueURL = clientUrl + "/common/components/QueueManager/QueueUpload.aspx?file_path=queue&client_id=" + clientID + "&country_code=" + countryCode + "&user_id=" + userID + "&file_name=" + fileName[fileName.length - 1];
                                                new mInterfaceUtil().sendFilesToServer(queueFiles[queueIndex].toString(), fileName[fileName.length - 1], queueURL);
                                            }
                                        }
                                    }
                                }
                            } else {
                                System.out.println("No database directory");
                            }
                        }
                    } else {
                        System.out.println("No internet connection..");
                    }
                } else {
                    System.out.println("No my accounts file");
                }
            } catch (Exception e) {
                System.out.println("out exception : " + e.getMessage());
            }
            return null;
        }

        @Override
        protected void onPostExecute(String result) {
            //Here you are done with the task
            System.out.println("Finished...");
        }
    }

    private void getPeriodicalLocationUpdates() {
        try {
            locationUpdateInd = "true";
            mInterfaceUtil.timerInd = "running";
            if (mGoogleApiClient.isConnected()) {
                startLocationUpdates(mInterfaceService.this);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @RequiresApi(api = Build.VERSION_CODES.O)
    private class SendLocation extends AsyncTask<String,
            Void,
            String> {
        @Override
        protected String doInBackground(String... urls) {
            String currentLine, clientID, countryCode, clientUrl, deviceID;
            ArrayList<JSONObject> accountsList;
            StringBuilder locationData;
            BufferedReader readerObj;
            BufferedWriter writerObj;
            String serverData,
                    requestURL;
            OutputStreamWriter oStreamObj;
            HttpURLConnection urlConObj;
            URL requestPath;

            try {
                File baseDirectory = rootDirectory;
                if (new File(baseDirectory, "/" + mInterfaceUtil.packageName + "/my_accounts").exists()) {
                    accountsList = mInterface.getJsonDataFromFiles(new File(rootDirectory, "/" + mInterfaceUtil.packageName + "/my_accounts").getPath());
                    locationData = new StringBuilder();
                    readerObj = new BufferedReader(new FileReader(new File(baseDirectory, "/" + mInterfaceUtil.packageName + "/my_location.txt")));
                    while ((currentLine = readerObj.readLine()) != null) {
                        locationData.append(decrypt(currentLine));
                    }
                    readerObj.close();
                    serverData = locationData.toString();

                    for (JSONObject currentAccount : accountsList) {
                        if (currentAccount.optString("location_update_ind").equals("true")) {
                            clientID = currentAccount.optString("client_id");
                            countryCode = currentAccount.optString("country_code");
                            clientUrl = currentAccount.optString("client_url");
                            deviceID = currentAccount.optString("device_id");
                            requestURL = clientUrl + "/common/components/GeoLocation/update_device_location_offline.aspx";
                            /* SEND LOCATION  */
                            requestPath = new URL(requestURL);
                            urlConObj = (HttpURLConnection) requestPath.openConnection();
                            urlConObj.setDoOutput(true);
                            urlConObj.setRequestMethod("POST");
                            urlConObj.setRequestProperty("CONTENT-TYPE", "text/xml");
                            urlConObj.connect();
                            oStreamObj = new OutputStreamWriter(urlConObj.getOutputStream());
                            oStreamObj.write("<location_xml><client_id>" + clientID + "</client_id><country_code>" + countryCode + "</country_code><device_id>" + deviceID + "</device_id><location>" + serverData + "</location></location_xml>");
                            oStreamObj.flush();
                            oStreamObj.close();
                            int responseCode = urlConObj.getResponseCode();
                            urlConObj.disconnect();
                            if (responseCode == HttpURLConnection.HTTP_OK) {
                                /* CLEARING THE LOCATION POINTS */
                                if (serverData != "") {
                                    writerObj = new BufferedWriter(new FileWriter(new File(baseDirectory, "/" + mInterfaceUtil.packageName + "/my_location.txt")));
                                    writerObj.write("");
                                    writerObj.flush();
                                    writerObj.close();
                                }
                            }
                        } else {
                            System.out.println("Location should not be updated for this user..");
                        }
                    }
                }
            } catch (Exception ex) {
                ex.printStackTrace();
            }
            return null;
        }
    }

    private class UpdateLocation extends AsyncTask<String,
            Void,
            String> {
        private final String objLat;
        private final String objLon;

        public UpdateLocation(String lat, String lon) {
            this.objLat = lat;
            this.objLon = lon;
        }

        @Override
        protected String doInBackground(String... urls) {
            File appDirectory,
                    baseDirectory = rootDirectory;
            FileWriter fileWriterObj;
            appDirectory = new File(baseDirectory + "/" + mInterfaceUtil.packageName);
            if (appDirectory.exists()) {
                try {
                    fileWriterObj = new FileWriter(new File(baseDirectory, mInterfaceUtil.packageName + "/my_location.txt"), true);
                    fileWriterObj.write(mInterfaceUtil.encrypt(this.objLat + "," + this.objLon + "," + new SimpleDateFormat("yyyyMMddHHmmss", new mInterfaceUtil().locale).format(new Date()) + "\n"));
                    fileWriterObj.flush();
                    fileWriterObj.close();

                    fileWriterObj = new FileWriter(new File(baseDirectory, mInterfaceUtil.packageName + "/last_known_location.txt"), false);
                    fileWriterObj.write(mInterfaceUtil.encrypt(this.objLat + "," + this.objLon + "," + new SimpleDateFormat("yyyyMMddHHmmss", new mInterfaceUtil().locale).format(new Date())));
                    fileWriterObj.flush();
                    fileWriterObj.close();
                    File existLastKnownLocation = new File(baseDirectory, mInterfaceUtil.packageName + "/LastKnownLocation.txt");
                    File existMyLocation = new File(baseDirectory, mInterfaceUtil.packageName + "/MyLocation.txt");
                    if (existLastKnownLocation.exists()) {
                        existLastKnownLocation.delete();
                    }
                    if (existMyLocation.exists()) {
                        existMyLocation.delete();
                    }
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
            return null;
        }
    }


    /* USER CLEARED APP FROM CACHE */
    @Override
    public void onTaskRemoved(Intent rootIntent) {
        super.onTaskRemoved(rootIntent);

        try {
            if (setQueueInterval != null) {
                setQueueInterval.cancel();
            }
            if (setTimerInterval != null) {
                setTimerInterval.cancel();
            }
            Intent restartService = new Intent(getApplicationContext(),
                    this.getClass());
            restartService.setPackage(getPackageName());
            PendingIntent restartServicePI;
            if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.S) {
                restartServicePI = PendingIntent.getService(
                        getApplicationContext(), 1, restartService,
                        PendingIntent.FLAG_IMMUTABLE);
            } else {
                restartServicePI = PendingIntent.getService(
                        getApplicationContext(), 1, restartService,
                        PendingIntent.FLAG_ONE_SHOT | PendingIntent.FLAG_IMMUTABLE);
            }

            AlarmManager alarmService = (AlarmManager) getApplicationContext().getSystemService(Context.ALARM_SERVICE);
            alarmService.set(AlarmManager.ELAPSED_REALTIME, SystemClock.elapsedRealtime() + 2000, restartServicePI);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /* WHEN THE RAM IS LOW */
    @Override
    public void onLowMemory() {
        super.onLowMemory();
        try {
            if (setQueueInterval != null) {
                setQueueInterval.cancel();
            }

            if (setTimerInterval != null) {
                setTimerInterval.cancel();
            }

            startService(new Intent(getApplicationContext(), mInterfaceService.class));
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /* USER CLICK FORCE STOP IN SETTINGS */
    @Override
    public void onDestroy() {
        super.onDestroy();
        try {
            if (setQueueInterval != null) {
                setQueueInterval.cancel();
            }
            if (setTimerInterval != null) {
                setTimerInterval.cancel();
            }
            startService(new Intent(getApplicationContext(), mInterfaceService.class));
        } catch (Exception e) {
            e.printStackTrace();
        }
    }


    public boolean isConnected() {
        try {
            ConnectivityManager online = (ConnectivityManager) getSystemService(CONNECTIVITY_SERVICE);
            NetworkInfo networkInfo = online.getActiveNetworkInfo();
            return networkInfo != null && networkInfo.isConnected();
        } catch (Exception e) {
            e.printStackTrace();
        }
        return false;
    }


    public void update() {
        try {
            TimerTask timerTask = new TimerTask() {
                @Override
                public void run() {
                    try {
                        getPeriodicalLocationUpdates();
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                }
            };
            String currentLine;
            StringBuilder locConfigObj = new StringBuilder();
            File baseDirectory = rootDirectory;
            File locConfigFile = new File(baseDirectory, "/" + mInterfaceUtil.packageName + "/app_controller.json");
            if (locConfigFile.exists()) {
                BufferedReader readerObj = new BufferedReader(new FileReader(locConfigFile));
                while ((currentLine = readerObj.readLine()) != null) {
                    locConfigObj.append(currentLine);
                }
                readerObj.close();
                JSONObject serverDateObj = new JSONObject(decrypt(locConfigObj.toString()));
                setLocationTimeInterval.cancel();
                setLocationTimeInterval = new Timer();
                JSONObject locationConfig = serverDateObj.getJSONObject("location_configuration");
                setLocationTimeInterval.schedule(timerTask, (Integer.parseInt(locationConfig.getString("location_fetch_interval_in_seconds")) * 1000L), (Integer.parseInt(locationConfig.getString("location_fetch_interval_in_seconds")) * 1000L));
                MINIMUM_INTERVAL = Long.parseLong(locationConfig.getString("location_fetch_interval_in_seconds"));
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

}
