package com.selfservit.util;

import static com.selfservit.util.mInterface.pathComponent;

import android.annotation.TargetApi;
import android.app.Activity;
import android.content.Context;
import android.content.SharedPreferences;
import android.database.Cursor;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.location.LocationListener;
import android.location.LocationManager;
import android.media.MediaMetadataRetriever;
import android.media.MediaScannerConnection;
import android.media.ThumbnailUtils;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.Build;
import android.provider.MediaStore;
import android.util.Base64;
import android.util.Log;

import org.apache.cordova.CallbackContext;
import org.apache.cordova.PluginResult;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.ByteArrayOutputStream;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.FilenameFilter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.URL;
import java.nio.charset.StandardCharsets;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.Locale;
import java.util.Scanner;
import java.util.zip.ZipEntry;
import java.util.zip.ZipInputStream;

import javax.crypto.Cipher;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;

public class mInterfaceUtil {

    LocationManager locationManager;
    LocationListener locationListener;
    public static String packageName = "";
    public static File rootDirectory;
    public static final Locale locale = Locale.US;
    private static final String encryptionKey = "8080808080808080";
    private static final String characterEncoding = "UTF-8";
    private static final String cipherTransformation = "AES/CBC/PKCS5PADDING";
    private static final String aesEncryptionAlgorithem = "AES";
    //Account information
    public static String app_id = "";
    public static String platform = "";
    public static String store = "";
    public static String sessionID = "";
    public static String localeID = "";
    public static String clientID = "";
    public static String countryCode = "";
    public static String userID = "";
    public static String employeeId = "";
    public static String cvsUrl = "";
    public static String clientUrl = "";
    public static String deviceID = "";
    public static String timerInd = "";

    private static final String PREFS_NAME = "app_prefs";
    private static final String KEY_FIRST_LAUNCH = "first_launch";

    public static String decrypt(String encryptedText) {
        String decryptedText = "";
        try {
            Cipher cipher = Cipher.getInstance(cipherTransformation);
            byte[] key = encryptionKey.getBytes(characterEncoding);
            SecretKeySpec secretKey = new SecretKeySpec(key, aesEncryptionAlgorithem);
            IvParameterSpec ivparameterspec = new IvParameterSpec(key);
            cipher.init(Cipher.DECRYPT_MODE, secretKey, ivparameterspec);
            byte[] cipherText = android.util.Base64.decode(encryptedText, 0);
            decryptedText = new String(cipher.doFinal(cipherText), StandardCharsets.UTF_8);
        } catch (Exception E) {
            System.out.println("decrypt Exception : " + E.getMessage());
        }
        return decryptedText;
    }

    public void DownloadChatAttachment(String requestURL, String filePath, String thumbnailInd, Context context, CallbackContext callbackContext, Activity activity) {
        try {
            class DownloadFile extends AsyncTask<String, String, String> {
                @Override
                protected void onPreExecute() {
                }

                @Override
                protected String doInBackground(String... args) {
                    BufferedInputStream input = null;
                    OutputStream output = null;
                    HttpURLConnection connection = null;
                    int count;
                    int progressCheck = 10;
                    try {
                        URL url = new URL((requestURL).replaceAll(" ", "%20"));
                        connection = (HttpURLConnection) url.openConnection();
                        connection.setRequestProperty("Connection", "Keep-Alive");
                        connection.connect();
                        if (connection.getResponseCode() != HttpURLConnection.HTTP_OK) {
                            return "Server returned HTTP " + connection.getResponseCode() + " " + connection.getResponseMessage();
                        }
                        int fileLength = connection.getContentLength();
                        input = new BufferedInputStream(connection.getInputStream(), 8192);
                        String rootPath = context.getExternalMediaDirs()[0].toString();
                        File filesourceDirecory = new File(rootPath + "/" + pathComponent(filePath));
                        if (!filesourceDirecory.exists()) {
                            filesourceDirecory.mkdirs();
                        }
                        File fileSavePath = new File(rootPath + "/" + filePath);
                        output = new FileOutputStream(fileSavePath);
                        byte[] data = new byte[1024];
                        long progress = 0;
                        int progressToSend = 0;
                        while ((count = input.read(data)) != -1) {
                            // allow canceling with back button
                            if (isCancelled()) {
                                input.close();
                                return null;
                            }
                            progress += count;
                            progressToSend = (int) ((progress * 100) / fileLength);

                            if (progressToSend >= progressCheck) {
                                JSONObject progressObj = new JSONObject();
                                progressObj.put("progress", progressCheck);
                                progressObj.put("fileLength", fileLength);
                                PluginResult pluginResult = new PluginResult(PluginResult.Status.OK, progressObj);
                                pluginResult.setKeepCallback(true);
                                callbackContext.sendPluginResult(pluginResult);
                                progressCheck = progressCheck + 10;
                            }

                            output.write(data, 0, count);
                        }
                    } catch (Exception e) {
                        callbackContext.error("DownloadChatAttachment failed, Exception is : " + e.getMessage());
                    }
                    if (thumbnailInd.equalsIgnoreCase("true")) {
                        return filePath;
                    } else {
                        return null;
                    }
                }

                public void onPostExecute(String result) {
                    try {
                        MediaScannerConnection.scanFile(context,
                                new String[]{context.getExternalMediaDirs()[0].toString()},
                                null,
                                (path, uri) -> {
                                    Log.i("ExternalStorage", "Scanned " + path + ":");
                                    Log.i("ExternalStorage", "-> uri=" + uri);
                                });
                        if (result != null) {
                            if (result.indexOf('.') != -1) {
                                String extension = "." + result.substring(result.lastIndexOf(".") + 1).toLowerCase(),
                                        filePath = context.getExternalMediaDirs()[0].toString() + "/" + result;
                                String thumbnail = getFileThumbnail(filePath, extension, context);
                                callbackContext.success(thumbnail);
                            } else {
                                callbackContext.error("DownloadChatAttachment: Failure");
                            }
                        } else {
                            callbackContext.success("success");
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                }
            }
            new DownloadFile().execute();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static String encrypt(String plainText) {
        String encryptedText = "";
        try {
            Cipher cipher = Cipher.getInstance(cipherTransformation);
            byte[] key = encryptionKey.getBytes(characterEncoding);
            SecretKeySpec secretKey = new SecretKeySpec(key, aesEncryptionAlgorithem);
            IvParameterSpec ivparameterspec = new IvParameterSpec(key);
            cipher.init(Cipher.ENCRYPT_MODE, secretKey, ivparameterspec);
            byte[] cipherText = android.util.Base64.encode(cipher.doFinal(plainText.getBytes(StandardCharsets.UTF_8)), 0);
            encryptedText = new String(cipherText);
        } catch (Exception E) {
            System.out.println("Failed to decrypt: Exception : " + E.getMessage());
        }
        return encryptedText;
    }

    /*FOR GETTING CURRENT LOCATION */
    public String getLocation(Context context) {
        String latitude = "",
                longitude = "";

        String currentLine, lastKnownLocation = "";
        File locationFile;
        try {
            locationFile = new File(rootDirectory, "/" + mInterfaceUtil.packageName + "/last_known_location.txt");
            if (locationFile.exists() && !locationFile.isDirectory()) {
                BufferedReader readerObj = new BufferedReader(new FileReader(locationFile));
                while ((currentLine = readerObj.readLine()) != null) {
                    lastKnownLocation = currentLine;
                }
                readerObj.close();
                String encryptedLocation = decrypt(lastKnownLocation);
                String[] splitStr = encryptedLocation.split(",");
                latitude = splitStr[0];
                longitude = splitStr[1];
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        //*** SUBSTRING LATITUDE,LONGITUDE IF GREATER THAN 10 POINTS ***//
        if (latitude.length() > 10) {
            latitude = latitude.substring(0, 10);
        }
        if (longitude.length() > 10) {
            longitude = longitude.substring(0, 10);
        }
        //*** RETURN LATITUDE,LONGITUDE VALUE IN JSON OBJECT FORMAT ***//
        return "{\"lat\":" + "\"" + latitude + "\"" + ",\"lon\":" + "\"" + longitude + "\"}";
    }

    /*FOR CHECK LOCATION SERVICE SETTING IS ENABLED OR NOT */
    public String checkLocation(Context context) {
        Boolean isEnabled = false;

        //*** REGISTER THE LOCATION MANAGER *** //
        locationManager = (LocationManager) context.getSystemService(Context.LOCATION_SERVICE);
        //*** CHECK LOCATION SETTING ENABLED OR NOT ***//
        isEnabled = locationManager.isProviderEnabled(LocationManager.GPS_PROVIDER);

        if (!isEnabled) {
            isEnabled = locationManager.isProviderEnabled(LocationManager.NETWORK_PROVIDER);
        }

        return String.valueOf(isEnabled);
    }

    /*FOR CHECK QUEUE IS PROCESSING OR NOT */
    public String getSyncIndicator(Context context) {
        File queueFile, queueFolder;
        Boolean syncIndication = false;
        try {
            queueFile = new File(rootDirectory + "/" + mInterfaceUtil.packageName + "/database/queue_mgr_encrypted.txt");
            queueFolder = new File(rootDirectory + "/" + mInterfaceUtil.packageName + "/database/queue");
            if (queueFile.exists()) {
                if (queueFile.length() == 0) {
                    syncIndication = true;
                }
            } else {
                syncIndication = true;
            }
            if (syncIndication) {
                if (queueFolder.exists()) {
                    if (queueFolder.listFiles().length != 0) {
                        syncIndication = false;
                    }
                }
            }
            return String.valueOf(syncIndication);
        } catch (Exception e) {
            return String.valueOf(e);
        }

    }

    public void deleteMultipleFiles(String str, CallbackContext callbackContext) {
        File baseDirectory = rootDirectory;
        try {
            File filePath = new File(baseDirectory + "/" + str);
            if (filePath.exists()) {
                filePath.delete();
            } else {
                callbackContext.error("No file available & File not deleted for " + str);
            }
        } catch (Exception e) {
            callbackContext.error("deleteMultipleFiles failed: Exception is : " + e.getMessage());
        }
    }

    public void copyConfigFile(CallbackContext callbackContext, JSONArray arguments) {
        JSONObject inputFileObj;
        String srcFilePath,
                srcFileName,
                desFilePath,
                desFileName;
        InputStream srcFileReader;
        OutputStream desFileWriter;
        int srcFileSize;
        byte[] buf;
        File sourceFileObj, desFileObj;
        String aa = "aaaa";
        try {
            for (int index = 0; index < arguments.length(); index++) {
                inputFileObj = arguments.getJSONObject(index);
                File rootDir = rootDirectory;
                srcFilePath = rootDir + "/" + inputFileObj.optString("srcPath");
                srcFileName = inputFileObj.optString("srcFile");
                desFilePath = rootDir + "/" + inputFileObj.optString("desPath");
                desFileName = inputFileObj.optString("desFile");
                sourceFileObj = new File(srcFilePath + "/" + srcFileName);
                desFileObj = new File(desFilePath + "/" + desFileName);
                //** CHECK DESTINATION FILE PATH EXITS OR NOT **//
                if (!new File(desFilePath).exists()) {
                    new File(desFilePath).mkdirs();
                }
                //** CHECK SOURCE FILE EXITS OR NOT **//
                if (sourceFileObj.exists()) {
                    srcFileReader = new FileInputStream(sourceFileObj);
                    desFileWriter = new FileOutputStream(desFileObj);
                    buf = new byte[1024];
                    //** WRITE SOURCE FILE INTO CONTENT_STORE DESTINATION PATH **//
                    while ((srcFileSize = srcFileReader.read(buf)) > 0) {
                        desFileWriter.write(buf, 0, srcFileSize);
                    }
                    srcFileReader.close();
                    desFileWriter.close();
                } else {
                    callbackContext.error("failure");
                }
            }
            callbackContext.success("success");
        } catch (Exception e) {
            callbackContext.error("copyConfigFile failed, Exception is" + e.getMessage());
        }
    }

    /* COPY A FILE FROM ONE LOCATION TO ANOTHER LOCATION */
    public void copyFile(CallbackContext callbackContext, JSONArray arguments) {
        JSONObject inputFileObj;
        String srcFilePath,
                srcFileName,
                desFilePath,
                desFileName;
        InputStream srcFileReader;
        OutputStream desFileWriter;
        int srcFileSize;
        byte[] buf;
        File sourceFileObj, desFileObj;
        try {
            for (int index = 0; index < arguments.length(); index++) {
                inputFileObj = arguments.getJSONObject(index);
                srcFilePath = rootDirectory + "/" + inputFileObj.optString("sourceFilePath");
                srcFileName = inputFileObj.optString("sourceFileName");
                desFilePath = rootDirectory + "/" + inputFileObj.optString("targetFilePath");
                desFileName = inputFileObj.optString("targetFileName");
                sourceFileObj = new File(srcFilePath + "/" + srcFileName);
                desFileObj = new File(desFilePath + "/" + desFileName);
                //** CHECK DESTINATION FILE PATH EXITS OR NOT **//
                if (!new File(desFilePath).exists()) {
                    new File(desFilePath).mkdirs();
                }
                //** CHECK SOURCE FILE EXITS OR NOT **//
                if (sourceFileObj.exists()) {
                    srcFileReader = new FileInputStream(sourceFileObj);
                    desFileWriter = new FileOutputStream(desFileObj);
                    buf = new byte[1024];
                    //** WRITE SOURCE FILE INTO CONTENT_STORE DESTINATION PATH **//
                    while ((srcFileSize = srcFileReader.read(buf)) > 0) {
                        desFileWriter.write(buf, 0, srcFileSize);
                    }
                    srcFileReader.close();
                    desFileWriter.close();
                } else {
                    callbackContext.error("File not exists");
                }
            }
            callbackContext.success("success");
        } catch (Exception e) {
            callbackContext.error("copyFile failed exception is : " + e.getMessage());
        }
    }

    /* COPY A FILE FROM ONE LOCATION TO ANOTHER LOCATION */
    public void copyAttachmentFile(CallbackContext callbackContext, JSONArray arguments) {
        JSONObject inputFileObj;
        String srcFilePath,
                srcFileName,
                desFilePath,
                desFileName,
                queueCopyPath,
                queueCopyFileName;
        InputStream srcFileReader;
        OutputStream desFileWriter, queueFileWriter;
        int srcFileSize;
        byte[] buf;
        File sourceFileObj, desFileObj, queueFileObj;
        try {
            for (int index = 0; index < arguments.length(); index++) {
                inputFileObj = arguments.getJSONObject(index);
                srcFilePath = inputFileObj.optString("srcPath");
                srcFileName = inputFileObj.optString("srcFile");
                desFilePath = rootDirectory + "/" + inputFileObj.optString("desPath");
                desFileName = inputFileObj.optString("desFile");
                queueCopyPath = rootDirectory + "/" + inputFileObj.optString("queueAttachPath");
                queueCopyFileName = inputFileObj.optString("queueAttachFile");
                sourceFileObj = new File(srcFilePath + "/" + srcFileName);
                desFileObj = new File(desFilePath + "/" + desFileName);
                queueFileObj = new File(queueCopyPath + "/" + queueCopyFileName);
                //** CHECK DESTINATION FILE PATH EXITS OR NOT **//
                if (!new File(desFilePath).exists()) {
                    new File(desFilePath).mkdirs();
                }
                if (!new File(queueCopyPath).exists()) {
                    new File(queueCopyPath).mkdirs();
                }
                //** CHECK SOURCE FILE EXITS OR NOT **//
                if (sourceFileObj.exists()) {
                    srcFileReader = new FileInputStream(sourceFileObj);
                    desFileWriter = new FileOutputStream(desFileObj);
                    buf = new byte[1024];
                    //** WRITE SOURCE FILE INTO CONTENT_STORE DESTINATION PATH **//
                    while ((srcFileSize = srcFileReader.read(buf)) > 0) {
                        desFileWriter.write(buf, 0, srcFileSize);
                    }
                    srcFileReader.close();
                    desFileWriter.close();

                    srcFileReader = new FileInputStream(sourceFileObj);
                    queueFileWriter = new FileOutputStream(queueFileObj);
                    buf = new byte[1024];
                    //** WRITE SOURCE FILE INTO QUEUE DESTINATION PATH **//
                    while ((srcFileSize = srcFileReader.read(buf)) > 0) {
                        queueFileWriter.write(buf, 0, srcFileSize);
                    }
                    srcFileReader.close();
                    queueFileWriter.close();
                } else {
                    callbackContext.error("failure");
                }
            }
            deleteFilesFromDirectory();
            callbackContext.success("success");
        } catch (Exception e) {
            callbackContext.error("copyAttachmentFile failed, exception is : " + e.getMessage());
        }
    }

    /* Move A FILE FROM ONE LOCATION TO ANOTHER LOCATION */
    public void moveFile(CallbackContext callbackContext, JSONArray arguments) {
        JSONObject inputFileObj;
        String srcFilePath,
                srcFileName,
                desFilePath,
                desFileName;
        InputStream srcFileReader;
        OutputStream desFileWriter;
        int srcFileSize;
        byte[] buf;
        File sourceFile, desFile;
        try {
            for (int index = 0; index < arguments.length(); index++) {
                inputFileObj = arguments.getJSONObject(index);
                srcFilePath = rootDirectory + "/" + inputFileObj.optString("sourceFilePath");
                srcFileName = inputFileObj.optString("sourceFileName");
                desFilePath = rootDirectory + "/" + inputFileObj.optString("targetFilePath");
                desFileName = inputFileObj.optString("targetFileName");
                sourceFile = new File(srcFilePath + "/" + srcFileName);
                desFile = new File(desFilePath + "/" + desFileName);
                //** CHECK DESTINATION FILE PATH EXITS OR NOT **//
                if (!new File(desFilePath).exists()) {
                    new File(desFilePath).mkdirs();
                }
                //** CHECK SOURCE FILE EXITS OR NOT **//
                if (sourceFile.exists()) {
                    srcFileReader = new FileInputStream(sourceFile);
                    desFileWriter = new FileOutputStream(desFile);
                    buf = new byte[1024];
                    //** WRITE SOURCE FILE INTO CONTENT_STORE DESTINATION PATH **//
                    while ((srcFileSize = srcFileReader.read(buf)) > 0) {
                        desFileWriter.write(buf, 0, srcFileSize);
                    }
                    srcFileReader.close();
                    desFileWriter.close();
                    /* Delete the source file */
                    sourceFile.delete();
                } else {
                    callbackContext.error("File not exists");
                }
            }
            callbackContext.success("success");
        } catch (Exception e) {
            callbackContext.error("Move File failed, exception is : " + e.getMessage());
        }
    }

    public void copyFileOld(CallbackContext callbackContext, JSONArray arguments) {
        JSONObject inputFileObj;
        String srcFilePath,
                srcFileName,
                desFilePath,
                desFileName,
                queueCopyPath,
                queueCopyFileName;
        InputStream srcFileReader;
        OutputStream desFileWriter, queueFileWriter;
        int srcFileSize;
        byte[] buf;
        File sourceFileObj, desFileObj, queueFileObj;
        try {
            for (int index = 0; index < arguments.length(); index++) {
                inputFileObj = arguments.getJSONObject(index);
                srcFilePath = inputFileObj.optString("srcPath");
                srcFileName = inputFileObj.optString("srcFile");
                desFilePath = rootDirectory + "/" + inputFileObj.optString("desPath");
                desFileName = inputFileObj.optString("desFile");
                queueCopyPath = rootDirectory + "/" + inputFileObj.optString("queueAttachPath");
                queueCopyFileName = inputFileObj.optString("queueAttachFile");
                sourceFileObj = new File(srcFilePath + "/" + srcFileName);
                desFileObj = new File(desFilePath + "/" + desFileName);
                queueFileObj = new File(queueCopyPath + "/" + queueCopyFileName);
                //** CHECK DESTINATION FILE PATH EXITS OR NOT **//
                if (!new File(desFilePath).exists()) {
                    new File(desFilePath).mkdirs();
                }
                if (!new File(queueCopyPath).exists()) {
                    new File(queueCopyPath).mkdirs();
                }
                //** CHECK SOURCE FILE EXITS OR NOT **//
                if (sourceFileObj.exists()) {
                    srcFileReader = new FileInputStream(sourceFileObj);
                    desFileWriter = new FileOutputStream(desFileObj);
                    buf = new byte[1024];
                    //** WRITE SOURCE FILE INTO CONTENT_STORE DESTINATION PATH **//
                    while ((srcFileSize = srcFileReader.read(buf)) > 0) {
                        desFileWriter.write(buf, 0, srcFileSize);
                    }
                    srcFileReader.close();
                    desFileWriter.close();

                    srcFileReader = new FileInputStream(sourceFileObj);
                    queueFileWriter = new FileOutputStream(queueFileObj);
                    buf = new byte[1024];
                    //** WRITE SOURCE FILE INTO QUEUE DESTINATION PATH **//
                    while ((srcFileSize = srcFileReader.read(buf)) > 0) {
                        queueFileWriter.write(buf, 0, srcFileSize);
                    }
                    srcFileReader.close();
                    queueFileWriter.close();
                } else {
                    callbackContext.error("failure");
                }
            }
            deleteFilesFromDirectory();
            callbackContext.success("success");
        } catch (Exception e) {
            callbackContext.error(e.getMessage());
        }
    }

    public void queueProcessor(CallbackContext callbackContext) {
        String statusIndication = "false";
        String breakIndication = "false";
        try {
            String clientID, countryCode, userID, clientUrl;
            BufferedReader myAccountsFileReader;
            StringBuilder myAccountsFileBuilder;
            ArrayList<JSONObject> accountsList;
            String currentLine;
            if (new File(rootDirectory, "/" + mInterfaceUtil.packageName + "/my_accounts").exists()) {
                accountsList = mInterface.getJsonDataFromFiles(new File(rootDirectory, "/" + mInterfaceUtil.packageName + "/my_accounts").getPath());
                for (JSONObject currentAccount : accountsList) {
                    clientID = currentAccount.optString("client_id");
                    countryCode = currentAccount.optString("country_code");
                    userID = currentAccount.optString("user_id");
                    clientUrl = currentAccount.optString("client_url");
                    File baseDirectory = rootDirectory;
                    File databaseDir = new File(baseDirectory + "/" + mInterfaceUtil.packageName + "/" + clientID + "/" + countryCode + "/database");
                    File processFileDir = new File(mInterfaceUtil.packageName + "/" + clientID + "/" + countryCode + "/database/process/");
                    if (databaseDir.exists()) {
                        String attachmentsPath = baseDirectory + "/" + mInterfaceUtil.packageName + "/" + clientID + "/" + countryCode + "/database/attachments";
                        String queuesPath = baseDirectory + "/" + mInterfaceUtil.packageName + "/" + clientID + "/" + countryCode + "/database/queue";
                        if (new File(attachmentsPath).exists()) {
                            File[] attachmentsFiles = new File(attachmentsPath).listFiles();
                            if (attachmentsFiles != null) {
                                for (int attachIndex = 0; attachIndex < attachmentsFiles.length; attachIndex++) {
                                    Arrays.sort(attachmentsFiles);
                                    if (attachmentsFiles[attachIndex].length() == 0) {
                                        breakIndication = "true";
                                        break;
                                    }
                                    String[] fileName = attachmentsFiles[attachIndex].toString().split("/");
                                    String attachURL = clientUrl + "/common/components/QueueManager/QueueUpload.aspx?file_path=attachments&client_id=" + clientID + "&country_code=" + countryCode + "&user_id=" + userID + "&file_name=" + fileName[fileName.length - 1];
                                    statusIndication = sendFilesToServer(attachmentsFiles[attachIndex].toString(), fileName[fileName.length - 1], attachURL);
                                    if (statusIndication.equals("true")) {
                                        breakIndication = "true";
                                        break;
                                    }
                                }
                            }
                        }
                        if (statusIndication.equals("false")) {
                            if (new File(queuesPath).exists()) {
                                File[] queueFiles = new File(queuesPath).listFiles();
                                if (queueFiles != null) {
                                    for (int queueIndex = 0; queueIndex < queueFiles.length; queueIndex++) {
                                        Arrays.sort(queueFiles);
                                        if (queueFiles[queueIndex].length() == 0) {
                                            breakIndication = "true";
                                            break;
                                        }
                                        String[] fileName = queueFiles[queueIndex].toString().split("/");
                                        String queueURL = clientUrl + "/common/components/QueueManager/QueueUpload.aspx?file_path=queue&client_id=" + clientID + "&country_code=" + countryCode + "&user_id=" + userID + "&file_name=" + fileName[fileName.length - 1];
                                        sendFilesToServer(queueFiles[queueIndex].toString(), fileName[fileName.length - 1], queueURL);
                                    }
                                }
                            }
                        }
                    } else {
                        System.out.println("No database directory");
                    }
                }
                if (breakIndication.equals("false")) {
                    callbackContext.success();
                } else {
                    callbackContext.error("failure");
                }
            } else {
                System.out.println("No my accounts file");
            }
        } catch (Exception e) {
            callbackContext.error(e.getMessage());
            System.out.println("Queue processor failed, exception is : " + e.getMessage());
        }
    }

    /*GETTING A FILEPATH OF API LEVEL 19 AND ABOVE */
    public static String getDataColumn(Context context, Uri uri, String selection, String[] selectionArgs) {
        Cursor cursor = null;
        final String column = "_data";
        final String[] projection = {
                column
        };

        try {
            cursor = context.getContentResolver().query(uri, projection, selection, selectionArgs, null);
            if (cursor != null && cursor.moveToFirst()) {
                final int column_index = cursor.getColumnIndexOrThrow(column);
                return cursor.getString(column_index);
            }
        } finally {
            if (cursor != null)
                cursor.close();
        }
        return null;
    }

    @TargetApi(Build.VERSION_CODES.KITKAT)
    public static String getPathToNonPrimaryVolume(Context context, String tag) {
        try {
            File[] volumes = context.getExternalCacheDirs();
            if (volumes != null) {
                for (File volume : volumes) {
                    if (volume != null) {
                        String path = volume.getAbsolutePath();
                        if (path != null) {
                            int index = path.indexOf(tag);
                            if (index != -1) {
                                return path.substring(0, index) + tag;
                            }
                        }

                    }
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }

    public String refreshTimeProfile(String date, String hour, String minute) {
        try {
            String serverResponseDate, deviceDate, serverDate;
            Date serverDateObj, todayDateobj;
            SimpleDateFormat serverDateformat, deviceDateFormat, serverDateString;
            BufferedWriter writerObj;
            serverResponseDate = date + " " + hour + ":" + minute + ":00";
            serverDateformat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss", locale);
            serverDateObj = serverDateformat.parse(serverResponseDate);
            serverDateString = new SimpleDateFormat("yyyy,MM,dd,HH,mm,ss", locale);
            serverDate = serverDateString.format(serverDateObj);
            deviceDateFormat = new SimpleDateFormat("yyyy,MM,dd,HH,mm,ss", locale);
            todayDateobj = new Date();
            deviceDate = deviceDateFormat.format(todayDateobj);
            JSONObject dateObj = new JSONObject();
            dateObj.put("serverDate", serverDate);
            dateObj.put("initServerDate", serverDate);
            dateObj.put("initDeviceDate", deviceDate);
            writerObj = new BufferedWriter(new FileWriter(new File(rootDirectory, "/" + mInterfaceUtil.packageName + "/time_profile_encrypted.txt")));
            writerObj.write(encrypt(dateObj.toString()));
            writerObj.flush();
            writerObj.close();
            return "true";
        } catch (Exception e) {
            return "false";
        }
    }

    public void getNewDate(CallbackContext callbackContext) {
        String currentLine;
        StringBuilder timeObj = new StringBuilder();
        try {
            Date mobileDate = new Date();
            File baseDirectory = rootDirectory;
            BufferedReader readerObj = new BufferedReader(new FileReader(new File(rootDirectory, "/" + mInterfaceUtil.packageName + "/time_profile_encrypted.txt")));
            while ((currentLine = readerObj.readLine()) != null) {
                timeObj.append(currentLine);
            }
            readerObj.close();
            JSONObject serverDateObj = new JSONObject(decrypt(timeObj.toString()));
            String serverTimeObj = serverDateObj.optString("serverDate");
            SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy,MM,dd,HH,mm,ss", locale);
            Date serverDate = simpleDateFormat.parse(serverTimeObj);
            long timeDiff = mobileDate.getTime() - serverDate.getTime();
            serverDate.setTime(serverDate.getTime() + timeDiff);
            SimpleDateFormat simpleDateFormat1 = new SimpleDateFormat("yyyy,MM,dd,HH,mm,ss", locale);
            String serverDate1 = simpleDateFormat1.format(serverDate);
            callbackContext.success(serverDate1);
        } catch (Exception e) {
            e.printStackTrace();
        }

    }

    public void logData(String fileName, String data) {
        File appDirectory;
        FileWriter fileWriterObj;
        try {
            /* CHECKING THE DIRECTORY EXISTS OR NOT AND CREATING THE DIRECTORY */
            appDirectory = new File(rootDirectory + "/" + fileName.substring(0, fileName.lastIndexOf("/")));
            if (!appDirectory.exists()) {
                appDirectory.mkdirs();
            }
            /* WRITING THE DATA TO THE FILE */
            fileWriterObj = new FileWriter(new File(appDirectory, fileName.substring(fileName.lastIndexOf("/") + 1)), true);
            fileWriterObj.write(data);
            fileWriterObj.flush();
            fileWriterObj.close();

        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void deleteFilesFromDirectory() {
        try {
            File dir = new File(rootDirectory + "/" + mInterfaceUtil.packageName + "/" + "images");
            if (dir.isDirectory()) {
                if (dir.exists()) {
                    String[] children = dir.list();
                    for (int i = 0; i < children.length; i++) {
                        new File(dir, children[i]).delete();
                    }
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public String convertBitmapToString(Bitmap bitmap) {
        try {
            ByteArrayOutputStream outputStream = new ByteArrayOutputStream();
            bitmap.compress(Bitmap.CompressFormat.JPEG, 100, outputStream);
            return Base64.encodeToString(outputStream.toByteArray(), Base64.NO_WRAP);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return "";
    }

    public String getFileThumbnail(String filePath, String extension, Context context) {
        Bitmap thumb;
        String imgString = "";
        try {
            if (extension.equalsIgnoreCase(".mp4")) {
                thumb = ThumbnailUtils.createVideoThumbnail(filePath,
                        MediaStore.Images.Thumbnails.MINI_KIND);
                imgString = convertBitmapToString(thumb);
            } else if (extension.equalsIgnoreCase(".heic") || extension.equalsIgnoreCase(".jpeg") || extension.equalsIgnoreCase(".jpg") || extension.equalsIgnoreCase(".png")) {
                thumb = ThumbnailUtils.extractThumbnail(BitmapFactory.decodeFile(filePath),
                        76, 76);

                imgString = convertBitmapToString(thumb);
            } else if (extension.equalsIgnoreCase(".mp3")) {
                MediaMetadataRetriever mmr = new MediaMetadataRetriever();
                byte[] bytes;
                BitmapFactory.Options bfo = new BitmapFactory.Options();

                mmr.setDataSource(context, Uri.fromFile(new File(filePath)));
                bytes = mmr.getEmbeddedPicture();
                if (bytes != null) {
                    thumb = BitmapFactory.decodeByteArray(bytes, 0, bytes.length, bfo);
                    imgString = convertBitmapToString(thumb);
                }
            }
        } catch (Exception e) {

        }
        return imgString;
    }

    public void sendChatAttachment(String filePath, String fileName, String requestURL, Context context, CallbackContext callbackContext) {
        try {
            class SendFile extends AsyncTask<String, String, String> {
                @Override
                protected void onPreExecute() {
                }

                @Override
                protected String doInBackground(String... args) {
                    FileInputStream fileInputStream;
                    HttpURLConnection urlConObj;
                    URL requestPath;
                    int bytesAvailable,
                            bufferSize;
                    int maxBufferSize = 1 * 1024 * 1024;
                    DataOutputStream dos;
                    String lineEnd = "\r\n";
                    String twoHyphens = "--";
                    String boundary = "*****";
                    StringBuilder serverResponseObj;
                    BufferedReader readerObj;
                    String currentLine,
                            receiveData = "", statusIndication = null;
                    int progressCheck = 10;
                    try {
                        if (new File(filePath).exists()) {
                            if (new File(filePath).exists()) {
                                fileInputStream = new FileInputStream(new File(filePath));

                                requestPath = new URL((requestURL).replaceAll(" ", "%20"));
                                urlConObj = (HttpURLConnection) requestPath.openConnection();
                                urlConObj.setDoInput(true); // Allow Inputs
                                urlConObj.setDoOutput(true); // Allow Outputs
                                urlConObj.setUseCaches(false); // Don't use a Cached Copy
                                urlConObj.setRequestMethod("POST");
                                urlConObj.setRequestProperty("Connection", "Keep-Alive");
                                urlConObj.setRequestProperty("ENCTYPE", "multipart/form-data");
                                urlConObj.setRequestProperty("Content-Type", "multipart/form-data;boundary=" + boundary);
                                urlConObj.setRequestProperty("uploaded_file", fileName);

                                dos = new DataOutputStream(urlConObj.getOutputStream());
                                dos.writeBytes(twoHyphens + boundary + lineEnd);
                                dos.writeBytes("Content-Disposition: form-data; name=\"uploaded_file\";filename=\""
                                        + fileName + "\"" + lineEnd);
                                dos.writeBytes(lineEnd);
                                // create a buffer of  maximum size
                                bytesAvailable = fileInputStream.available();

                                bufferSize = Math.min(bytesAvailable, maxBufferSize);

                                int progress = 0;
                                int progressToSend = 0;
                                int fileLength = (int) new File(filePath).length();
                                int bytesReadValue = 0;
                                byte[] buf = new byte[1024];
                                BufferedInputStream bufInput = new BufferedInputStream(new FileInputStream(new File(filePath)));
                                while ((bytesReadValue = bufInput.read(buf)) != -1) {
                                    // write output
                                    dos.write(buf, 0, bytesReadValue);
                                    progress += bytesReadValue;
                                    progressToSend = (int) ((progress * 100) / fileLength);

                                    if (progressToSend >= progressCheck) {
                                        JSONObject progressObj = new JSONObject();
                                        progressObj.put("progress", progressCheck);
                                        progressObj.put("fileLength", fileLength);
                                        PluginResult pluginResult = new PluginResult(PluginResult.Status.OK, progressObj);
                                        pluginResult.setKeepCallback(true);
                                        callbackContext.sendPluginResult(pluginResult);
                                        progressCheck = progressCheck + 10;
                                    }
                                }

                                // send multipart form data necesssary after file data...
                                dos.writeBytes(lineEnd);
                                dos.writeBytes(twoHyphens + boundary + twoHyphens + lineEnd);
                                urlConObj.getResponseCode();
                                //close the streams //
                                fileInputStream.close();
                                dos.flush();
                                dos.close();
                                readerObj = new BufferedReader(new InputStreamReader(urlConObj.getInputStream()));
                                currentLine = readerObj.readLine();
                                readerObj.close();
                                receiveData = currentLine;
                                urlConObj.disconnect();
                                JSONObject resultObj = new JSONObject(receiveData);
                                if (resultObj.getString("status").equalsIgnoreCase("success")) {
                                    statusIndication = "true";
                                } else {
                                    statusIndication = "false";
                                }
                                urlConObj.disconnect();
                            }
                        }

                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                    return statusIndication;

                }

                public void onPostExecute(String statusIndication) {
                    try {
                        if (statusIndication == null) {
                            callbackContext.error("failure");
                        } else {
                            if (statusIndication.equals("true")) {
                                callbackContext.success("success");
                            } else {
                                callbackContext.error("failure");
                            }
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                    }

                }
            }
            new SendFile().execute();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }


    public String sendAttachmentToServer(String filePath, String fileName, String requestURL) {
        String statusIndication = "false";
        try {
            FileInputStream fileInputStream;
            HttpURLConnection urlConObj;
            URL requestPath;
            int bytesRead,
                    bytesAvailable,
                    bufferSize;
            byte[] buffer;
            int maxBufferSize = 1 * 1024 * 1024;
            DataOutputStream dos;
            String lineEnd = "\r\n";
            String twoHyphens = "--";
            String boundary = "*****";
            StringBuilder serverResponseObj;
            BufferedReader readerObj;
            String currentLine,
                    receiveData = "";
            if (new File(filePath).exists()) {
                if (new File(filePath).exists()) {
                    fileInputStream = new FileInputStream(new File(filePath));
                    requestPath = new URL((requestURL).replaceAll(" ", "%20"));
                    urlConObj = (HttpURLConnection) requestPath.openConnection();
                    urlConObj.setDoInput(true); // Allow Inputs
                    urlConObj.setDoOutput(true); // Allow Outputs
                    urlConObj.setUseCaches(false); // Don't use a Cached Copy
                    urlConObj.setRequestMethod("POST");
                    urlConObj.setRequestProperty("Connection", "Keep-Alive");
                    urlConObj.setRequestProperty("ENCTYPE", "multipart/form-data");
                    urlConObj.setRequestProperty("Content-Type", "multipart/form-data;boundary=" + boundary);
                    urlConObj.setRequestProperty("uploaded_file", fileName);

                    dos = new DataOutputStream(urlConObj.getOutputStream());
                    dos.writeBytes(twoHyphens + boundary + lineEnd);
                    dos.writeBytes("Content-Disposition: form-data; name=\"uploaded_file\";filename=\""
                            + fileName + "\"" + lineEnd);
                    dos.writeBytes(lineEnd);
                    // create a buffer of  maximum size
                    bytesAvailable = fileInputStream.available();

                    bufferSize = Math.min(bytesAvailable, maxBufferSize);
                    buffer = new byte[bufferSize];

                    // read file and write it into form...
                    bytesRead = fileInputStream.read(buffer, 0, bufferSize);
                    while (bytesRead > 0) {
                        dos.write(buffer, 0, bufferSize);
                        bytesAvailable = fileInputStream.available();
                        bufferSize = Math.min(bytesAvailable, maxBufferSize);
                        bytesRead = fileInputStream.read(buffer, 0, bufferSize);

                    }
                    // send multipart form data necesssary after file data...
                    dos.writeBytes(lineEnd);
                    dos.writeBytes(twoHyphens + boundary + twoHyphens + lineEnd);
                    urlConObj.getResponseCode();
                    //close the streams //
                    fileInputStream.close();
                    dos.flush();
                    dos.close();
                    readerObj = new BufferedReader(new InputStreamReader(urlConObj.getInputStream()));
                    currentLine = readerObj.readLine();
                    readerObj.close();
                    receiveData = currentLine;
                    urlConObj.disconnect();
                    JSONObject resultObj = new JSONObject(receiveData);
                    if (resultObj.getString("status").equalsIgnoreCase("success")) {
                        statusIndication = "true";
                    } else {
                        statusIndication = "false";
                    }
                    urlConObj.disconnect();
                }
            }
        } catch (Exception e) {
            statusIndication = "true";
        }
        return statusIndication;
    }

    private void UpdateProgressBar(CallbackContext callbackContext, int progress) {
        try {
            PluginResult pluginResult = new PluginResult(PluginResult.Status.OK, progress);
            pluginResult.setKeepCallback(true); // keep callback
            callbackContext.sendPluginResult(pluginResult);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public String sendFilesToServer(String filePath, String fileName, String requestURL) {
        String statusIndication = "false";
        try {
            FileInputStream fileInputStream;
            HttpURLConnection urlConObj;
            URL requestPath;
            int bytesRead,
                    bytesAvailable,
                    bufferSize;
            byte[] buffer;
            int maxBufferSize = 1 * 1024 * 1024;
            DataOutputStream dos;
            String lineEnd = "\r\n";
            String twoHyphens = "--";
            String boundary = "*****";
            StringBuilder serverResponseObj;
            BufferedReader readerObj;
            String currentLine,
                    receiveData = "";
            if (new File(filePath).exists()) {
                if (new File(filePath).exists()) {
                    fileInputStream = new FileInputStream(new File(filePath));
                    requestPath = new URL((requestURL).replaceAll(" ", "%20"));
                    urlConObj = (HttpURLConnection) requestPath.openConnection();
                    urlConObj.setDoInput(true); // Allow Inputs
                    urlConObj.setDoOutput(true); // Allow Outputs
                    urlConObj.setUseCaches(false); // Don't use a Cached Copy
                    urlConObj.setRequestMethod("POST");
                    urlConObj.setRequestProperty("Connection", "Keep-Alive");
                    urlConObj.setRequestProperty("ENCTYPE", "multipart/form-data");
                    urlConObj.setRequestProperty("Content-Type", "multipart/form-data;boundary=" + boundary);
                    urlConObj.setRequestProperty("uploaded_file", fileName);

                    dos = new DataOutputStream(urlConObj.getOutputStream());
                    dos.writeBytes(twoHyphens + boundary + lineEnd);
                    dos.writeBytes("Content-Disposition: form-data; name=\"uploaded_file\";filename=\""
                            + fileName + "\"" + lineEnd);
                    dos.writeBytes(lineEnd);
                    // create a buffer of  maximum size
                    bytesAvailable = fileInputStream.available();

                    bufferSize = Math.min(bytesAvailable, maxBufferSize);
                    buffer = new byte[bufferSize];

                    // read file and write it into form...
                    bytesRead = fileInputStream.read(buffer, 0, bufferSize);
                    while (bytesRead > 0) {
                        dos.write(buffer, 0, bufferSize);
                        bytesAvailable = fileInputStream.available();
                        bufferSize = Math.min(bytesAvailable, maxBufferSize);
                        bytesRead = fileInputStream.read(buffer, 0, bufferSize);

                    }
                    // send multipart form data necesssary after file data...
                    dos.writeBytes(lineEnd);
                    dos.writeBytes(twoHyphens + boundary + twoHyphens + lineEnd);
                    urlConObj.getResponseCode();
                    //close the streams //
                    fileInputStream.close();
                    dos.flush();
                    dos.close();
                    readerObj = new BufferedReader(new InputStreamReader(urlConObj.getInputStream()));
                    currentLine = readerObj.readLine();
                    readerObj.close();
                    receiveData = currentLine;
                    urlConObj.disconnect();
                    if (receiveData.equals("true")) {
                        new File(filePath).delete();
                    } else {
                        statusIndication = "true";
                    }
                    urlConObj.disconnect();
                }
            }
        } catch (Exception e) {
            statusIndication = "true";
        }
        return statusIndication;
    }

    public void readFile(JSONArray args, CallbackContext callbackContext) throws IOException {
        String str = "";
        File baseDirectory = rootDirectory;
        try {
            File filePath = new File(baseDirectory + "/" + args.getJSONObject(0).optString("filePath"));
            if (filePath.exists()) {
                String content = new Scanner(filePath).useDelimiter("\\A").next();
                callbackContext.success(content);
            } else {
                callbackContext.error("There is no file at the given path. Path: " + filePath);
            }
        } catch (Exception e) {
            callbackContext.error("unable to readFile, Exception is: " + e.getMessage());
        }
    }

    public void deleteFile(JSONArray args, CallbackContext callbackContext) {
        File baseDirectory = rootDirectory;
        try {
            File filePath = new File(baseDirectory + "/" + args.getJSONObject(0).optString("filePath"));
            if (filePath.exists()) {
                filePath.delete();
                callbackContext.success();
            } else {
                callbackContext.error("File not deleted, Path: " + baseDirectory + "/" + args.getJSONObject(0).optString("filePath"));
            }
        } catch (Exception e) {
            callbackContext.error("delete file failed, exception is : " + e.getMessage());
        }
    }

    public void createFile(JSONArray args, CallbackContext callbackContext) {
        File appDirectory;
        FileWriter fileWriterObj;
        try {
            String fileName = args.getJSONObject(0).optString("filePath");
            String data = args.getJSONObject(0).optString("data");
            appDirectory = new File(rootDirectory + "/" + fileName.substring(0, fileName.lastIndexOf("/")));
            if (!appDirectory.exists()) {
                appDirectory.mkdirs();
            }
            /* WRITING THE DATA TO THE FILE */
            String bbbb = fileName.substring(fileName.lastIndexOf("/") + 1);
            fileWriterObj = new FileWriter(new File(appDirectory, fileName.substring(fileName.lastIndexOf("/") + 1)));
            fileWriterObj.write(data);
            fileWriterObj.flush();
            fileWriterObj.close();
            callbackContext.success();
        } catch (Exception e) {
            try {
                callbackContext.error("create File failed for path:" + args.getJSONObject(0).optString("filePath") + " , exception is : " + e.getMessage());
            } catch (JSONException ex) {
                e.printStackTrace();
            }
        }
    }

    public void validateFile(JSONArray args, CallbackContext callbackContext) {
        File baseDirectory = rootDirectory;
        try {
            File filePath = new File(baseDirectory + "/" + args.getJSONObject(0).optString("filePath"));
            boolean sss = filePath.exists();
            callbackContext.success(sss ? "true" : "false");
        } catch (Exception e) {
            try {
                callbackContext.error("validate file failed for path:" + baseDirectory + "/" + args.getJSONObject(0).optString("filePath") + " , exception is : " + e.getMessage());
            } catch (JSONException ex) {
                e.printStackTrace();
            }
        }
    }

    public void createDirectory(JSONArray args, CallbackContext callbackContext) {
        File appDirectory;
        FileWriter fileWriterObj;
        try {
            String fileName = args.getJSONObject(0).optString("filePath");
            appDirectory = new File(rootDirectory + "/" + fileName);
            if (!appDirectory.exists()) {
                appDirectory.mkdirs();
            }
            callbackContext.success();
        } catch (Exception e) {
            try {
                callbackContext.error("create directory failed for " + args.getJSONObject(0).optString("filePath") + ", exception is : " + e.getMessage());
            } catch (JSONException ex) {
                e.printStackTrace();
            }
        }
    }

    public void deleteDirectory(JSONArray args, CallbackContext callbackContext) {
        File appDirectory;
        FileWriter fileWriterObj;
        try {
            String fileName = args.getJSONObject(0).optString("filePath");
            if (fileName.equals("")) {
                callbackContext.error("deleteDirectory: Given directory path is empty. path: " + args.getJSONObject(0).optString("filePath"));
            } else {
                File dir = new File(rootDirectory + "/" + fileName);
                if (dir.exists()) {
                    deleteRecursive(dir);
                    callbackContext.success();
                } else {
                    callbackContext.error("deleteDirectory: File does not exists in " + args.getJSONObject(0).optString("filePath"));
                }

            }
        } catch (Exception e) {
            try {
                callbackContext.error("delete directory failed for " + args.getJSONObject(0).optString("filePath") + ", exception is : " + e.getMessage());
            } catch (JSONException ex) {
                throw new RuntimeException(ex);
            }
        }
    }

    public void deleteRecursive(File fileOrDirectory) {
        try {
            if (fileOrDirectory.isDirectory()) {
                for (File child : fileOrDirectory.listFiles()) {
                    System.out.println("Child directory path: " + child);
                    deleteRecursive(child);
                }
            }

            fileOrDirectory.delete();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private static final int BUFFER_SIZE = 6 * 1024;

    public static void unzip(String zipFile, String location, CallbackContext callbackContext) throws JSONException {
        try {
            File f = new File(location);
            if (!f.isDirectory()) {
                f.mkdirs();
            }
            ZipInputStream zin = new ZipInputStream(new FileInputStream(zipFile));
            try {
                ZipEntry ze = null;
                while ((ze = zin.getNextEntry()) != null) {
                    String path = location + File.separator + ze.getName();

                    if (ze.isDirectory()) {
                        File unzipFile = new File(path);
                        if (!unzipFile.isDirectory()) {
                            unzipFile.mkdirs();
                        }
                    } else {
                        FileOutputStream fout = new FileOutputStream(path, false);

                        try {
                            for (int c = zin.read(); c != -1; c = zin.read()) {
                                fout.write(c);
                            }
                            zin.closeEntry();
                        } finally {
                            fout.close();
                        }
                    }
                }
            } finally {
                zin.close();
            }
            callbackContext.success();
        } catch (Exception e) {
            e.printStackTrace();
            callbackContext.error("unzip failed, exception is : " + e.getMessage());
        }
    }

    public void getSubDirectoryList(JSONArray args, CallbackContext callbackContext) {
        try {
            String fileName = args.getJSONObject(0).optString("filePath");
            System.out.println("deleteFile Path is: " + fileName);
            if (fileName.equals("")) {
                callbackContext.error("Given directory path is empty.");
            } else {
                File dir = new File(rootDirectory + "/" + fileName);
                String[] subDirectories = dir.list(new FilenameFilter() {
                    @Override
                    public boolean accept(File current, String name) {
                        return new File(current, name).isDirectory();
                    }
                });
                StringBuilder fileNames = new StringBuilder();
                for (String subDirectory : subDirectories) {
                    fileNames.append(subDirectory);
                    fileNames.append("|");
                }
                callbackContext.success(fileNames.length() > 0 ? fileNames.substring(0, fileNames.length() - 1) : "");
            }
        } catch (Exception e) {
            try {
                callbackContext.error("getSubDirectoryList failed for " + args.getJSONObject(0).optString("filePath") + ", exception is : " + e.getMessage());
            } catch (JSONException ex) {
                e.printStackTrace();
            }
        }
    }

    public void getFileList(JSONArray args, CallbackContext callbackContext) {
        try {
            String fileName = args.getJSONObject(0).optString("filePath");
            System.out.println("deleteFile Path is: " + fileName);
            if (fileName.equals("")) {
                callbackContext.error("Given directory path is empty.");
            } else {
                File dir = new File(rootDirectory + "/" + fileName);
                String[] subDirectories = dir.list(new FilenameFilter() {
                    @Override
                    public boolean accept(File current, String name) {
                        return new File(current, name).isFile();
                    }
                });
                StringBuilder fileNames = new StringBuilder();
                for (String subDirectory : subDirectories) {
                    fileNames.append(subDirectory);
                    fileNames.append("|");
                }
                callbackContext.success(fileNames.length() > 0 ? fileNames.substring(0, fileNames.length() - 1) : "");
            }
        } catch (Exception e) {
            try {
                callbackContext.error("getFileList failed for " + args.getJSONObject(0).optString("filePath") + ", exception is : " + e.getMessage());
            } catch (JSONException ex) {
                e.printStackTrace();
            }
        }
    }

    public static void getAppStateInfo(CallbackContext callbackContext, Context applicationContext) {
        String currentLine;
        File appStateIndicatorFile;
        try {
            appStateIndicatorFile = new File(rootDirectory, "/" + mInterfaceUtil.packageName + "/" + clientID + "/" + countryCode + "/" + "app_state_info.txt");
            if (appStateIndicatorFile.exists()) {
                BufferedReader authFileReader = new BufferedReader(new FileReader(appStateIndicatorFile));
                StringBuilder authFileBuilder = new StringBuilder();
                while ((currentLine = authFileReader.readLine()) != null) {
                    authFileBuilder.append(currentLine);
                }
                authFileReader.close();
                JSONObject authFileObj = new JSONObject(decrypt(authFileBuilder.toString()));
                long lastModifiedTime = appStateIndicatorFile.lastModified();
                Date date = new Date();
                date.setTime(lastModifiedTime);
                String lastModifiedDate = new SimpleDateFormat("yyyyMMdd", new mInterfaceUtil().locale).format(date);

                if (authFileObj.optString("validDevice").equals("nostatus") || !lastModifiedDate.equals(new SimpleDateFormat("yyyyMMdd", new mInterfaceUtil().locale).format(new Date()))) {
                    if (isConnected(applicationContext)) {
                        downloadAppStateInfo(callbackContext);
                    } else {
                        callbackContext.success(authFileObj.toString());
                    }
                } else {
                    callbackContext.success(authFileObj.toString());
                }
            } else {
                if (isConnected(applicationContext)) {
                    downloadAppStateInfo(callbackContext);
                } else {
                    callbackContext.success("");
                }
            }
        } catch (Exception e) {
            System.out.println(e.getMessage());
            callbackContext.error("getAppStateInfo failed, exception is : " + e.getMessage());
        }
    }

    public static void downloadAppStateInfo(CallbackContext callbackContext) {
        URL requestAuthenticationPath,
                requestValidateDevicePath, getKeysPath;
        HttpURLConnection urlConObj;
        OutputStreamWriter oStreamObj;
        BufferedWriter writerObj;
        StringBuilder serverResponseObj;
        BufferedReader responseReaderObj;
        JSONObject responseDataObj;
        String currentLine;
        try {
            getKeysPath = new URL(clientUrl + "/" + "common/components/Keys/" + "RetrieveKey.aspx");
            urlConObj = (HttpURLConnection) getKeysPath.openConnection();
            urlConObj.setDoOutput(true);
            urlConObj.setRequestMethod("POST");
            urlConObj.setRequestProperty("CONTENT-TYPE", "application/json");
            urlConObj.connect();
            JSONObject jsonObject1 = new JSONObject();
            jsonObject1 = jsonObject1.put("client_id", clientID);
            jsonObject1 = jsonObject1.put("country_code", countryCode);
            jsonObject1 = jsonObject1.put("purposeCode", "mobile_address_store");
            jsonObject1 = jsonObject1.put("version", "doubleo");
            System.out.println("data format: " + jsonObject1);
            oStreamObj = new OutputStreamWriter(urlConObj.getOutputStream());
            oStreamObj.write(jsonObject1.toString());
            oStreamObj.flush();
            oStreamObj.close();
            serverResponseObj = new StringBuilder();
            responseReaderObj = new BufferedReader(new InputStreamReader(urlConObj.getInputStream()));
            while ((currentLine = responseReaderObj.readLine()) != null) {
                serverResponseObj.append(currentLine);
            }
            responseReaderObj.close();
            urlConObj.disconnect();

            BufferedReader reader = new BufferedReader(new FileReader(new File(rootDirectory, "/" + mInterfaceUtil.packageName + "/" + "my_accounts" + "/" + clientID + "_" + countryCode + ".json")));
            StringBuilder content = new StringBuilder();
            String line;
            while ((line = reader.readLine()) != null) {
                content.append(line);
            }
            reader.close();
            // Parse the existing data as JSON
            JSONObject existingData = new JSONObject(decrypt(content.toString()));
            existingData.put("keys", serverResponseObj.toString());
            writerObj = new BufferedWriter(new FileWriter(new File(rootDirectory, "/" + mInterfaceUtil.packageName + "/" + "my_accounts" + "/" + clientID + "_" + countryCode + ".json")));
            writerObj.write(encrypt(existingData.toString()));
            writerObj.flush();
            writerObj.close();
            /* App State info DATA REQUEST */
            requestAuthenticationPath = new URL(cvsUrl + "/" + "get_app_state_info.aspx");
            urlConObj = (HttpURLConnection) requestAuthenticationPath.openConnection();
            urlConObj.setDoOutput(true);
            urlConObj.setRequestMethod("POST");
            urlConObj.setRequestProperty("CONTENT-TYPE", "application/json");
            urlConObj.connect();

            oStreamObj = new OutputStreamWriter(urlConObj.getOutputStream());
            JSONObject reqJson_obj = new JSONObject();
            reqJson_obj.put("client_id", clientID);
            reqJson_obj.put("country_code", countryCode);
            reqJson_obj.put("app_id", app_id);
            reqJson_obj.put("platform", platform);
            reqJson_obj.put("store", store);
            oStreamObj.write(reqJson_obj.toString());
            oStreamObj.flush();
            oStreamObj.close();
            serverResponseObj = new StringBuilder();
            responseReaderObj = new BufferedReader(new InputStreamReader(urlConObj.getInputStream()));
            while ((currentLine = responseReaderObj.readLine()) != null) {
                serverResponseObj.append(currentLine);
            }
            responseReaderObj.close();
            urlConObj.disconnect();
            responseDataObj = new JSONObject(serverResponseObj.toString());

            /* VALIDATE DEVICE REQUEST */
            try {
                requestValidateDevicePath = new URL(clientUrl + "/api/security/validate_device");
                urlConObj = (HttpURLConnection) requestValidateDevicePath.openConnection();
                urlConObj.setDoOutput(true);
                urlConObj.setRequestMethod("POST");
                urlConObj.setRequestProperty("CONTENT-TYPE", "application/json");
                urlConObj.connect();
                oStreamObj = new OutputStreamWriter(urlConObj.getOutputStream());
                JSONObject inputJson_obj = new JSONObject();
                JSONObject context_obj = new JSONObject();
                JSONObject inputparam_obj = new JSONObject();

                inputparam_obj.put("p_device_id", deviceID);
                inputparam_obj.put("p_company_id", clientID);
                inputparam_obj.put("p_country_code", countryCode);
                context_obj.put("sessionId", sessionID);
                context_obj.put("userId", userID);
                context_obj.put("client_id", clientID);
                context_obj.put("locale_id", localeID);
                context_obj.put("country_code", countryCode);
                context_obj.put("inputparam", inputparam_obj);

                inputJson_obj.put("context", context_obj);
                oStreamObj.write(inputJson_obj.toString());
                oStreamObj.flush();
                oStreamObj.close();
                serverResponseObj = new StringBuilder();
                responseReaderObj = new BufferedReader(new InputStreamReader(urlConObj.getInputStream()));
                while ((currentLine = responseReaderObj.readLine()) != null) {
                    serverResponseObj.append(currentLine);
                }
                responseReaderObj.close();
                urlConObj.disconnect();
                String responseStr = serverResponseObj.toString().replace("\\", "");
                responseStr = responseStr.substring(1, responseStr.length() - 1);
                JSONObject resultJsonObj = new JSONObject(responseStr).getJSONObject("outputparam");
                responseDataObj = responseDataObj.put("validDevice", "true");
                /* RESPONSE FOR AUTHENTICATION & VALIDATE DEVICE REQUESTS */
                writerObj = new BufferedWriter(new FileWriter(new File(rootDirectory, "/" + packageName + "/" + clientID + "/" + countryCode + "/" + "app_state_info.txt")));
                writerObj.write(encrypt(responseDataObj.toString()));
                writerObj.flush();
                writerObj.close();
                callbackContext.success(responseDataObj.toString());

            } catch (Exception ex) {
                responseDataObj = responseDataObj.put("validDevice", "nostatus");
                writerObj = new BufferedWriter(new FileWriter(new File(rootDirectory, "/" + packageName + "/" + clientID + "/" + countryCode + "/" + "app_state_info.txt")));
                writerObj.write(encrypt(responseDataObj.toString()));
                writerObj.flush();
                writerObj.close();
                callbackContext.success(responseDataObj.toString());
            }
        } catch (Exception e) {
            System.out.println(e.getMessage());
            callbackContext.success("");
        }
    }

    public static void validateAppStateInfo(Context applicationContext) {

        String currentLine;
        try {
            if (new File(rootDirectory, "/" + mInterfaceUtil.packageName + "/my_accounts").exists()) {
                ArrayList<JSONObject> accountsList = mInterface.getJsonDataFromFiles(new File(rootDirectory, "/" + mInterfaceUtil.packageName + "/my_accounts").getPath());
                for (JSONObject currentAccount : accountsList) {
                    String clientID = currentAccount.optString("client_id");
                    String countryCode = currentAccount.optString("country_code");


                    File appStateIndicatorFile = new File(rootDirectory, "/" + mInterfaceUtil.packageName + "/" + clientID + "/" + countryCode + "/" + "app_state_info.txt");
                    if (appStateIndicatorFile.exists()) {
                        BufferedReader authFileReader = new BufferedReader(new FileReader(appStateIndicatorFile));
                        StringBuilder authFileBuilder = new StringBuilder();
                        while ((currentLine = authFileReader.readLine()) != null) {
                            authFileBuilder.append(currentLine);
                        }
                        authFileReader.close();
                        JSONObject authFileObj = new JSONObject(decrypt(authFileBuilder.toString()));
                        long lastModifiedTime = appStateIndicatorFile.lastModified();
                        Date date = new Date();
                        date.setTime(lastModifiedTime);
                        String lastModifiedDate = new SimpleDateFormat("yyyyMMdd", new mInterfaceUtil().locale).format(date);

                        if (authFileObj.optString("validDevice").equals("nostatus") || !lastModifiedDate.equals(new SimpleDateFormat("yyyyMMdd", new mInterfaceUtil().locale).format(new Date()))) {
                            if (isConnected(applicationContext)) {
                                UpdateAppStateInfo task = new UpdateAppStateInfo();
                                task.setParam(currentAccount);
                                task.execute();
                            } else {
                                mInterfaceService.handleAppStateTimer("success");
                            }
                        } else {
                            mInterfaceService.handleAppStateTimer("success");
                        }
                    } else {
                        if (isConnected(applicationContext)) {
                            UpdateAppStateInfo task = new UpdateAppStateInfo();
                            task.setParam(currentAccount);
                            task.execute();
                        } else {
                            mInterfaceService.handleAppStateTimer("failure");
                        }
                    }

                }
            } else {
                System.out.println("No my accounts file");
            }
        } catch (Exception e) {
            System.out.println(e.getMessage());
            mInterfaceService.handleAppStateTimer("failure");
        }
    }

    /* App State info */
    private static class UpdateAppStateInfo extends AsyncTask<String,
            Void,
            String> {
        private JSONObject currentAccount;

        public void setParam(JSONObject currentAccount) {
            this.currentAccount = currentAccount;
        }

        @Override
        protected String doInBackground(String... strings) {
            String currentLine, clientUrl, clientID, countryCode, cvsUrl, deviceID, sessionID, userID, localeID;
            URL requestAuthenticationPath,
                    requestValidateDevicePath, getKeysPath;
            HttpURLConnection urlConObj;
            OutputStreamWriter oStreamObj;
            BufferedWriter writerObj;
            StringBuilder serverResponseObj;
            BufferedReader responseReaderObj;
            JSONObject responseDataObj;
            try {
                clientID = currentAccount.optString("client_id");
                countryCode = currentAccount.optString("country_code");
                clientUrl = currentAccount.optString("client_url");
                cvsUrl = currentAccount.optString("cvs_url");
                deviceID = currentAccount.optString("device_id");
                sessionID = currentAccount.optString("session_id");
                userID = currentAccount.optString("user_id");
                localeID = currentAccount.optString("locale_id");

                getKeysPath = new URL(clientUrl + "/" + "common/components/Keys/" + "RetrieveKey.aspx");
                urlConObj = (HttpURLConnection) getKeysPath.openConnection();
                urlConObj.setDoOutput(true);
                urlConObj.setRequestMethod("POST");
                urlConObj.setRequestProperty("CONTENT-TYPE", "application/json");
                urlConObj.connect();
                JSONObject jsonObject1 = new JSONObject();
                jsonObject1 = jsonObject1.put("client_id", clientID);
                jsonObject1 = jsonObject1.put("country_code", countryCode);
                jsonObject1 = jsonObject1.put("purposeCode", "mobile_address_store");
                jsonObject1 = jsonObject1.put("version", "doubleo");
                System.out.println("data format: " + jsonObject1);
                oStreamObj = new OutputStreamWriter(urlConObj.getOutputStream());
                oStreamObj.write(jsonObject1.toString());
                oStreamObj.flush();
                oStreamObj.close();
                serverResponseObj = new StringBuilder();
                responseReaderObj = new BufferedReader(new InputStreamReader(urlConObj.getInputStream()));
                while ((currentLine = responseReaderObj.readLine()) != null) {
                    serverResponseObj.append(currentLine);
                }
                responseReaderObj.close();
                urlConObj.disconnect();
                BufferedReader reader = new BufferedReader(new FileReader(new File(rootDirectory, "/" + mInterfaceUtil.packageName + "/" + "my_accounts" + "/" + clientID + "_" + countryCode + "/" + ".json")));
                StringBuilder content = new StringBuilder();
                String line;
                while ((line = reader.readLine()) != null) {
                    content.append(line);
                }
                reader.close();
                // Parse the existing data as JSON
                JSONObject existingData = new JSONObject(decrypt(content.toString()));
                existingData.put("keys", serverResponseObj.toString());
                writerObj = new BufferedWriter(new FileWriter(new File(rootDirectory, "/" + mInterfaceUtil.packageName + "/" + "my_accounts" + "/" + clientID + "_" + countryCode + "/" + ".json")));
                writerObj.write(encrypt(existingData.toString()));
                writerObj.flush();
                writerObj.close();
                /* App State info DATA REQUEST */
                requestAuthenticationPath = new URL(cvsUrl + "/" + "get_app_state_info.aspx");
                urlConObj = (HttpURLConnection) requestAuthenticationPath.openConnection();
                urlConObj.setDoOutput(true);
                urlConObj.setRequestMethod("POST");
                urlConObj.setRequestProperty("CONTENT-TYPE", "application/json");
                urlConObj.connect();

                oStreamObj = new OutputStreamWriter(urlConObj.getOutputStream());
                JSONObject reqJson_obj = new JSONObject();
                reqJson_obj.put("client_id", clientID);
                reqJson_obj.put("country_code", countryCode);
                reqJson_obj.put("app_id", app_id);
                reqJson_obj.put("platform", platform);
                reqJson_obj.put("store", store);
                oStreamObj.write(reqJson_obj.toString());
                oStreamObj.flush();
                oStreamObj.close();
                serverResponseObj = new StringBuilder();
                responseReaderObj = new BufferedReader(new InputStreamReader(urlConObj.getInputStream()));
                while ((currentLine = responseReaderObj.readLine()) != null) {
                    serverResponseObj.append(currentLine);
                }
                responseReaderObj.close();
                urlConObj.disconnect();
                responseDataObj = new JSONObject(serverResponseObj.toString());

                /* VALIDATE DEVICE REQUEST */
                try {
                    requestValidateDevicePath = new URL(clientUrl + "/api/security/validate_device");
                    urlConObj = (HttpURLConnection) requestValidateDevicePath.openConnection();
                    urlConObj.setDoOutput(true);
                    urlConObj.setRequestMethod("POST");
                    urlConObj.setRequestProperty("CONTENT-TYPE", "application/json");
                    urlConObj.connect();
                    oStreamObj = new OutputStreamWriter(urlConObj.getOutputStream());
                    JSONObject inputJson_obj = new JSONObject();
                    JSONObject context_obj = new JSONObject();
                    JSONObject inputparam_obj = new JSONObject();

                    inputparam_obj.put("p_device_id", deviceID);
                    inputparam_obj.put("p_company_id", clientID);
                    inputparam_obj.put("p_country_code", countryCode);
                    context_obj.put("sessionId", sessionID);
                    context_obj.put("userId", userID);
                    context_obj.put("client_id", clientID);
                    context_obj.put("locale_id", localeID);
                    context_obj.put("country_code", countryCode);
                    context_obj.put("inputparam", inputparam_obj);

                    inputJson_obj.put("context", context_obj);
                    oStreamObj.write(inputJson_obj.toString());
                    oStreamObj.flush();
                    oStreamObj.close();
                    serverResponseObj = new StringBuilder();
                    responseReaderObj = new BufferedReader(new InputStreamReader(urlConObj.getInputStream()));
                    while ((currentLine = responseReaderObj.readLine()) != null) {
                        serverResponseObj.append(currentLine);
                    }
                    responseReaderObj.close();
                    urlConObj.disconnect();
                    String responseStr = serverResponseObj.toString().replace("\\", "");
                    responseStr = responseStr.substring(1, responseStr.length() - 1);
                    JSONObject resultJsonObj = new JSONObject(responseStr).getJSONObject("outputparam");
                    responseDataObj = responseDataObj.put("validDevice", "true");
                    /* RESPONSE FOR AUTHENTICATION & VALIDATE DEVICE REQUESTS */
                    writerObj = new BufferedWriter(new FileWriter(new File(rootDirectory, "/" + packageName + "/" + clientID + "/" + countryCode + "/" + "app_state_info.txt")));
                    writerObj.write(encrypt(responseDataObj.toString()));
                    writerObj.flush();
                    writerObj.close();

                    mInterfaceService.handleAppStateTimer("Success");

                } catch (Exception ex) {
                    responseDataObj = responseDataObj.put("validDevice", "nostatus");
                    writerObj = new BufferedWriter(new FileWriter(new File(rootDirectory, "/" + packageName + "/" + clientID + "/" + countryCode + "/" + "app_state_info.txt")));
                    writerObj.write(encrypt(responseDataObj.toString()));
                    writerObj.flush();
                    writerObj.close();
                    mInterfaceService.handleAppStateTimer("Success");
                }
            } catch (Exception e) {
                System.out.println(e.getMessage());
                mInterfaceService.handleAppStateTimer("failure");
            }
            return null;
        }
    }

    public boolean updateAppInfo(JSONArray args) {
        try {
            JSONObject appInfo = args.getJSONObject(0);
            mInterfaceUtil.app_id = appInfo.optString("app_id");
            mInterfaceUtil.platform = appInfo.optString("platform");
            mInterfaceUtil.deviceID = appInfo.optString("device_id");
            mInterfaceUtil.clientID = appInfo.optString("client_id");
            mInterfaceUtil.countryCode = appInfo.optString("country_code");
            mInterfaceUtil.localeID = appInfo.optString("locale_id");
            mInterfaceUtil.sessionID = appInfo.optString("session_id");
            mInterfaceUtil.userID = appInfo.optString("user_Id");
            mInterfaceUtil.employeeId = appInfo.optString("employee_id");
            mInterfaceUtil.clientUrl = appInfo.optString("client_url");
            mInterfaceUtil.cvsUrl = appInfo.optString("cvs_url");
            mInterfaceUtil.store = appInfo.optString("store_name");
        } catch (Exception e) {
            return false;
        }
        return true;
    }


    public static boolean isConnected(Context applicationContext) {
        try {
            ConnectivityManager online = (ConnectivityManager) applicationContext.getSystemService(Context.CONNECTIVITY_SERVICE);
            NetworkInfo networkInfo = online.getActiveNetworkInfo();
            return networkInfo != null && networkInfo.isConnected();
        } catch (Exception e) {
            e.printStackTrace();
        }
        return false;
    }

    public static void appCleanUp(CallbackContext callbackContext, Context applicationContext) {
        try {
            if (isFirstLaunch(applicationContext)) {
                performCleanup(applicationContext);
                setFirstLaunch(applicationContext, false);
            }
            callbackContext.success("Success");
        } catch (Exception e) {
            e.printStackTrace();
            callbackContext.error("AppCleanUp Failed, Exception is" + e.getMessage());
        }
    }

    private static void performCleanup(Context context) {
        // Delete files in the internal storage directory
        File internalFilesDir = context.getFilesDir();
        deleteDirectory(internalFilesDir);
        // Delete files in the cache directory
        File cacheDir = context.getCacheDir();
        deleteDirectory(cacheDir);
        // Delete files in the external storage directory
        File externalFilesDir = context.getExternalFilesDir(null);
        if (externalFilesDir != null) {
            deleteDirectory(externalFilesDir);
        }
        // Delete files in the external cache directory
        File externalCacheDir = context.getExternalCacheDir();
        if (externalCacheDir != null) {
            deleteDirectory(externalCacheDir);
        }

    }

    public static boolean isFirstLaunch(Context context) {
        SharedPreferences prefs = context.getSharedPreferences(PREFS_NAME, Context.MODE_PRIVATE);
        return prefs.getBoolean(KEY_FIRST_LAUNCH, true);
    }

    public static void setFirstLaunch(Context context, boolean value) {
        SharedPreferences prefs = context.getSharedPreferences(PREFS_NAME, Context.MODE_PRIVATE);
        SharedPreferences.Editor editor = prefs.edit();
        editor.putBoolean(KEY_FIRST_LAUNCH, value);
        editor.apply();
    }

    private static void deleteDirectory(File dir) {
        if (dir != null && dir.isDirectory()) {
            File[] files = dir.listFiles();
            if (files != null) {
                for (File file : files) {
                    if (file.isDirectory()) {
                        deleteDirectory(file);
                    } else {
                        boolean deleted = file.delete();
                        if (!deleted) {
                            Log.e("FileUtils", "Failed to delete file: " + file.getAbsolutePath());
                        }
                    }
                }
            }
        }
    }

}