#import <Cordova/CDV.h>

#import <Foundation/Foundation.h>
@import UIKit;
#import <MapKit/MapKit.h>
#import <CoreLocation/CoreLocation.h>
#import <Cordova/CDVPlugin.h>
#import <UIKit/UIKit.h>
#import <QuickLook/QuickLook.h>
#import "SSZipArchive.h"
#import <MessageUI/MessageUI.h>
@interface mInterface : CDVPlugin <CLLocationManagerDelegate, UIImagePickerControllerDelegate, UINavigationControllerDelegate, UIAlertViewDelegate, QLPreviewControllerDelegate, QLPreviewControllerDataSource, QLPreviewItem, SSZipArchiveDelegate, UIDocumentInteractionControllerDelegate, MFMessageComposeViewControllerDelegate>
{
#define FILE_EXTENSION    @".png"
#define IMAGE_NAME        @"CameraImage"
    NSString *localFile;
    UIImagePickerController *ipc;
    UIImagePickerController *cameraOpen;
    UIImagePickerController *imagePicker;
    UIImagePickerController *liveCamera;
    UIPopoverController *popover;
    UIAlertController *alertChoice;
    UIAlertController *alertConfirm;
    UIActivityIndicatorView *spinnerIndicator;
    NSString *spinnerCallbackId;
    NSNumber *spinnerIsFixed;
    NSString *app_id;
    NSString *platform;
    NSString *store;
    NSString *sessionID;
    NSString *localeID;
    NSString *clientID;
    NSString *countryCode;
    NSString *userID;
    NSString *cvsUrl;
    NSString *clientUrl;
    NSString *deviceID;
    NSString *appInfoCaller;
    NSString *imageAttachmentInd;
    NSString *imageDestinationPath;
@protected BOOL _isLocked;
    UIInterfaceOrientation _lastOrientation;
}
@property(strong) NSString* callbackID;
- (void)GetFCMUtils:(CDVInvokedUrlCommand *)command;
-(void)GetBase64String:(CDVInvokedUrlCommand *)command;
- (void)ValidateAppStateInfo;
-(void)HandleAppStateTimer:(NSString *)status;
-(void)GetAppStateInfo:(CDVInvokedUrlCommand *)command;
- (void)RotateScreen:(CDVInvokedUrlCommand *)command;
- (void)GetSubDirectoryList:(CDVInvokedUrlCommand *)command;
- (void)GetFileListOO:(CDVInvokedUrlCommand *)command;
- (void)moveFileOO:(CDVInvokedUrlCommand *)command;
- (void)CopyFileOO:(CDVInvokedUrlCommand *)command;
- (void)CheckAutomaticTime:(CDVInvokedUrlCommand *)command;
- (void)OpenDialPad:(CDVInvokedUrlCommand *)command;
- (void)OpenSms:(CDVInvokedUrlCommand *)command;
- (void)OpenEmail:(CDVInvokedUrlCommand *)command;
- (void)HasPermission:(CDVInvokedUrlCommand *)command;
- (void)GrantPermission:(CDVInvokedUrlCommand *)command;
-(void)KillBackgroundExecutions:(CDVInvokedUrlCommand*)command;
-(void)DeleteMultipleFiles:(CDVInvokedUrlCommand*)command;
-(void)CopyConfigFile:(CDVInvokedUrlCommand*)command;
-(void)TriggerAuthIndService:(CDVInvokedUrlCommand*)command;
- (void)GetCurrentLocation:(CDVInvokedUrlCommand*)command;
- (void)GetUniqueDeviceId:(CDVInvokedUrlCommand*)command;
-(void)DeleteDirectory:(CDVInvokedUrlCommand*)command;
-(void)CreateDirectory:(CDVInvokedUrlCommand*)command;
-(void)ValidateFile:(CDVInvokedUrlCommand*)command;
-(void)CreateFile:(CDVInvokedUrlCommand*)command;
-(void)ReadFile:(CDVInvokedUrlCommand*)command;
-(void)DeleteFile:(CDVInvokedUrlCommand*)command;
- (void)UnZip:(CDVInvokedUrlCommand*)command;
-(void)GetStorageRoot:(CDVInvokedUrlCommand*)command;
-(void)DownloadFile:(CDVInvokedUrlCommand*)command;
- (void)OpenFileWithViewer:(CDVInvokedUrlCommand *)command;
- (void)DeviceInfo:(CDVInvokedUrlCommand*)command;
-(void)AppVersion:(CDVInvokedUrlCommand*)command;
-(void)CheckLocationPermission:(CDVInvokedUrlCommand*)command;
-(void)GetPermissions:(CDVInvokedUrlCommand*)command;
-(void)RemoveFilesFromDirectory;
-(void)DespatchQueueMoveToServer;
- (void)QueueProcessor:(CDVInvokedUrlCommand*)command;
- (NSString *)sendFilesToServer:(NSString *)filePath fileName:(NSString *)fileName requestURL:(NSString *) requestURL;
- (void)CaptureFromCamera:(CDVInvokedUrlCommand*)command;
- (void)CaptureImageFromCamera:(CDVInvokedUrlCommand*)command;
- (void)PickImageFromGallery:(CDVInvokedUrlCommand*)command;
- (void)Spinner:(CDVInvokedUrlCommand*)command;
- (void)GetPackageName:(CDVInvokedUrlCommand*)command;
- (void)UpdateNew:(CDVInvokedUrlCommand*)command;
- (void)StartService:(CDVInvokedUrlCommand*)command;
- (void)SendAttachmentToServer:(CDVInvokedUrlCommand*)command;
- (void)SendLocation;
- (void)GetLocation:(CDVInvokedUrlCommand*)command;
- (void)timeReader;
- (void)CheckSumIndicatorResult;
- (void)CheckLocation:(CDVInvokedUrlCommand*)command;
- (void)CopyFile:(CDVInvokedUrlCommand*)command;
- (void)FileChooser:(CDVInvokedUrlCommand*)command;
- (NSString *)contentTypeForImageData:(NSString *)string;
- (void)RefreshTimeProfile:(CDVInvokedUrlCommand*)command;
- (void)GetNewDate:(CDVInvokedUrlCommand*)command;
- (id)getCurrentDateTime;
-(void)timeValues:(NSString *)date hour:(NSString *)hour minute:(NSString *)minute;
-(void)SendChatAttachment:(CDVInvokedUrlCommand*)command;
- (void)KillTimers;
//- (void)AuthenticationRefresh;
//- (void)triggerAuthenticationServices:(NSString *)clientId  countryCode:(NSString *)countryCode  userId:(NSString *)userId  sessionId:(NSString *)sessionId  localeId:(NSString *)localeId  deviceID:(NSString *)deviceID  clientUrl:(NSString *)clientUrl  cvsUrl:(NSString *)cvsUrl authIndFilePath:(NSString *)authIndFilePath;
- (void)GetSyncIndicator:(CDVInvokedUrlCommand*)command;
- (void)CopyAttachmentFile:(CDVInvokedUrlCommand*)command;
- (void)getMyAccountsData:(CDVInvokedUrlCommand*)command;
@property (strong, nonatomic) CLLocationManager * locationManager;
@property (strong, nonatomic) NSMutableArray * coordinatesArray;
@property (weak, nonatomic) IBOutlet UIButton *btnGallery;
@property (strong, nonatomic) UIViewController * viewcont;
@property (nonatomic, strong) NSString *callbackIdForImagePicker;
@property (nonatomic, strong) NSString *callbackIdForAppUpdate;
@property (nonatomic, strong) NSString *successCallBackForSpinner;
@property NSTimer *LocationTimer;
@property NSTimer *timeReaderTimer;
@property NSTimer *CheckSumTimer;
@property NSTimer *authTimer;
@property NSTimer *QueueToServerTimer;
@property NSTimer *AppStateInfoTimer;
@property UIActivityIndicatorView *activityIndicator;
@property (nonatomic, retain) UIActivityIndicatorView *indicator;
@property (nonatomic, retain) UIView *overlay;
@property(strong, nonatomic) NSURL *fileUrl;
@property(readonly) NSURL *previewItemURL;
@property (nonatomic, copy) NSString* fileOpenCallbackId;
@property(nonatomic, strong) UIDocumentInteractionController *controller;
@end
