#import "mInterface.h"
#import "XMLConverter.h"
#import "InternetConnection.h"
#import "UICKeyChainStore.h"
#import <AssetsLibrary/AssetsLibrary.h>
#import <Cordova/CDVViewController.h>
#import <QuartzCore/QuartzCore.h>
#import <MobileCoreServices/MobileCoreServices.h>
#import <objc/message.h>
#include <sys/types.h>
#include <sys/sysctl.h>
#include "TargetConditionals.h"
#import "OneSignalPush.h"
#import <OneSignal/OneSignal.h>
#import <objc/runtime.h>

#if defined(__IPHONE_10_0) && __IPHONE_OS_VERSION_MAX_ALLOWED >= __IPHONE_10_0
@import UserNotifications;
#endif

#ifndef NSFoundationVersionNumber_iOS_9_x_Max
#define NSFoundationVersionNumber_iOS_9_x_Max 1299
#endif

@implementation mInterface
@synthesize btnGallery;
@synthesize indicator = _indicator;
@synthesize overlay = _overlay;
@synthesize controller = docController;
@synthesize callbackID;

- (void)GetFCMUtils:(CDVInvokedUrlCommand *)command {
    OSDeviceState *deviceState = [OneSignal getDeviceState];
    NSMutableDictionary * deviceDict = [[NSMutableDictionary alloc] init];
    [deviceDict setValue:deviceState.userId forKey:@"userId"];
    [deviceDict setValue:deviceState.pushToken forKey:@"pushToken"];
    CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsDictionary:deviceDict];
    [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
}

- (void)SendAttachmentToServer:(CDVInvokedUrlCommand *)command {
    NSString *statusIndication = @"false";
    NSMutableArray *argumentsList = [command arguments];
    CDVPluginResult *result;
    NSDictionary *argumentObject;
    NSString *filePath;
    NSString *serverPath;
    NSString *fileName;
    NSString *attachURL;
    for(int index = 0; index < [argumentsList count]; index++) {
        argumentObject = [argumentsList objectAtIndex:index];
        filePath = argumentObject[@"filePath"];
        serverPath = argumentObject[@"serverPath"];
        fileName = argumentObject[@"fileName"];
        attachURL = [NSString stringWithFormat: @"%@/common/components/msvFileHandler/UploadFiles.aspx?client_id=%@&country_code=%@&path=%@", clientUrl, clientID, countryCode, serverPath];
        statusIndication = [self sendFilesToServer:filePath fileName:fileName requestURL:attachURL];
        if ([statusIndication isEqualToString:@"false"]) {
            break;
        }
    }
    if ([statusIndication isEqualToString:@"true"]) {
        NSString *serviceResult = [NSString stringWithFormat:@"%s", "success"];
        result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsString:serviceResult];
    } else {
        NSString *serviceResult = [NSString stringWithFormat:@"%s", "failure"];
        result = [CDVPluginResult resultWithStatus:CDVCommandStatus_ERROR messageAsString:serviceResult];
    }
    [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
}

-(void)GetBase64String:(CDVInvokedUrlCommand *)command {
    NSMutableDictionary *dict = [[command arguments] objectAtIndex:0];
    NSString *directory = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES)[0];
    NSString *workSpacePath=[NSString stringWithFormat:@"%@/%@", directory, dict[@"filePath"]];
    NSString *imageString = [UIImagePNGRepresentation([UIImage imageWithData:[NSData dataWithContentsOfFile:workSpacePath]]) base64EncodedStringWithOptions:NSDataBase64Encoding64CharacterLineLength];
    CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsString:imageString];
    [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
}

-(void)GetAppStateInfo:(CDVInvokedUrlCommand *)command {
    appInfoCaller = @"true";
    NSString *appInfoUpdate = [self UpdateAppInfo:command];
    if([appInfoUpdate isEqualToString:@"true"]){
        [self getAppStateInfoCall:command];
    } else {
        CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK];
        [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
    }
}
-(void)getAppStateInfoCall:(CDVInvokedUrlCommand *)command {
    NSString *directory = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES)[0];
    NSString *contentsPath = [NSString stringWithFormat:@"%@/%@/%@/%@/app_state_info.txt", directory, [self GetAppName], clientID, countryCode];
    InternetConnection *networkReachability = [InternetConnection reachabilityForInternetConnection];
    NetworkStatus networkStatus = [networkReachability currentReachabilityStatus];
    if([[NSFileManager defaultManager] fileExistsAtPath:contentsPath]) {
        NSData *fileData = [NSData dataWithContentsOfFile:contentsPath];
        NSMutableDictionary *fileDict = [NSJSONSerialization JSONObjectWithData:fileData options:NSJSONReadingMutableContainers error:nil];
        NSString *deviceStatus = fileDict[@"validDevice"];
        NSDictionary *attributes = [[NSFileManager defaultManager] attributesOfItemAtPath:contentsPath error:nil];
        NSDateFormatter *dateFormatter = [self getCurrentDateTime];
        [dateFormatter setDateFormat:@"yyyyMMdd"];
        NSString *lastModified = [dateFormatter stringFromDate:[attributes fileModificationDate]];
        NSString *currentDate = [dateFormatter stringFromDate:[NSDate date]];
        int lastModifiedInt = [lastModified intValue];
        int currentDateInt = [currentDate intValue];
        if([deviceStatus isEqualToString:@"nostatus"] || lastModifiedInt != currentDateInt) {
            if(networkStatus != NotReachable){
                [self DownloadAppStateInfo:command];
            } else {
                NSData *jsonData = [NSJSONSerialization dataWithJSONObject:fileDict options:NSJSONWritingPrettyPrinted error:nil];
                [jsonData writeToFile:contentsPath atomically:true];
                CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsString:[[NSString alloc] initWithData:jsonData   encoding:NSUTF8StringEncoding]];
                [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
            }
        } else {
            NSData *jsonData = [NSJSONSerialization dataWithJSONObject:fileDict options:NSJSONWritingPrettyPrinted error:nil];
            [jsonData writeToFile:contentsPath atomically:true];
            CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsString:[[NSString alloc] initWithData:jsonData   encoding:NSUTF8StringEncoding]];
            [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
        }
    } else {
        if(networkStatus != NotReachable){
            [self DownloadAppStateInfo:command];
        } else {
            CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK];
            [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
        }
    }
}

-(void)HandleAppStateTimer:(NSString *)status {
    if([status isEqualToString:@"failure"]) {
        self.AppStateInfoTimer = [NSTimer scheduledTimerWithTimeInterval:60.0
                                                                   target:self
                                                                selector:@selector(ValidateAppStateInfo)
                                                                 userInfo:nil
                                                                  repeats:YES];
    } else {
        if([self.AppStateInfoTimer isValid]) {
            [self.AppStateInfoTimer invalidate];
        }
    }
}

-(void)DownloadAppStateInfo:(CDVInvokedUrlCommand *)command{
    @try {
        NSString *directory = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0];
        //getting API Keys
        NSError *jsonError;
        NSString *getKeyApsx = [NSString stringWithFormat:@"%@/common/components/Keys/RetrieveKey.aspx", clientUrl];
        NSString *keyContent = [NSString stringWithFormat:@"{\"client_id\":\"%@\",\"country_code\":\"%@\",\"purposeCode\":\"mobile_address_store\",\"version\":\"doubleo\"}",clientID, countryCode];
        NSMutableURLRequest *authRequest1 = [[NSMutableURLRequest alloc] initWithURL:[NSURL URLWithString:getKeyApsx]];
        [authRequest1 setValue:@"text/json" forHTTPHeaderField:@"Content-type"];
        [authRequest1 setHTTPMethod : @"POST"];
        [authRequest1 setHTTPBody : [keyContent dataUsingEncoding:NSUTF8StringEncoding]];
        NSURLResponse *keyResponse;
        NSData *keyResponseData = [NSURLConnection sendSynchronousRequest:authRequest1 returningResponse:&keyResponse error:&jsonError];
        NSString *responseString1 = [[NSString alloc] initWithData:keyResponseData encoding:NSUTF8StringEncoding];
        NSData *keyData = [responseString1 dataUsingEncoding:NSUTF8StringEncoding];
        
        NSString *filePath = [NSString stringWithFormat:@"%@/%@/my_accounts/%@_%@.json", directory, [self GetAppName], clientID, countryCode];
        // Read the existing JSON data from the file
       NSError* readError;
       NSString* fileContents = [NSString stringWithContentsOfFile:filePath
                                                          encoding:NSUTF8StringEncoding
                                                             error:&readError];
       // Parse the existing data as JSON
       NSData* jsonData = [fileContents dataUsingEncoding:NSUTF8StringEncoding];
       NSMutableDictionary* existingData = [NSJSONSerialization JSONObjectWithData:jsonData
                                                                           options:NSJSONReadingMutableContainers
                                                                             error:nil];
        existingData[@"keys"] = [NSJSONSerialization JSONObjectWithData:keyData options:NSJSONReadingMutableContainers error:nil];
       // Convert the updated data back to JSON
       NSData* updatedJsonData = [NSJSONSerialization dataWithJSONObject:existingData
                                                                 options:NSJSONWritingPrettyPrinted
                                                                   error:nil];
       // Write the updated JSON data back to the file
       [updatedJsonData writeToFile:filePath atomically:YES];
        
        NSString *contentsPath = [NSString stringWithFormat:@"%@/%@/%@/%@/app_state_info.txt", directory, [self GetAppName], clientID, countryCode];
        NSString *authAspx = [NSString stringWithFormat:@"%@/get_app_state_info.aspx", cvsUrl];
        NSString *deviceAspx = [NSString stringWithFormat:@"%@/api/security/validate_device", clientUrl];
        NSDictionary *authDict = @{
               @"client_id" : [NSString stringWithFormat:@"%@", clientID],
            @"country_code" : [NSString stringWithFormat:@"%@", countryCode],
            @"app_id" : [NSString stringWithFormat:@"%@", app_id],
                 @"platform" : [NSString stringWithFormat:@"%@", platform],
               @"store" : [NSString stringWithFormat:@"%@", store]
        };
        NSDictionary *inputParamDict = @{
               @"p_device_id" : [NSString stringWithFormat:@"%@", deviceID],
            @"p_company_id" : [NSString stringWithFormat:@"%@", clientID],
            @"p_country_code" : [NSString stringWithFormat:@"%@", countryCode],
        };
        NSDictionary *contextDict = @{
              @"sessionId" : [NSString stringWithFormat:@"%@", sessionID],
            @"userId" : [NSString stringWithFormat:@"%@", userID],
            @"client_id" : [NSString stringWithFormat:@"%@", clientID],
            @"locale_id" : [NSString stringWithFormat:@"%@", localeID],
                 @"country_code" : [NSString stringWithFormat:@"%@", countryCode],
               @"inputparam" : inputParamDict
        };
        NSDictionary *inputDict = @{
              @"context" : contextDict,
        };
        NSData * authJSONData = [NSJSONSerialization  dataWithJSONObject:authDict options:0 error:&jsonError];
        NSString * authDataString = [[NSString alloc] initWithData:authJSONData   encoding:NSUTF8StringEncoding];
        NSMutableURLRequest *authRequest = [[NSMutableURLRequest alloc] initWithURL:[NSURL URLWithString:authAspx]];
        [authRequest setValue:@"text/json" forHTTPHeaderField:@"Content-type"];
        [authRequest setHTTPMethod : @"POST"];
        [authRequest setHTTPBody : [authDataString dataUsingEncoding:NSUTF8StringEncoding]];
        NSURLResponse *authResponse;
        NSData *authResponseData = [NSURLConnection sendSynchronousRequest:authRequest returningResponse:&authResponse error:&jsonError];
        NSString *responseString = [[NSString alloc] initWithData:authResponseData encoding:NSUTF8StringEncoding];
        NSMutableDictionary * mutableDict = [[NSMutableDictionary alloc] init];
        mutableDict = [NSJSONSerialization JSONObjectWithData:[responseString dataUsingEncoding:NSUTF8StringEncoding] options:kNilOptions error:&jsonError];
        @try {
            NSData * deviceJSONData = [NSJSONSerialization  dataWithJSONObject:inputDict options:0 error:&jsonError];
            NSString * deviceDataString = [[NSString alloc] initWithData:deviceJSONData   encoding:NSUTF8StringEncoding];
            NSMutableURLRequest *deviceRequest = [[NSMutableURLRequest alloc] initWithURL:[NSURL URLWithString:deviceAspx]];
            [deviceRequest setValue:@"text/json" forHTTPHeaderField:@"Content-type"];
            [deviceRequest setHTTPMethod : @"POST"];
            [deviceRequest setHTTPBody : [deviceDataString dataUsingEncoding:NSUTF8StringEncoding]];
            NSURLResponse *deviceResponse;
            NSData *deviceResponseData = [NSURLConnection sendSynchronousRequest:deviceRequest returningResponse:&deviceResponse error:nil];
            NSString *deviceResponseString = [[NSString alloc] initWithData:deviceResponseData encoding:NSUTF8StringEncoding];
            if (deviceResponseData != nil) {
                NSMutableDictionary *deviceResponseDict = [[NSMutableDictionary alloc] init];
                deviceResponseDict = [NSJSONSerialization JSONObjectWithData:[deviceResponseString dataUsingEncoding:NSUTF8StringEncoding] options:kNilOptions error:&jsonError];
                NSMutableDictionary *deviceIndDict = [[NSMutableDictionary alloc] init];
                deviceIndDict = deviceResponseDict[@"outputparam"];
                NSMutableDictionary *dict = [[NSMutableDictionary alloc] init];
                dict[@"accessPackageTimestamp"] = mutableDict[@"accessPackageTimestamp"];
                dict[@"appVersion"] = mutableDict[@"appVersion"];
                dict[@"configurationPackageTimestamp"] = mutableDict[@"configurationPackageTimestamp"];
                dict[@"validDevice"] = @"true";
                
                NSData *jsonData = [NSJSONSerialization dataWithJSONObject:dict options:NSJSONWritingPrettyPrinted error:nil];
                NSLog(@"final data: %@", [[NSString alloc] initWithData:jsonData   encoding:NSUTF8StringEncoding]);
                [jsonData writeToFile:contentsPath atomically:true];
                CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsString:[[NSString alloc] initWithData:jsonData   encoding:NSUTF8StringEncoding]];
                [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
            } else {
                NSMutableDictionary *dict = [[NSMutableDictionary alloc] init];
                dict[@"accessPackageTimestamp"] = mutableDict[@"accessPackageTimestamp"];
                dict[@"appVersion"] = mutableDict[@"appVersion"];
                dict[@"configurationPackageTimestamp"] = mutableDict[@"configurationPackageTimestamp"];
                dict[@"validDevice"] = @"nostatus";
                NSData *jsonData = [NSJSONSerialization dataWithJSONObject:dict options:NSJSONWritingPrettyPrinted error:nil];
                NSLog(@"final data: %@", [[NSString alloc] initWithData:jsonData   encoding:NSUTF8StringEncoding]);
                [jsonData writeToFile:contentsPath atomically:true];
                CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsString:[[NSString alloc] initWithData:jsonData   encoding:NSUTF8StringEncoding]];
                [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
            }
        } @catch (NSException *exception) {
            NSMutableDictionary *dict = [[NSMutableDictionary alloc] init];
            dict[@"accessPackageTimestamp"] = mutableDict[@"accessPackageTimestamp"];
            dict[@"appVersion"] = mutableDict[@"appVersion"];
            dict[@"configurationPackageTimestamp"] = mutableDict[@"configurationPackageTimestamp"];
            dict[@"validDevice"] = @"nostatus";
            NSData *jsonData = [NSJSONSerialization dataWithJSONObject:dict options:NSJSONWritingPrettyPrinted error:nil];
            NSLog(@"final data: %@", [[NSString alloc] initWithData:jsonData   encoding:NSUTF8StringEncoding]);
            [jsonData writeToFile:contentsPath atomically:true];
            CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsString:[[NSString alloc] initWithData:jsonData   encoding:NSUTF8StringEncoding]];
            [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
        }
    } @catch (NSException *exception) {
        NSLog(@"Exception : %@", exception.description);
    }
}

-(NSString *)UpdateAppInfo:(CDVInvokedUrlCommand *)command {
    NSDictionary *dict = [[command arguments] objectAtIndex:0];
    @try {
        app_id = dict[@"app_id"];
        platform = dict[@"platform"];
        deviceID = dict[@"device_id"];
        clientID = dict[@"client_id"];
        countryCode = dict[@"country_code"];
        localeID = dict[@"locale_id"];
        sessionID = dict[@"session_id"];
        userID = dict[@"user_Id"];
        clientUrl = dict[@"client_url"];
        cvsUrl = dict[@"cvs_url"];
        store = dict[@"store_name"];
        if(![appInfoCaller isEqualToString:@"true"]) {
            CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK];
            [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
        }
        appInfoCaller = @"";
    } @catch (NSException *exception) {
        return @"false";
    }
    return @"true";
}

-(void) UpdateAppStateInfo: (NSData *)accountJsonData{
    @try {
        NSString *directory = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0];
        NSError *jsonError;
        NSString *contentsPath;
        NSDictionary *accountDict = [NSJSONSerialization JSONObjectWithData:accountJsonData options:NSJSONReadingMutableContainers error:&jsonError];
        if (!jsonError && accountDict) {
            NSString *clientID = accountDict[@"client_id"];
            NSString *countryCode = accountDict[@"country_code"];
            NSString *appID = [NSString stringWithFormat:@"%@", app_id];
            NSString *platform =   @"iOS";
            NSString *store =   @"AppleAppStore";
            NSString *deviceID = accountDict[@"device_id"];
            NSString *sessionID = accountDict[@"session_id"];
            NSString *userID = accountDict[@"user_id"];
            NSString *localeID = accountDict[@"locale_id"];
            NSString *cvsUrl = accountDict[@"cvs_url"];
            NSString *clientUrl = accountDict[@"client_url"];
            
            //getting API Keys
            NSError *jsonError;
            NSString *getKeyApsx = [NSString stringWithFormat:@"%@/common/components/Keys/RetrieveKey.aspx", clientUrl];
            NSString *keyContent = [NSString stringWithFormat:@"{\"client_id\":\"%@\",\"country_code\":\"%@\",\"purposeCode\":\"mobile_address_store\",\"version\":\"doubleo\"}",clientID, countryCode];
            NSMutableURLRequest *authRequest1 = [[NSMutableURLRequest alloc] initWithURL:[NSURL URLWithString:getKeyApsx]];
            [authRequest1 setValue:@"text/json" forHTTPHeaderField:@"Content-type"];
            [authRequest1 setHTTPMethod : @"POST"];
            [authRequest1 setHTTPBody : [keyContent dataUsingEncoding:NSUTF8StringEncoding]];
            NSURLResponse *keyResponse;
            NSData *keyResponseData = [NSURLConnection sendSynchronousRequest:authRequest1 returningResponse:&keyResponse error:&jsonError];
            NSString *responseString1 = [[NSString alloc] initWithData:keyResponseData encoding:NSUTF8StringEncoding];
            NSData *keyData = [responseString1 dataUsingEncoding:NSUTF8StringEncoding];
            
            NSString *filePath = [NSString stringWithFormat:@"%@/%@/my_accounts/%@_%@.json", directory, [self GetAppName], clientID, countryCode];
            // Read the existing JSON data from the file
           NSError* readError;
           NSString* fileContents = [NSString stringWithContentsOfFile:filePath
                                                              encoding:NSUTF8StringEncoding
                                                                 error:&readError];
           // Parse the existing data as JSON
           NSData* jsonData = [fileContents dataUsingEncoding:NSUTF8StringEncoding];
           NSMutableDictionary* existingData = [NSJSONSerialization JSONObjectWithData:jsonData
                                                                               options:NSJSONReadingMutableContainers
                                                                                 error:nil];
            existingData[@"keys"] = [NSJSONSerialization JSONObjectWithData:keyData options:NSJSONReadingMutableContainers error:nil];
           // Convert the updated data back to JSON
           NSData* updatedJsonData = [NSJSONSerialization dataWithJSONObject:existingData
                                                                     options:NSJSONWritingPrettyPrinted
                                                                       error:nil];
           // Write the updated JSON data back to the file
           [updatedJsonData writeToFile:filePath atomically:YES];
            
            contentsPath = [NSString stringWithFormat:@"%@/%@/%@/%@/app_state_info.txt", directory, [self GetAppName], clientID, countryCode];
            NSString *authAspx = [NSString stringWithFormat:@"%@/get_app_state_info.aspx", cvsUrl];
            NSString *deviceAspx = [NSString stringWithFormat:@"%@/api/security/validate_device", clientUrl];
            NSDictionary *authDict = @{
                            @"client_id" : clientID,
                            @"country_code" : countryCode,
                            @"app_id" : appID,
                            @"platform" : platform,
                            @"store" : store
                        };
             NSDictionary *inputParamDict = @{
                @"p_device_id" : deviceID,
                @"p_company_id" : clientID,
                @"p_country_code" : countryCode,
            };

             NSDictionary *contextDict = @{
                @"sessionId" : sessionID,
                @"userId" : userID,
                @"client_id" : clientID,
                @"locale_id" : localeID,
                @"country_code" : countryCode,
                @"inputparam" : inputParamDict
            };

            NSDictionary *inputDict = @{
                @"context" : contextDict,
            };
            NSData * authJSONData = [NSJSONSerialization  dataWithJSONObject:authDict options:0 error:&jsonError];
            NSString * authDataString = [[NSString alloc] initWithData:authJSONData   encoding:NSUTF8StringEncoding];
            NSMutableURLRequest *authRequest = [[NSMutableURLRequest alloc] initWithURL:[NSURL URLWithString:authAspx]];
            [authRequest setValue:@"text/json" forHTTPHeaderField:@"Content-type"];
            [authRequest setHTTPMethod : @"POST"];
            [authRequest setHTTPBody : [authDataString dataUsingEncoding:NSUTF8StringEncoding]];
            NSURLResponse *authResponse;
            NSData *authResponseData = [NSURLConnection sendSynchronousRequest:authRequest returningResponse:&authResponse error:&jsonError];
            NSString *responseString = [[NSString alloc] initWithData:authResponseData encoding:NSUTF8StringEncoding];
            NSMutableDictionary * mutableDict = [[NSMutableDictionary alloc] init];
            mutableDict = [NSJSONSerialization JSONObjectWithData:[responseString dataUsingEncoding:NSUTF8StringEncoding] options:kNilOptions error:&jsonError];
            //For device authentication
            @try {
                NSData * deviceJSONData = [NSJSONSerialization  dataWithJSONObject:inputDict options:0 error:&jsonError];
                NSString * deviceDataString = [[NSString alloc] initWithData:deviceJSONData   encoding:NSUTF8StringEncoding];
                NSData *deviceData = [deviceDataString dataUsingEncoding:NSUTF8StringEncoding];
                NSMutableURLRequest *deviceRequest = [[NSMutableURLRequest alloc] initWithURL:[NSURL URLWithString:deviceAspx]];
                [deviceRequest setValue:@"text/json" forHTTPHeaderField:@"Content-type"];
                [deviceRequest setHTTPMethod : @"POST"];
                [deviceRequest setHTTPBody : deviceData];
                NSURLResponse *deviceResponse;
                NSData *deviceResponseData = [NSURLConnection sendSynchronousRequest:deviceRequest returningResponse:&deviceResponse error:nil];
                NSString *deviceResponseString = [[NSString alloc] initWithData:deviceResponseData encoding:NSUTF8StringEncoding];
                if (deviceResponseData != nil) {
                    NSMutableDictionary *deviceResponseDict = [[NSMutableDictionary alloc] init];
                    deviceResponseDict = [NSJSONSerialization JSONObjectWithData:[deviceResponseString dataUsingEncoding:NSUTF8StringEncoding] options:kNilOptions error:&jsonError];
                    NSMutableDictionary *deviceIndDict = [[NSMutableDictionary alloc] init];
                    deviceIndDict = deviceResponseDict[@"outputparam"];
                    NSMutableDictionary *dict = [[NSMutableDictionary alloc] init];
                    dict[@"accessPackageTimestamp"] = mutableDict[@"accessPackageTimestamp"];
                    dict[@"appVersion"] = mutableDict[@"appVersion"];
                    dict[@"configurationPackageTimestamp"] = mutableDict[@"configurationPackageTimestamp"];
                    dict[@"validDevice"] = @"true";
                    NSData *jsonData = [NSJSONSerialization dataWithJSONObject:dict options:NSJSONWritingPrettyPrinted error:nil];
                    [jsonData writeToFile:contentsPath atomically:true];
                } else {
                    NSMutableDictionary *dict = [[NSMutableDictionary alloc] init];
                    dict[@"accessPackageTimestamp"] = mutableDict[@"accessPackageTimestamp"];
                    dict[@"appVersion"] = mutableDict[@"appVersion"];
                    dict[@"configurationPackageTimestamp"] = mutableDict[@"configurationPackageTimestamp"];
                    dict[@"validDevice"] = @"nostatus";
                    NSData *jsonData = [NSJSONSerialization dataWithJSONObject:dict options:NSJSONWritingPrettyPrinted error:nil];
                    [jsonData writeToFile:contentsPath atomically:true];
                }
            } @catch (NSException *exception) {
                NSMutableDictionary *dict = [[NSMutableDictionary alloc] init];
                dict[@"accessPackageTimestamp"] = mutableDict[@"accessPackageTimestamp"];
                dict[@"appVersion"] = mutableDict[@"appVersion"];
                dict[@"configurationPackageTimestamp"] = mutableDict[@"configurationPackageTimestamp"];
                dict[@"validDevice"] = @"nostatus";
                NSData *jsonData = [NSJSONSerialization dataWithJSONObject:dict options:NSJSONWritingPrettyPrinted error:nil];
                [jsonData writeToFile:contentsPath atomically:true];
            }
            
        }else {
            NSLog(@"Error parsing accountJsonData: %@", jsonError);
        }
    } @catch (NSException *exception) {
        NSLog(@"Exception : %@", exception.description);
    }
}


- (void)ValidateAppStateInfo {
    NSString *directory = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES)[0];
    NSString *myAccountsFolderPath = [NSString stringWithFormat:@"%@/%@/%@", directory, [self GetAppName], @"my_accounts"];
       NSError *error;
       NSFileManager *fileManager = [NSFileManager defaultManager];
    InternetConnection *networkReachability = [InternetConnection reachabilityForInternetConnection];
    NetworkStatus networkStatus = [networkReachability currentReachabilityStatus];
    if ([fileManager fileExistsAtPath:myAccountsFolderPath]) {
        NSArray *accountFiles = [fileManager contentsOfDirectoryAtPath:myAccountsFolderPath error:&error];
        if (accountFiles) {
            for (NSString *accountFileName in accountFiles) {
                if ([accountFileName.pathExtension isEqualToString:@"json"]) {
                    NSString *accountFilePath = [myAccountsFolderPath stringByAppendingPathComponent:accountFileName];
                    NSData *accountJsonData = [NSData dataWithContentsOfFile:accountFilePath];
                    if (accountJsonData) {
                        NSMutableDictionary *accountDict = [NSJSONSerialization JSONObjectWithData:accountJsonData options:NSJSONReadingMutableContainers error:nil];
                        NSString *accountClientID = accountDict[@"client_id"];
                        NSString *accountCountryCode = accountDict[@"country_code"];
                        NSString *contentsPath = [NSString stringWithFormat:@"%@/%@/%@/%@/app_state_info.txt", directory, [self GetAppName], accountClientID, accountCountryCode];
                        if ([[NSFileManager defaultManager] fileExistsAtPath:contentsPath]) {
                            NSData *fileData = [NSData dataWithContentsOfFile:contentsPath];
                            NSMutableDictionary *fileDict = [NSJSONSerialization JSONObjectWithData:fileData options:NSJSONReadingMutableContainers error:nil];
                            NSString *deviceStatus = fileDict[@"validDevice"];
                            NSDictionary *attributes = [[NSFileManager defaultManager] attributesOfItemAtPath:contentsPath error:nil];
                            NSDateFormatter *dateFormatter = [self getCurrentDateTime];
                            [dateFormatter setDateFormat:@"yyyyMMdd"];
                            NSString *lastModified = [dateFormatter stringFromDate:[attributes fileModificationDate]];
                            NSString *currentDate = [dateFormatter stringFromDate:[NSDate date]];
                            int lastModifiedInt = [lastModified intValue];
                            int currentDateInt = [currentDate intValue];
                            
                            if([deviceStatus isEqualToString:@"nostatus"] || lastModifiedInt != currentDateInt) {
                                if(networkStatus != NotReachable){
                                    [self UpdateAppStateInfo :accountJsonData];
                                } else {
                                    [self HandleAppStateTimer:@"success"];
                                }
                            }else {
                                [self HandleAppStateTimer:@"success"];
                            }
                        }else {
                            if(networkStatus != NotReachable){
                                [self UpdateAppStateInfo :accountJsonData];
                            } else {
                                [self HandleAppStateTimer:@"success"];
                            }
                        }
                    }
                }
            }
        } else {
            NSLog(@"Error in reading my_accounts folder contents: %@", error);
        }
    } else {
        NSLog(@"my_accounts folder not found..");
    }
}

- (void)RotateScreen:(CDVInvokedUrlCommand *)command {
    NSString *args = [[command arguments] objectAtIndex:0];
    if([args isEqualToString:@"landscape"]) {
        [[UIDevice currentDevice] setValue:@(UIInterfaceOrientationLandscapeLeft) forKey:@"orientation"];
        [UINavigationController attemptRotationToDeviceOrientation];
    } else {
        [[UIDevice currentDevice] setValue:@(UIInterfaceOrientationPortrait) forKey:@"orientation"];
        [UINavigationController attemptRotationToDeviceOrientation];
    }
    CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK];
    [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
}

- (void)GetSubDirectoryList:(CDVInvokedUrlCommand *)command {
    BOOL isDir;
    NSString *resultString = @"";
    NSMutableDictionary * dict = [[command arguments] objectAtIndex:0];
    NSString *directory = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES)[0];
    NSString *contentsPath = [NSString stringWithFormat:@"%@/%@", directory, dict[@"filePath"]];
    NSArray *contenstArray = [[NSFileManager defaultManager] contentsOfDirectoryAtPath:contentsPath error:nil];
    NSMutableArray *contenstMutableArray = [contenstArray mutableCopy];
    if ([contenstMutableArray containsObject:@".DS_Store"]) {
        [contenstMutableArray removeObject:@".DS_Store"];
    }
    for(int index = 0; index < [contenstMutableArray count]; index++) {
        if ([[NSFileManager defaultManager] fileExistsAtPath:[contentsPath stringByAppendingPathComponent:contenstMutableArray[index]] isDirectory:&isDir] && isDir) {
            if ([resultString isEqualToString:@""]) {
                resultString = [resultString stringByAppendingString:contenstMutableArray[index]];
            }
            else {
                resultString = [resultString stringByAppendingString:@"|"];
                resultString = [resultString stringByAppendingString:contenstMutableArray[index]];
            }
        }
    }
    CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsString:resultString];
    [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
}

- (void)GetFileList:(CDVInvokedUrlCommand *)command {
    BOOL isDir;
    NSString *resultString = @"";
    NSMutableDictionary * dict = [[command arguments] objectAtIndex:0];
    NSString *directory = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES)[0];
    NSString *contentsPath = [NSString stringWithFormat:@"%@/%@", directory, dict[@"filePath"]];
    NSArray *contenstArray = [[NSFileManager defaultManager] contentsOfDirectoryAtPath:contentsPath error:nil];
    NSMutableArray *contenstMutableArray = [contenstArray mutableCopy];
    if ([contenstMutableArray containsObject:@".DS_Store"]) {
        [contenstMutableArray removeObject:@".DS_Store"];
    }
    for(int index = 0; index < [contenstMutableArray count]; index++) {
        if ([[NSFileManager defaultManager] fileExistsAtPath:[contentsPath stringByAppendingPathComponent:contenstMutableArray[index]] isDirectory:&isDir] && !isDir) {
            if ([resultString isEqualToString:@""]) {
                resultString = [resultString stringByAppendingString:contenstMutableArray[index]];
            }
            else {
                resultString = [resultString stringByAppendingString:@"|"];
                resultString = [resultString stringByAppendingString:contenstMutableArray[index]];
            }
        }
    }
    CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsString:resultString];
    [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
}

- (void)moveFile:(CDVInvokedUrlCommand *)command {
    [self.commandDelegate runInBackground:^{
        @try {
            for(int index = 0; index < [[command arguments] count]; index++) {
                NSMutableDictionary * dict = [[command arguments] objectAtIndex:index];
                NSString *directory = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES)[0];
                NSString *srcPath = dict[@"sourceFilePath"];
                NSString *toPath = [NSString stringWithFormat:@"%@/%@", directory, dict[@"targetFilePath"]];
                NSError *error;
                NSFileManager *fileManager= [NSFileManager defaultManager];
                if (![[NSFileManager defaultManager] fileExistsAtPath:toPath]) {
                    [[NSFileManager defaultManager] createDirectoryAtPath:toPath withIntermediateDirectories:YES attributes:nil error:nil];
                }
                NSString *srcFilePath = [NSString stringWithFormat:@"%@/%@", srcPath, dict[@"sourceFileName"]];
                NSString *destFilePath = [NSString stringWithFormat:@"%@/%@", toPath, dict[@"targetFileName"]];
                if([[NSFileManager defaultManager] fileExistsAtPath:srcFilePath]) {
                    if([fileManager moveItemAtPath:srcFilePath toPath:destFilePath error:&error]==YES)
                    {
                        [fileManager removeItemAtPath:srcFilePath error:nil];
                    }
                } else {
                    CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_ERROR];
                    [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
                }
            }
            CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK];
            [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
        } @catch (NSException *exception) {
            NSLog(@"CopyFile Exception is : %@", exception.description);
        }
    }];
}

- (void)CopyFile:(CDVInvokedUrlCommand *)command {
    [self.commandDelegate runInBackground:^{
        @try {
            for(int index = 0; index < [[command arguments] count]; index++) {
                NSMutableDictionary * dict = [[command arguments] objectAtIndex:index];
                NSString *directory = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES)[0];
                NSString *srcPath = dict[@"sourceFilePath"];
                NSString *toPath = [NSString stringWithFormat:@"%@/%@", directory, dict[@"targetFilePath"]];
                NSError *error;
                if (![[NSFileManager defaultManager] fileExistsAtPath:toPath]) {
                    [[NSFileManager defaultManager] createDirectoryAtPath:toPath withIntermediateDirectories:YES attributes:nil error:nil];
                }
                NSString *srcFilePath = [NSString stringWithFormat:@"%@/%@", srcPath, dict[@"sourceFileName"]];
                NSString *destFilePath = [NSString stringWithFormat:@"%@/%@", toPath, dict[@"targetFileName"]];
                if([[NSFileManager defaultManager] fileExistsAtPath:srcFilePath]) {
                    if([[NSFileManager defaultManager] copyItemAtPath:srcFilePath toPath:destFilePath error:&error]==YES)
                    {
                        NSLog(@"File copied..");
                    }
                } else {
                    CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_ERROR];
                    [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
                }
            }
            [self RemoveFilesFromDirectory];
            CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK];
            [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
        } @catch (NSException *exception) {
            NSLog(@"CopyFile Exception is : %@", exception.description);
        }
    }];
}

- (void)OpenDialPad:(CDVInvokedUrlCommand *)command {
    NSDictionary * dict = [[command arguments] objectAtIndex:0];
    [[UIApplication sharedApplication] openURL:[NSURL URLWithString:[NSString stringWithFormat:@"tel:%@", dict[@"contact_number"]]]];
}

#pragma mark - MFMessageComposeViewControllerDelegate Implementation
// Dismisses the composition interface when users tap Cancel or Send. Proceeds to update the message field with the result of the operation.
- (void)messageComposeViewController:(MFMessageComposeViewController *)controller didFinishWithResult:(MessageComposeResult)result {
    // Notifies users about errors associated with the interface
    int webviewResult = 0;
    NSString* message = @"";
    switch(result) {
        case MessageComposeResultCancelled:
            webviewResult = 0;
            message = @"Message cancelled.";
            break;
        case MessageComposeResultSent:
            webviewResult = 1;
            message = @"Message sent.";
            break;
        case MessageComposeResultFailed:
            webviewResult = 2;
            message = @"Message failed.";
            break;
        default:
            webviewResult = 3;
            message = @"Unknown error.";
            break;
    }
    
    [self.viewController dismissViewControllerAnimated:YES completion:nil];
    
    if(webviewResult == 1) {
        CDVPluginResult* pluginResult = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK
                                                          messageAsString:message];
        
        [self.commandDelegate sendPluginResult:pluginResult callbackId:self.callbackID];
    } else {
        CDVPluginResult* pluginResult = [CDVPluginResult resultWithStatus:CDVCommandStatus_ERROR
                                                          messageAsString:message];

        [self.commandDelegate sendPluginResult:pluginResult callbackId:self.callbackID];
    }
}

- (void)OpenSms:(CDVInvokedUrlCommand *)command {
    self.callbackID = command.callbackId;
    NSDictionary * dict = [[command arguments] objectAtIndex:0];
    MFMessageComposeViewController *picker = [[MFMessageComposeViewController alloc] init];
    picker.messageComposeDelegate = self;
    picker.recipients = [NSArray arrayWithObjects:dict[@"contact_number"], nil];
    picker.body = @"Message text here..";
    
    UIViewController *top = [UIApplication sharedApplication].keyWindow.rootViewController;
    //if(UI_USER_INTERFACE_IDIOM()==UIUserInterfaceIdiomPhone){
        [top presentViewController:picker animated:YES completion: nil];
        self.callbackIdForImagePicker = command.callbackId;
   // }
   // else
   // {
    //    popover=[[UIPopoverController alloc]initWithContentViewController:picker];
    //    CGRect myFrame = [top.view frame];
    //    [popover presentPopoverFromRect:myFrame inView:top.view permittedArrowDirections:UIPopoverArrowDirectionAny animated:YES];
    //}
    //[self presentModalViewController:picker animated:YES];
}

- (void)OpenEmail:(CDVInvokedUrlCommand *)command {
    NSDictionary * dict = [[command arguments] objectAtIndex:0];
    NSString *mailString = [NSString stringWithFormat:@"mailto:%@?subject=%@&body=%@", dict[@"toEmail"], dict[@"subject"], dict[@"body"]];
    #define URLEMail mailString

    NSString *url = [URLEMail stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding];
    [[UIApplication sharedApplication]  openURL: [NSURL URLWithString: url]];
}

- (void)CheckAutomaticTime:(CDVInvokedUrlCommand *)command {
    CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsString:@"true"];
    [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
}

-(void)KillBackgroundExecutions:(CDVInvokedUrlCommand*)command {
    [self.commandDelegate runInBackground:^{
        @try {
            [self KillTimers];
            CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsString:@"Timers killed."];
            [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
        } @catch (NSException *exception) {
            CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_ERROR messageAsString:@"Failed in killing timers."];
            [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
        }
    }];
}

- (void)HasPermission:(CDVInvokedUrlCommand *)command {
    BOOL enabled = NO;
    UIApplication *application = [UIApplication sharedApplication];

    if ([[UIApplication sharedApplication] respondsToSelector:@selector(registerUserNotificationSettings:)]) {
        enabled = application.currentUserNotificationSettings.types != UIUserNotificationTypeNone;
    } else {
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
        enabled = application.enabledRemoteNotificationTypes != UIRemoteNotificationTypeNone;
#pragma GCC diagnostic pop
    }

    NSMutableDictionary* message = [NSMutableDictionary dictionaryWithCapacity:1];
    [message setObject:[NSNumber numberWithBool:enabled] forKey:@"isEnabled"];
    CDVPluginResult *commandResult = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsDictionary:message];
    [self.commandDelegate sendPluginResult:commandResult callbackId:command.callbackId];
}

- (void)GrantPermission:(CDVInvokedUrlCommand *)command {
    if (floor(NSFoundationVersionNumber) <= NSFoundationVersionNumber_iOS_9_x_Max) {
        if ([[UIApplication sharedApplication]respondsToSelector:@selector(registerUserNotificationSettings:)]) {
            UIUserNotificationType notificationTypes =
            (UIUserNotificationTypeSound | UIUserNotificationTypeAlert | UIUserNotificationTypeBadge);
            UIUserNotificationSettings *settings = [UIUserNotificationSettings settingsForTypes:notificationTypes categories:nil];
            [[UIApplication sharedApplication] registerUserNotificationSettings:settings];
            [[UIApplication sharedApplication] registerForRemoteNotifications];
        } else {
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
            [[UIApplication sharedApplication] registerForRemoteNotificationTypes:(UIRemoteNotificationTypeAlert | UIRemoteNotificationTypeBadge | UIRemoteNotificationTypeSound)];
#pragma GCC diagnostic pop
        }

        CDVPluginResult *pluginResult = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK];
        [self.commandDelegate sendPluginResult:pluginResult callbackId:command.callbackId];

        return;
    }


#if defined(__IPHONE_10_0) && __IPHONE_OS_VERSION_MAX_ALLOWED >= __IPHONE_10_0
    UNAuthorizationOptions authOptions = UNAuthorizationOptionAlert|UNAuthorizationOptionSound|UNAuthorizationOptionBadge;
    [[UNUserNotificationCenter currentNotificationCenter]
        requestAuthorizationWithOptions:authOptions
                      completionHandler:^(BOOL granted, NSError * _Nullable error) {

            if (![NSThread isMainThread]) {
                dispatch_sync(dispatch_get_main_queue(), ^{
                    [[UIApplication sharedApplication] registerForRemoteNotifications];

                    CDVPluginResult *pluginResult = [CDVPluginResult resultWithStatus: granted ? CDVCommandStatus_OK : CDVCommandStatus_ERROR];
                    [self.commandDelegate sendPluginResult:pluginResult callbackId:command.callbackId];
                });
            } else {
                [[UIApplication sharedApplication] registerForRemoteNotifications];
                CDVPluginResult *pluginResult = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK];
                [self.commandDelegate sendPluginResult:pluginResult callbackId:command.callbackId];
            }
        }
    ];
#else
    [[UIApplication sharedApplication] registerForRemoteNotifications];
    CDVPluginResult *pluginResult = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK];
    [self.commandDelegate sendPluginResult:pluginResult callbackId:command.callbackId];
#endif

    return;
}
-(void)DeleteMultipleFiles:(CDVInvokedUrlCommand*)command {
    CDVPluginResult *result = nil;
    NSString *dir = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0];
    for( int index = 0; index < [[command arguments] count]; index++ ) {
        NSString *fullFilePath = [NSString stringWithFormat:@"%@/%@", dir, [[command arguments] objectAtIndex:index]];
        NSFileManager *fileManager = [NSFileManager defaultManager];
        if([fileManager fileExistsAtPath:fullFilePath]) {
            [fileManager removeItemAtPath:fullFilePath error:nil];
        } else {
            result = [CDVPluginResult resultWithStatus:CDVCommandStatus_ERROR messageAsString:@"No file found at the path to delete.."];
            [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
        }
        result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK];
        [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
    }
}
-(void)CopyConfigFile:(CDVInvokedUrlCommand*)command{
    [self.commandDelegate runInBackground:^{
        @try {
            for(int index = 0; index < [[command arguments] count]; index++) {
                NSMutableDictionary * dict = [[command arguments] objectAtIndex:index];
                NSString *directory = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES)[0];
                NSString *toPath = [NSString stringWithFormat:@"%@/%@", directory, dict[@"desPath"]];
                NSError *error;
                if (![[NSFileManager defaultManager] fileExistsAtPath:toPath]) {
                    [[NSFileManager defaultManager] createDirectoryAtPath:toPath withIntermediateDirectories:YES attributes:nil error:nil];
                }
                NSString *srcFilePath = [NSString stringWithFormat:@"%@/%@/%@", directory, dict[@"srcPath"], dict[@"srcFile"]];
                NSString *destFilePath = [NSString stringWithFormat:@"%@/%@/%@", directory, dict[@"desPath"], dict[@"desFile"]];
                if([[NSFileManager defaultManager] fileExistsAtPath:srcFilePath]) {
                    if([[NSFileManager defaultManager] copyItemAtPath:srcFilePath toPath:destFilePath error:&error]==YES)
                    {
                        NSLog(@"File copied..");
                    }
                } else {
                    CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_ERROR messageAsString:[NSString stringWithFormat:@"There is no file at the path of %@/%@", dict[@"srcPath"], dict[@"srcFile"]]];
                    [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
                }
            }
            CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK];
            [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
        } @catch (NSException *exception) {
            NSLog(@"CopyFile Exception is : %@", exception.description);
        }
    }];
}

-(void)CreateDirectory:(CDVInvokedUrlCommand*)command {
    @try {
        NSMutableDictionary * dict = [[command arguments] objectAtIndex:0];
        NSString *dir = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0];
        NSError *error;
        NSString *fullFilePath = [NSString stringWithFormat:@"%@/%@", dir, dict[@"filePath"]];
        NSFileManager *fileManager = [NSFileManager defaultManager];
        if(![fileManager fileExistsAtPath:fullFilePath]) {
            [fileManager createDirectoryAtPath:fullFilePath withIntermediateDirectories:YES attributes:nil error:&error];
        }
        CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK];
        [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
    } @catch (NSException *exception) {
        CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_ERROR messageAsString:@"Failed to write file.."];
        [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
    }
}

-(void)DeleteDirectory:(CDVInvokedUrlCommand*)command {
    @try {
        NSMutableDictionary * dict = [[command arguments] objectAtIndex:0];
        NSString *dir = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0];
        NSError *error;
        NSString *fullFilePath = [NSString stringWithFormat:@"%@/%@", dir, dict[@"filePath"]];
        NSFileManager *fileManager = [NSFileManager defaultManager];
        if([fileManager fileExistsAtPath:fullFilePath]) {
            [fileManager removeItemAtPath:fullFilePath error:&error];
        } else {
            CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsString:@"There is no directory to delete."];
            [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
        }
        CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK];
        [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
    } @catch (NSException *exception) {
        CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_ERROR messageAsString:@"Failed to write file.."];
        [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
    }
}
-(void)CreateFile:(CDVInvokedUrlCommand*)command {
    @try {
        NSMutableDictionary * dict = [[command arguments] objectAtIndex:0];
        NSString *dir = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0];
        NSError *error;
        NSString *fullFilePath = [NSString stringWithFormat:@"%@/%@", dir, dict[@"filePath"]];
        NSFileManager *fileManager = [NSFileManager defaultManager];
        NSString *theFileName = [fullFilePath lastPathComponent];
        NSArray *onlyPath = [fullFilePath componentsSeparatedByString:theFileName];
        if(![fileManager fileExistsAtPath:[onlyPath objectAtIndex:0]]) {
            [fileManager createDirectoryAtPath:[onlyPath objectAtIndex:0] withIntermediateDirectories:YES attributes:nil error:&error];
        }
        NSData *data = [dict[@"data"] dataUsingEncoding:NSUTF8StringEncoding];
        [data writeToFile:fullFilePath atomically:true];
        CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK];
        [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
    } @catch (NSException *exception) {
        CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_ERROR messageAsString:@"Failed to write file.."];
        [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
    }
}

-(void)ReadFile:(CDVInvokedUrlCommand*)command {
    NSMutableDictionary * dict = [[command arguments] objectAtIndex:0];
    NSString *dir = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0];
    NSError *error;
    NSString *fullFilePath = [NSString stringWithFormat:@"%@/%@", dir, dict[@"filePath"]];
    NSFileManager *fileManager = [NSFileManager defaultManager];
    if(![fileManager fileExistsAtPath:fullFilePath]) {
        CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_ERROR messageAsString:@"No file found at the path to read.."];
        [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
    } else {
        NSString *readData = [NSString stringWithContentsOfFile:fullFilePath encoding:NSUTF8StringEncoding error:&error];
        CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsString:readData];
        [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
    }
}
-(void)DeleteFile:(CDVInvokedUrlCommand*)command {
    CDVPluginResult *result = nil;
    NSMutableDictionary * dict = [[command arguments] objectAtIndex:0];
    NSString *dir = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0];
    NSError *error;
    NSString *fullFilePath = [NSString stringWithFormat:@"%@/%@", dir, dict[@"filePath"]];
    NSFileManager *fileManager = [NSFileManager defaultManager];
    if([fileManager fileExistsAtPath:fullFilePath]) {
        [fileManager removeItemAtPath:fullFilePath error:nil];
        result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK];
        [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
    } else {
        result = [CDVPluginResult resultWithStatus:CDVCommandStatus_ERROR messageAsString:@"No file found at the path to delete.."];
        [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
    }
}

-(void)ValidateFile:(CDVInvokedUrlCommand*)command {
    CDVPluginResult *result = nil;
    @try {
        BOOL isEnabled = false;
        NSMutableDictionary * dict = [[command arguments] objectAtIndex:0];
        NSString *dir = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0];
        NSError *error;
        NSString *fullFilePath = [NSString stringWithFormat:@"%@/%@", dir, dict[@"filePath"]];
        NSFileManager *fileManager = [NSFileManager defaultManager];
        if([fileManager fileExistsAtPath:fullFilePath]) {
            isEnabled = true;
        } else {
            isEnabled = false;
        }
        NSString *serviceResult = [NSString stringWithFormat:@"%s", isEnabled ? "true" : "false"];
        result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsString:serviceResult];
        [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
    } @catch (NSException *exception) {
        NSString *fail_reason = [NSString stringWithFormat:@"%@\n%@\n%@",exception.name, exception.reason, exception.description ];
        result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsString:fail_reason];
        [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
        NSLog(@"CheckLocation Exception is : %@", exception.description);
    }
}

-(void)GetStorageRoot:(CDVInvokedUrlCommand*)command {
    NSURL *dirURL = [[NSFileManager defaultManager] URLForDirectory:NSDocumentDirectory
                                                           inDomain:NSUserDomainMask
                                                  appropriateForURL:nil
                                                             create:NO
                                                              error:nil];
    NSString * documentsURL = [NSString stringWithFormat:@"%@", dirURL];
    NSLog(@"File Url : %@", dirURL.absoluteString);
    NSLog(@"documentsURL : %@", documentsURL);
    CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsString:documentsURL];
    [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
}
- (NSString *)pathForURL:(NSString *)urlString
{
    NSURL *documentsURL = [[NSFileManager defaultManager] URLForDirectory:NSDocumentDirectory
                                                                 inDomain:NSUserDomainMask
                                                        appropriateForURL:nil
                                                                   create:NO
                                                                    error:nil];
    NSURL *cafURL = [documentsURL URLByAppendingPathComponent:urlString];
    return cafURL.absoluteString;
}
- (void)UnZip:(CDVInvokedUrlCommand*)command {
    [self.commandDelegate runInBackground:^{
        CDVPluginResult* pluginResult = nil;
        @try {
            NSMutableDictionary * dict = [[command arguments] objectAtIndex:0];
            NSError *error;
            //NSString *zipPath = [self pathForURL:zipURL];
            //NSString *destinationPath = [self pathForURL:destinationURL];
            NSString *dir = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES)objectAtIndex:0];
            NSString *zipPath = [dir stringByAppendingPathComponent: dict[@"filePath"]];
            NSString *destinationPath = [dir stringByAppendingPathComponent: dict[@"destination"]];
            
            if([SSZipArchive unzipFileAtPath:zipPath toDestination:destinationPath overwrite:YES password:nil error:&error delegate:self]) {
                pluginResult = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK];
            } else {
                NSLog(@"%@ - %@", @"Error occurred during unzipping", [error localizedDescription]);
                pluginResult = [CDVPluginResult resultWithStatus:CDVCommandStatus_ERROR messageAsString:@"Error occurred during unzipping"];
            }
        } @catch(NSException* exception) {
            NSLog(@"%@ - %@", @"Error occurred during unzipping", [exception debugDescription]);
            pluginResult = [CDVPluginResult resultWithStatus:CDVCommandStatus_ERROR messageAsString:@"Error occurred during unzipping"];
        }
        
        [self.commandDelegate sendPluginResult:pluginResult callbackId:command.callbackId];
    }];
}

-(void)DownloadFile:(CDVInvokedUrlCommand*)command {
    self.callbackIdForImagePicker = command.callbackId;
    NSMutableDictionary * dict = [[command arguments] objectAtIndex:0];
    NSString *dir = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES)objectAtIndex:0];
    NSString *downloadPath = [dir stringByAppendingPathComponent: dict[@"filePath"]];
    NSString *fileDirectory = [downloadPath stringByDeletingLastPathComponent];
    NSURLRequest *request = [NSURLRequest requestWithURL:[NSURL URLWithString:dict[@"url"]]];
    [NSURLConnection sendAsynchronousRequest:request queue:[NSOperationQueue currentQueue] completionHandler:^(NSURLResponse *response, NSData *data, NSError *error) {
        if (error) {
            CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_ERROR messageAsString:@"Failed to download the file."];
            [self.commandDelegate sendPluginResult:result callbackId:self.callbackIdForImagePicker];
        }
        if (data) {
            NSFileManager * fileManager = [NSFileManager defaultManager];
            if(![fileManager fileExistsAtPath:fileDirectory]) {
                [[NSFileManager defaultManager] createDirectoryAtPath:fileDirectory withIntermediateDirectories:YES attributes:nil error:nil];
            }
            [data writeToFile:downloadPath atomically:YES];
            CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK];
            [self.commandDelegate sendPluginResult:result callbackId:self.callbackIdForImagePicker];
        }
    }];
}

-(void)TriggerAuthIndService:(CDVInvokedUrlCommand*)command {
    InternetConnection *networkReachability = [InternetConnection reachabilityForInternetConnection];
    NetworkStatus networkStatus = [networkReachability currentReachabilityStatus];
    if(networkStatus != NotReachable) {
        NSString *directory = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0];
        NSFileManager *fileManager = [NSFileManager defaultManager];
        NSString *rootFolderPath = [NSString stringWithFormat:@"%@/%@/my_accounts_encrypted.txt", directory, [self GetAppName]];
        NSError *error;
        NSString *myAccountsContents = [NSString stringWithContentsOfFile:rootFolderPath encoding:NSUTF8StringEncoding error:&error];
        NSData *myAccountsData = [myAccountsContents dataUsingEncoding:NSUTF8StringEncoding];
        NSArray *myAccountsArray = [NSJSONSerialization JSONObjectWithData:myAccountsData options: NSJSONReadingMutableContainers error: &error];
        for(int index = 0; index < [myAccountsArray count]; index++) {
            NSString *clientId = [myAccountsArray[index] valueForKey:@"client_id"];
            NSString *countryCode = [myAccountsArray[index] valueForKey:@"country_code"];
            NSString *clientUrl = [myAccountsArray[index] valueForKey:@"client_url"];
            NSString *clientConfigFile = [NSString stringWithFormat:@"%@/%@/%@/%@/client_configuration_encrypted.txt", directory, [self GetAppName], clientId, countryCode];
            @try {
                NSError *jsonError;
                NSString *getKeyApsx = [NSString stringWithFormat:@"%@/common/components/Keys/RetrieveKey.aspx", clientUrl];
                NSString *keyContent = [NSString stringWithFormat:@"{\"client_id\":\"%@\",\"country_code\":\"%@\",\"purposeCode\":\"mobile_address_store\",,\"version\":\"doubleo\"}",clientId, countryCode];
                NSMutableURLRequest *authRequest = [[NSMutableURLRequest alloc] initWithURL:[NSURL URLWithString:getKeyApsx]];
                [authRequest setValue:@"text/json" forHTTPHeaderField:@"Content-type"];
                [authRequest setHTTPMethod : @"POST"];
                [authRequest setHTTPBody : [keyContent dataUsingEncoding:NSUTF8StringEncoding]];
                NSURLResponse *keyResponse;
                NSData *keyResponseData = [NSURLConnection sendSynchronousRequest:authRequest returningResponse:&keyResponse error:&jsonError];
                NSString *responseString = [[NSString alloc] initWithData:keyResponseData encoding:NSUTF8StringEncoding];
                NSData *keyData = [responseString dataUsingEncoding:NSUTF8StringEncoding];
                [keyData writeToFile:clientConfigFile atomically:true];
                CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK];
                [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
            } @catch (NSException *exception) {
                CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK];
                [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
            }
        }
    } else {
        CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK];
        [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
    }
}
- (void)GetCurrentLocation:(CDVInvokedUrlCommand*)command {
    @try {
        self.locationManager = [[CLLocationManager alloc] init];
        [self.locationManager setDelegate:self];
        [self.locationManager setDistanceFilter:kCLDistanceFilterNone];
        [self.locationManager setHeadingFilter:kCLHeadingFilterNone];
        [self.locationManager requestAlwaysAuthorization];
        [self.locationManager requestWhenInUseAuthorization];
        CLAuthorizationStatus status = [CLLocationManager authorizationStatus];
        if (status == kCLAuthorizationStatusAuthorizedAlways) {
            // Location permission is granted, enable background location updates
            if ([[[UIDevice currentDevice] systemVersion] floatValue] >= 9) {
                _locationManager.allowsBackgroundLocationUpdates = YES;
            }
        }
        [self.locationManager startUpdatingLocation];
        double lat = self.locationManager.location.coordinate.latitude;
        double lngt = self.locationManager.location.coordinate.longitude;
        NSString *content = [NSString stringWithFormat:@"%f,%f", lat, lngt];
        CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsString:content];
        [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
    } @catch (NSException *exception) {
        CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_ERROR messageAsString:@"Fetching location failed for GetCurrentLocation"];
        [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
    }
}

- (void)GetUniqueDeviceId:(CDVInvokedUrlCommand*)command {
    [self.commandDelegate runInBackground:^{
        NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
        NSString *uuidUserDefaults = [defaults objectForKey:@"uuid"];
        NSString *uuid = [UICKeyChainStore stringForKey:@"uuid"];
        if ( uuid && !uuidUserDefaults) {
            [defaults setObject:uuid forKey:@"uuid"];
            [defaults synchronize];
        }  else if ( !uuid && !uuidUserDefaults ) {
            NSString *uuidString = [[NSUUID UUID] UUIDString];
            [UICKeyChainStore setString:uuidString forKey:@"uuid"];
            [defaults setObject:uuidString forKey:@"uuid"];
            [defaults synchronize];
            uuid = [UICKeyChainStore stringForKey:@"uuid"];
        } else if ( ![uuid isEqualToString:uuidUserDefaults] ) {
            [UICKeyChainStore setString:uuidUserDefaults forKey:@"uuid"];
            uuid = [UICKeyChainStore stringForKey:@"uuid"];
        }
        CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsString:uuid];
        [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
    }];
}

-(void)GetPermissions:(CDVInvokedUrlCommand*)command {
    CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK];
    [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
}

-(void)CheckLocationPermission:(CDVInvokedUrlCommand*)command {
    CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK];
    [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
}

- (void)SendLocation {
    [self.commandDelegate runInBackground:^{
        @try {
            NSString *directory = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0];
            NSString *locationFilePath = [NSString stringWithFormat:@"%@/%@/MyLocation_encrypted.txt", directory, [self GetAppName]];
            NSString *lastKnownPath = [NSString stringWithFormat:@"%@/%@/last_known_location.txt", directory, [self GetAppName]];
            NSData *fileContents = [[NSData alloc] init];
            NSFileManager *filemanager = [NSFileManager defaultManager];
            if([filemanager fileExistsAtPath:locationFilePath] != YES){
                [fileContents writeToFile:locationFilePath atomically:true];
            }
            double lat = self.locationManager.location.coordinate.latitude;
            double lngt = self.locationManager.location.coordinate.longitude;
            NSDateFormatter *dateFormatter = [self getCurrentDateTime];
            [dateFormatter setDateFormat:@"yyyyMMddHHmmss"];
            NSString *content = [NSString stringWithFormat:@"%f,%f,%@\n", lat, lngt, [dateFormatter stringFromDate:[NSDate date]]];
            //Appending Locations in MyLocation.txt file
            NSFileHandle *myLocationFileHandle = [NSFileHandle fileHandleForWritingAtPath:locationFilePath];
            [myLocationFileHandle seekToEndOfFile];
            [myLocationFileHandle writeData:[content dataUsingEncoding:NSUTF8StringEncoding]];
            [myLocationFileHandle closeFile];
            //Updating Locations in LastKnownLocation.txt file
            NSData *lastKnownLocationData = [content dataUsingEncoding:NSUTF8StringEncoding];
            [lastKnownLocationData writeToFile:lastKnownPath atomically:true];
            InternetConnection *networkReachability = [InternetConnection reachabilityForInternetConnection];
            NetworkStatus networkStatus = [networkReachability currentReachabilityStatus];
            if(networkStatus == NotReachable){
            } else {
                NSError *error;
                NSString *myAccountsFolderPath = [NSString stringWithFormat:@"%@/%@/%@", directory, [self GetAppName], @"my_accounts"];
                NSFileManager *fileManager = [NSFileManager defaultManager];
                if([fileManager fileExistsAtPath:myAccountsFolderPath]) {
                    NSArray *files = [fileManager contentsOfDirectoryAtPath:myAccountsFolderPath error:&error];
                    if (files) {
                        NSMutableArray *myAccountsArray = [NSMutableArray array];
                        for (NSString *fileName in files) {
                            if ([fileName.pathExtension isEqualToString:@"json"]) {
                                NSString *filePath = [myAccountsFolderPath stringByAppendingPathComponent:fileName];
                                NSData *jsonData = [NSData dataWithContentsOfFile:filePath];
                                if (jsonData) {
                                    NSError *jsonError;
                                    NSDictionary *jsonDict = [NSJSONSerialization JSONObjectWithData:jsonData options:NSJSONReadingMutableContainers error:&jsonError];
                                    if (!jsonError && jsonDict) {
                                        [myAccountsArray addObject:jsonDict];
                                    } else {
                                        NSLog(@"Error parsing JSON file %@: %@", fileName, jsonError);
                                    }
                                }
                            }
                        }
                        for( int index = 0; index < [myAccountsArray count]; index++ ) {
                            NSString *locationUpdateInd = [myAccountsArray[index] valueForKey:@"location_update_ind"];
                            if([locationUpdateInd isEqual: @"true"]) {
                                NSString *clientId = [myAccountsArray[index] valueForKey:@"client_id"];
                                NSString *countryCode = [myAccountsArray[index] valueForKey:@"country_code"];
                                NSString *clientUrl = [myAccountsArray[index] valueForKey:@"client_url"];
                                NSString *locationData = [NSString stringWithContentsOfFile:locationFilePath encoding:NSUTF8StringEncoding error:&error];
                                NSString *baseURL = [NSString stringWithFormat:@"%@/common/components/GeoLocation/update_device_location_offline.aspx", clientUrl];
                                NSString *content = [NSString stringWithFormat:@"<location_xml><client_id>%@</client_id><country_code>%@</country_code><device_id>%@</device_id><location>%@</location></location_xml>", clientId, countryCode, deviceID, locationData];
                                NSData *inputData = [content dataUsingEncoding:NSUTF8StringEncoding];
                                NSMutableURLRequest *request = [[NSMutableURLRequest alloc] initWithURL:[NSURL URLWithString:baseURL]];
                                [request setValue:@"text/xml" forHTTPHeaderField:@"Content-type"];
                                [request setHTTPMethod : @"POST"];
                                [request setHTTPBody : inputData];
                                NSError *jsonError;
                                NSURLResponse *response = nil;
                                            //[NSURLConnection connectionWithRequest:fileRequest delegate:self];
                                            NSData *responseData = [NSURLConnection sendSynchronousRequest:request returningResponse:&response error:&jsonError];
                                            NSString *responseString = [[NSString alloc] initWithData:responseData encoding:NSUTF8StringEncoding];
                                
                            } else {
                                NSLog(@"The locationUpdateInd indication is set to false");
                            }
                        }
                        // Emptying the text file
                        [[NSData data] writeToFile:locationFilePath atomically:true];

                        
                    }else{
                            NSLog(@"Error in reading files: %@", error);
                    }
                }else {
                    NSLog(@"File not available at the path..");
                }
            }
        } @catch (NSException *exception) {
            NSLog(@"SendLocation Exception is : %@", exception.description);
        }
    }];
}


- (void)GetLocation:(CDVInvokedUrlCommand*)command
{
    [self.commandDelegate runInBackground:^{
        CDVPluginResult *result = nil;
        @try {
            NSString * directory = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0];
            NSString * filePath = [NSString stringWithFormat:@"%@/%@%@",directory,[self GetAppName],@"/last_known_location.txt"];
            NSError * error;
            NSString * locationData = [NSString stringWithContentsOfFile:filePath encoding:NSUTF8StringEncoding error:&error];
            NSArray * mySplit = [locationData componentsSeparatedByString:@","];
            NSString * locationString = [NSString stringWithFormat:@"{\"lat\":\"%@\",\"lon\":\"%@\"}", [mySplit objectAtIndex:0], [mySplit objectAtIndex:1]];
            result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsString:locationString];
            [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
        } @catch (NSException * exception) {
            NSString * failReason = [NSString stringWithFormat:@"%@\n%@\n%@",exception.name, exception.reason, exception.description ];
            result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsString:failReason];
            [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
        }
    }];
}

- (void)timeReader
{
    [self.commandDelegate runInBackground:^{
        @try {
            NSString *docdir = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0];
            NSString *folderPath = [NSString stringWithFormat:@"%@/%@/time_profile_encrypted.txt", docdir, [self GetAppName]];
            NSData *data = [NSData dataWithContentsOfFile:folderPath];
            NSError *jsonError = nil;
            NSMutableDictionary * dict = [NSJSONSerialization JSONObjectWithData:data options:NSJSONReadingMutableContainers error:&jsonError];
            NSString *serverDate = dict[@"serverDate"];
            NSDateFormatter * dateFormatter = [self getCurrentDateTime];
            [dateFormatter setDateFormat:@"yyyy,MM,dd,HH,mm,ss"];
            NSDate *date = [dateFormatter dateFromString:serverDate];
            NSDate *addedDate = [date dateByAddingTimeInterval:(1*60)];
            NSString *dateString = [dateFormatter stringFromDate:addedDate];
            dict[@"serverDate"] = dateString;
            NSLog(@"Time from timeReader : %@", dict[@"serverDate"]);
            NSData *fileContents = [NSJSONSerialization dataWithJSONObject:dict options:NSJSONWritingPrettyPrinted error:nil];
            [fileContents writeToFile:folderPath atomically:true];
        } @catch (NSException *exception) {
            NSLog(@"timeReader Exception is : %@", exception.description);
        }
    }];
}

- (void)CheckSumIndicatorResult {
    [self.commandDelegate runInBackground:^{
        @try
        {
            InternetConnection *networkReachability = [InternetConnection reachabilityForInternetConnection];
            NetworkStatus networkStatus = [networkReachability currentReachabilityStatus];
            if(networkStatus != NotReachable){
                NSString *directory = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0];
                NSString *rootFolderPath = [NSString stringWithFormat:@"%@/%@/my_accounts_encrypted.txt", directory, [self GetAppName]];
                NSError *error = nil;
                NSString *myAccountsContents = [NSString stringWithContentsOfFile:rootFolderPath encoding:NSUTF8StringEncoding error:&error];
                NSData *myAccountsData = [myAccountsContents dataUsingEncoding:NSUTF8StringEncoding];
                NSArray *myAccountsArray = [NSJSONSerialization JSONObjectWithData:myAccountsData options: NSJSONReadingMutableContainers error: &error];
                for(int index = 0; index < [myAccountsArray count]; index++) {
                    NSString *clientId = [myAccountsArray[index] valueForKey:@"client_id"];
                    NSString *countryCode = [myAccountsArray[index] valueForKey:@"country_code"];
                    NSString *userId = [myAccountsArray[index] valueForKey:@"user_id"];
                    NSString *empId = [myAccountsArray[index] valueForKey:@"employee_id"];
                    NSString *sessionId = [myAccountsArray[index] valueForKey:@"session_id"];
                    NSString *localeId = [myAccountsArray[index] valueForKey:@"locale_id"];
                    NSString *clientUrl = [myAccountsArray[index] valueForKey:@"client_url"];
                    NSString *request_path = [NSString stringWithFormat:@"%@/JSONServiceEndpoint.aspx?appName=common_modules&serviceName=retrieve_listof_values_for_searchcondition&path=context/outputparam", clientUrl];
                    NSString *checkSumPath = [NSString stringWithFormat:@"%@/%@/%@/%@/database/checksum_value_encrypted.txt", directory, [self GetAppName], clientId, countryCode];
                    NSLog(@"checkSum Path %@", checkSumPath);
                    NSData *data = [NSData dataWithContentsOfFile:checkSumPath];
                    NSString *checksum_value, *refresh_ind;
                    NSFileManager *fileManager = [NSFileManager defaultManager];
                    if([fileManager fileExistsAtPath:checkSumPath] == YES){
                        NSMutableDictionary *dict = [NSJSONSerialization JSONObjectWithData:data options:NSJSONReadingMutableContainers error:&error];
                        checksum_value = dict[@"checksum_value"];
                        refresh_ind = dict[@"refresh_ind"];
                    } else {
                        checksum_value = @"";
                        refresh_ind = @"";
                    }
                    if([refresh_ind isEqual: @""] || [refresh_ind isEqual:@"false"]){
                        NSString *content = [NSString stringWithFormat:@"{\"context\":{\"sessionId\":\"%@\",\"userId\":\"%@\",\"client_id\":\"%@\",\"locale_id\":\"%@\",\"country_code\":\"%@\",\"inputparam\":{\"p_inputparam_xml\":\"<inputparam><lov_code_type>VALIDATE_CHECKSUM</lov_code_type><search_field_1>%@</search_field_1><search_field_2>%@</search_field_2><search_field_3>MOBILE</search_field_3></inputparam>\"}}}",sessionId, userId, clientId, localeId, countryCode, checksum_value, empId];
                        NSData *data = [content dataUsingEncoding:NSUTF8StringEncoding];
                        NSMutableURLRequest *request = [[NSMutableURLRequest alloc] initWithURL:[NSURL URLWithString:request_path]];
                        [request setValue:@"text/json" forHTTPHeaderField:@"Content-type"];
                        [request setHTTPMethod : @"POST"];
                        [request setHTTPBody : data];
                        NSURLResponse *response;
                        NSData *responseData = [NSURLConnection sendSynchronousRequest:request returningResponse:&response error:&error];
                        NSString *responseString = [[NSString alloc] initWithData:responseData encoding:NSUTF8StringEncoding];
                        NSString *replacedString = responseString;
                        replacedString = [replacedString stringByReplacingOccurrencesOfString:@"[" withString:@""];
                        replacedString = [replacedString stringByReplacingOccurrencesOfString:@"]" withString:@""];
                        NSData *finalCheckSumData = [replacedString dataUsingEncoding:NSUTF8StringEncoding];
                        NSDictionary *json = [[NSDictionary alloc] init];
                        json = [NSJSONSerialization JSONObjectWithData:finalCheckSumData options:kNilOptions error:&error];
                        //Check if it is valid JSON or not
                        if ([NSJSONSerialization JSONObjectWithData:finalCheckSumData
                                                            options:kNilOptions
                                                              error:&error] == nil) {
                        } else {
                            //Check given response is valid Checksum data or Exception..
                            if([json objectForKey:@"refresh_ind"]){
                                [finalCheckSumData writeToFile:checkSumPath atomically:true];
                                NSString *date, *hour, *minute;
                                NSData *responseJson = [replacedString dataUsingEncoding:NSUTF8StringEncoding];
                                NSMutableDictionary * dictionary = [NSJSONSerialization JSONObjectWithData:responseJson options:NSJSONReadingMutableContainers error:&error];
                                date = [NSString stringWithFormat:@"%@", dictionary[@"serverDate"]];
                                hour = [NSString stringWithFormat:@"%@", dictionary[@"serverHour"]];
                                minute = [NSString stringWithFormat:@"%@", dictionary[@"serverMinute"]];
                                [self timeValues:date hour:hour minute:minute];
                            }
                        }
                    }
                }
            }
        } @catch (NSException *exception) {
            NSLog(@"CheckSumIndicatorResult Exception is : %@", exception.description);
        }
    }];
}

- (void)RefreshTimeProfile:(CDVInvokedUrlCommand*)command
{
    @try {
        [self.commandDelegate runInBackground:^{
            NSMutableDictionary * dict = [[command arguments] objectAtIndex:0];
            NSString *date = dict[@"serverDate"];
            NSString *hour = dict[@"serverHour"];
            NSString *minute = dict[@"serverMinute"];
            [self timeValues:date hour:hour minute:minute];
            CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK];
            [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
        }];
    } @catch (NSException *exception) {
        NSLog(@"RefreshTimeProfile Exception is : %@", exception.description);
    }
}

-(void)timeValues:(NSString *)date hour:(NSString *)hour minute:(NSString *)minute
{
    @try {
        NSString *serverDate = [NSString stringWithFormat:@"%@,%@,%@,00", date, hour, minute];
        NSDateFormatter * dateFormatter = [self getCurrentDateTime];
        [dateFormatter setDateFormat:@"yyyy,MM,dd,HH,mm,ss"];
        NSDate *getDate = [dateFormatter dateFromString:serverDate];
        NSString *deviceDate = [dateFormatter stringFromDate:[NSDate date]];
        NSString *finalServerDate = [dateFormatter stringFromDate:getDate];
        NSMutableDictionary * dictionary = [[NSMutableDictionary alloc] init];
        [dictionary setValue:finalServerDate forKey:@"serverDate"];
        [dictionary setValue:finalServerDate forKey:@"initServerDate"];
        [dictionary setValue:deviceDate forKey:@"initDeviceDate"];
        NSString *docdir = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0];
        NSString *time_profile = [NSString stringWithFormat:@"%@/%@/time_profile_encrypted.txt", docdir, [self GetAppName]];
        NSLog(@"time profile path : %@", time_profile);
        NSData *fileContents = [NSJSONSerialization dataWithJSONObject:dictionary options:0 error:nil];
        [fileContents writeToFile:time_profile atomically:true];
    } @catch (NSException *exception) {
        NSLog(@"timeValues Exception is : %@", exception.description);
    }
}

- (id)getCurrentDateTime {
    NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init];
    NSLocale *locale = [[NSLocale alloc]
                        initWithLocaleIdentifier:@"US"];
    [dateFormatter setLocale:locale];
    return dateFormatter;
}

- (void)GetNewDate:(CDVInvokedUrlCommand*)command
{
    @try {
        [self.commandDelegate runInBackground:^{
            NSString *docdir = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0];
            NSString *time_profile = [NSString stringWithFormat:@"%@/%@/time_profile_encrypted.txt", docdir,[self GetAppName]];
            NSData *user_data = [NSData dataWithContentsOfFile:time_profile];
            NSError *jsonError = nil;
            NSMutableDictionary * dict = [NSJSONSerialization JSONObjectWithData:user_data options:NSJSONReadingMutableContainers error:&jsonError];
            NSString *serverDateString = dict[@"serverDate"];
            NSDateFormatter * dateFormatter = [self getCurrentDateTime];
            [dateFormatter setDateFormat:@"yyyy,MM,dd,HH,mm,ss"];
            NSDate *deviceDate = [NSDate date];
            NSDate *serverDate = [dateFormatter dateFromString:serverDateString];
            NSTimeInterval timeDifference = [deviceDate timeIntervalSinceDate:serverDate];
            NSLog(@"%f", timeDifference);
            //NSTimeInterval timeDiff = [deviceDate timeIntervalSinceReferenceDate] - [getDate timeIntervalSinceReferenceDate];
            if(timeDifference > 0){
                serverDate = [serverDate dateByAddingTimeInterval:timeDifference];
            }
            NSString *finalServerDate = [dateFormatter stringFromDate:serverDate];
            NSLog(@"finalServerDate : %@", finalServerDate);
            CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsString:finalServerDate];
            [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
        }];
    } @catch (NSException *exception) {
        NSLog(@"GetNewDate Exception is : %@", exception.description);
    }
}

- (void)CheckLocation:(CDVInvokedUrlCommand*)command
{
    [self.commandDelegate runInBackground:^{
        CDVPluginResult *result = nil;
        @try {
            BOOL isEnabled = false;
            if([CLLocationManager locationServicesEnabled] &&
               [CLLocationManager authorizationStatus] != kCLAuthorizationStatusDenied)
            {
                isEnabled = true;
            } else {
                isEnabled = false;
            }
            NSString *serviceResult = [NSString stringWithFormat:@"%s", isEnabled ? "true" : "false"];
            result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsString:serviceResult];
            [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
        } @catch (NSException *exception) {
            NSString *fail_reason = [NSString stringWithFormat:@"%@\n%@\n%@",exception.name, exception.reason, exception.description ];
            result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsString:fail_reason];
            [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
            NSLog(@"CheckLocation Exception is : %@", exception.description);
        }
    }];
}

- (void)CopyAttachmentFile:(CDVInvokedUrlCommand*)command {
    [self.commandDelegate runInBackground:^{
        @try {
            for(int index = 0; index < [[command arguments] count]; index++) {
                NSMutableDictionary * dict = [[command arguments] objectAtIndex:index];
                NSString *directory = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES)[0];
                NSString *srcPath = dict[@"srcPath"];
                NSString *toPath = [NSString stringWithFormat:@"%@/%@", directory, dict[@"desPath"]];
                NSString *queueAttachPath = [NSString stringWithFormat:@"%@/%@", directory, dict[@"queueAttachPath"]];
                NSError *error;
                if (![[NSFileManager defaultManager] fileExistsAtPath:toPath]) {
                    [[NSFileManager defaultManager] createDirectoryAtPath:toPath withIntermediateDirectories:YES attributes:nil error:nil];
                }
                if (![[NSFileManager defaultManager] fileExistsAtPath:queueAttachPath]){
                    [[NSFileManager defaultManager] createDirectoryAtPath:queueAttachPath withIntermediateDirectories:YES attributes:nil error:nil];
                }
                NSString *srcFilePath = [NSString stringWithFormat:@"%@/%@", srcPath, dict[@"srcFile"]];
                NSString *destFilePath = [NSString stringWithFormat:@"%@/%@", toPath, dict[@"desFile"]];
                NSString *queueAttachCopyPath = [NSString stringWithFormat:@"%@/%@", queueAttachPath, dict[@"desFile"]];
                if([[NSFileManager defaultManager] fileExistsAtPath:srcFilePath]) {
                    if([[NSFileManager defaultManager] copyItemAtPath:srcFilePath toPath:destFilePath error:&error]==YES)
                    {
                        NSLog(@"File copied..");
                    }
                    if([[NSFileManager defaultManager] copyItemAtPath:srcFilePath toPath:queueAttachCopyPath error:&error]==YES)
                    {
                        NSLog(@"File copied..");
                    }
                } else {
                    CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_ERROR];
                    [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
                }
            }
            [self RemoveFilesFromDirectory];
            CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK];
            [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
        } @catch (NSException *exception) {
            NSLog(@"CopyFile Exception is : %@", exception.description);
        }
    }];
}

- (void)GetSyncIndicator:(CDVInvokedUrlCommand*)command
{
    CDVPluginResult *result = nil;
    @try {
        NSMutableDictionary * dict = [[command arguments] objectAtIndex:0];
        NSString *client_id = dict[@"client_id"];
        NSString *country_code = dict[@"country_code"];
        NSString *user_id = dict[@"user_id"];
        NSString *client_url = dict[@"client_url"];
        BOOL isEnabled = false;
        NSString *requestUrl = [NSString stringWithFormat:@"%@/common/components/QueueManager/GetSyncInd.aspx?client_id=%@&country_code=%@&user_id=%@", client_url, client_id, country_code, user_id];
        NSString *returnedIndication = @"";
        NSString *directory = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES)[0];
        NSString *oldQueuePath = [NSString stringWithFormat:@"%@/%@/database/queue", directory,[self GetAppName]];
        NSString *newQueuePath = [NSString stringWithFormat:@"%@/%@/%@/%@/database/queue", directory,[self GetAppName], client_id, country_code];
        NSFileManager *fileManager = [NSFileManager defaultManager];
        if ([fileManager fileExistsAtPath:oldQueuePath]) {
            NSArray *oldQueueFiles = [fileManager contentsOfDirectoryAtPath:oldQueuePath error:nil];
            NSMutableArray *oldQueueFilesMut = [oldQueueFiles mutableCopy];
            if ([oldQueueFilesMut containsObject:@".DS_Store"]) {
                [oldQueueFilesMut removeObject:@".DS_Store"];
            }
            if (oldQueueFilesMut == nil || [oldQueueFilesMut count] == 0) {
                isEnabled = true;
            }
        } else {
            isEnabled = true;
        }
        if (isEnabled) {
            if ([fileManager fileExistsAtPath:newQueuePath]) {
                NSArray *newQueueFiles = [fileManager contentsOfDirectoryAtPath:newQueuePath error:nil];
                NSMutableArray *newQueueFilesMut = [newQueueFiles mutableCopy];
                if ([newQueueFilesMut containsObject:@".DS_Store"]) {
                    [newQueueFilesMut removeObject:@".DS_Store"];
                }
                if (newQueueFilesMut == nil || [newQueueFilesMut count] != 0) {
                    isEnabled = false;
                }
            }
        }
        if (isEnabled) {
            NSMutableURLRequest *request = [[NSMutableURLRequest alloc] initWithURL:[NSURL URLWithString:requestUrl]];
            [request setValue:@"application/text" forHTTPHeaderField:@"Content-type"];
            [request setHTTPMethod : @"POST"];
            //Get Response from url
            NSURLResponse *response;
            NSError *responseError;
            NSData *responseData = [NSURLConnection sendSynchronousRequest:request returningResponse:&response error:&responseError];
            NSString *responseString = [[NSString alloc] initWithData:responseData encoding:NSUTF8StringEncoding];
            returnedIndication = responseString;
            if([returnedIndication isEqualToString:@"true"]) {
                isEnabled = true;
            } else {
                isEnabled = false;
            }
        }
        NSString *serviceResult = [NSString stringWithFormat:@"%s", isEnabled ? "true" : "false"];
        result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsString:serviceResult];
        [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
    } @catch (NSException *exception) {
        NSString *fail_reason = [NSString stringWithFormat:@"%@\n%@\n%@",exception.name, exception.reason, exception.description ];
        result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsString:fail_reason];
        [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
        NSLog(@"CheckLocation Exception is : %@", exception.description);
    }
}

- (void)FileChooser:(CDVInvokedUrlCommand*)command
{
    //[self.commandDelegate runInBackground:^{
        ipc= [[UIImagePickerController alloc] init];
        /*if(![UIImagePickerController isSourceTypeAvailable:UIImagePickerControllerSourceTypeCamera]){
            return;
        }*/
        ipc.delegate = self;
        ipc.sourceType = UIImagePickerControllerSourceTypePhotoLibrary;
        UIViewController *top = [UIApplication sharedApplication].keyWindow.rootViewController;
       // if(UI_USER_INTERFACE_IDIOM()==UIUserInterfaceIdiomPhone) {
            [top presentViewController:ipc animated:YES completion: nil];
            self.callbackIdForImagePicker = command.callbackId;
       // } else {
          //  popover=[[UIPopoverController alloc]initWithContentViewController:imagePicker];
        //    CGRect myFrame = [top.view frame];
         //   [popover presentPopoverFromRect:myFrame inView:top.view permittedArrowDirections:UIPopoverArrowDirectionAny animated:YES];
        //}
    //}];
}

- (NSString *)contentTypeForImageData:(NSString *)string
{
    NSString *c;
    if ([string isEqualToString:@"jpg"]){
        c = @"image/jpeg";
    } else if ([string isEqualToString:@"png"]) {
        c = @"image/png";
    } else if ([string isEqualToString:@"gif"]){
        c = @"image/gif";
    } else if ([string isEqualToString:@"pdf"]){
        c = @"application/pdf";
    } else if ([string isEqualToString:@"txt"]){
        c = @"application/txt";
    }
    return c;
}

- (void)CaptureFromCamera:(CDVInvokedUrlCommand*)command {
    liveCamera= [[UIImagePickerController alloc] init];
    if(![UIImagePickerController isSourceTypeAvailable:UIImagePickerControllerSourceTypeCamera]){
        return;
    }
    liveCamera.delegate = self;
    liveCamera.sourceType = UIImagePickerControllerSourceTypeCamera;
    UIViewController *top = [UIApplication sharedApplication].keyWindow.rootViewController;
    //if(UI_USER_INTERFACE_IDIOM()==UIUserInterfaceIdiomPhone) {
        [top presentViewController:liveCamera animated:YES completion: nil];
        self.callbackIdForImagePicker = command.callbackId;
   // } else {
   //     popover=[[UIPopoverController alloc]initWithContentViewController:liveCamera];
   //     CGRect myFrame = [top.view frame];
   //     [popover presentPopoverFromRect:myFrame inView:top.view permittedArrowDirections:UIPopoverArrowDirectionAny animated:YES];
    //}
}

- (void)CaptureImageFromCamera:(CDVInvokedUrlCommand*)command {
    NSMutableDictionary *inputObject = [[command arguments] objectAtIndex:0];
    imageAttachmentInd = inputObject[@"attachmentInd"];
    imageDestinationPath = inputObject[@"destinationPath"];
    cameraOpen= [[UIImagePickerController alloc] init];
    if(![UIImagePickerController isSourceTypeAvailable:UIImagePickerControllerSourceTypeCamera]){
        return;
    }
    cameraOpen.delegate = self;
    cameraOpen.sourceType = UIImagePickerControllerSourceTypeCamera;
    UIViewController *top = [UIApplication sharedApplication].keyWindow.rootViewController;
   // if(UI_USER_INTERFACE_IDIOM()==UIUserInterfaceIdiomPhone) {
        [top presentViewController:cameraOpen animated:YES completion: nil];
        self.callbackIdForImagePicker = command.callbackId;
   // } else {
   ///     popover=[[UIPopoverController alloc]initWithContentViewController:cameraOpen];
      //  CGRect myFrame = [top.view frame];
        //[popover presentPopoverFromRect:myFrame inView:top.view permittedArrowDirections:UIPopoverArrowDirectionAny animated:YES];
    // }
}

- (void)PickImageFromGallery:(CDVInvokedUrlCommand*)command {
    NSMutableDictionary *inputObject = [[command arguments] objectAtIndex:0];
    imageAttachmentInd = inputObject[@"attachmentInd"];
    imageDestinationPath = inputObject[@"destinationPath"];
    imagePicker= [[UIImagePickerController alloc] init];
    /*if(![UIImagePickerController isSourceTypeAvailable:UIImagePickerControllerSourceTypeCamera]){
        return;
    }*/
    imagePicker.delegate = self;
    imagePicker.sourceType = UIImagePickerControllerSourceTypePhotoLibrary;
    UIViewController *top = [UIApplication sharedApplication].keyWindow.rootViewController;
   // if(UI_USER_INTERFACE_IDIOM()==UIUserInterfaceIdiomPhone) {
        [top presentViewController:imagePicker animated:YES completion: nil];
        self.callbackIdForImagePicker = command.callbackId;
   // } else {
      //  popover=[[UIPopoverController alloc]initWithContentViewController:imagePicker];
    //    CGRect myFrame = [top.view frame];
     //   [popover presentPopoverFromRect:myFrame inView:top.view permittedArrowDirections:UIPopoverArrowDirectionAny animated:YES];
    //}
}

-(void)RemoveFilesFromDirectory {
    NSFileManager *fileManager = [NSFileManager defaultManager];
    NSString * directory = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0];
    NSString *imageDir = [NSString stringWithFormat:@"%@/%@/images", directory, [self GetAppName]];
    NSError *error = nil;
    if([fileManager fileExistsAtPath:imageDir]) {
        NSArray *imageFilesArr = [fileManager contentsOfDirectoryAtPath:imageDir error:&error];
        NSMutableArray *imageFilesMutArr = [imageFilesArr mutableCopy];
        if([imageFilesMutArr containsObject:@".DS_Store"]) {
            [imageFilesMutArr removeObject:@".DS_Store"];
        }
        for( int index = 0; index < [imageFilesMutArr count]; index++ ) {
            NSString *currentFile = [NSString stringWithFormat:@"%@/%@", imageDir, imageFilesMutArr[index]];
            [fileManager removeItemAtPath:currentFile error:nil];
        }
    }
}

- (void)SendChatAttachment:(CDVInvokedUrlCommand*)command {
    CDVPluginResult *result = nil;
    @try {
        NSString *statusIndication = @"false";
        NSMutableDictionary *inputObject = [[command arguments] objectAtIndex:0];
        NSString *filePath = inputObject[@"filePath"];
        NSString *serverPath = inputObject[@"serverPath"];
        NSString *fileName = inputObject[@"fileName"];
        NSString *attachURL = [NSString stringWithFormat:@"%@/common/components/msvFileHandler/UploadFiles.aspx?&client_id=%@&country_code=%@&path=%@", clientUrl, clientID, countryCode, serverPath];
        
        statusIndication = [self sendFilesToServer:filePath fileName:fileName requestURL:attachURL];
        if ([statusIndication isEqualToString:@"true"]) {
            NSString *serviceResult = [NSString stringWithFormat:@"%s", "success"];
            result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsString:serviceResult];
        } else {
            NSString *serviceResult = [NSString stringWithFormat:@"%s", "failure"];
            result = [CDVPluginResult resultWithStatus:CDVCommandStatus_ERROR messageAsString:serviceResult];
        }
        
        [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
    } @catch (NSException *exception) {
        NSString *fail_reason = [NSString stringWithFormat:@"%@\n%@\n%@",exception.name, exception.reason, exception.description ];
        result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsString:fail_reason];
        [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
        NSLog(@"CheckLocation Exception is : %@", exception.description);
    }
}

#pragma mark - MapViewDelegate
- (void) locationManager:(CLLocationManager *)manager didUpdateLocations:(NSArray<CLLocation *> *)locations{
    
}
// Error while updating location
- (void) locationManager:(CLLocationManager *)manager didFailWithError:(NSError *)error{
    NSLog(@"%@",error);
}
- (void)locationManager:(CLLocationManager *)manager didUpdateToLocation:(CLLocation *)newLocation fromLocation:(CLLocation *)oldLocation {
    
}
- (void)locationManager:(CLLocationManager *)manager didUpdateHeading:(CLHeading *)newHeading {
    
}
- (void)StartService:(CDVInvokedUrlCommand*)command
{
    @try {
        [self ValidateAppStateInfo];
        self.QueueToServerTimer = [NSTimer scheduledTimerWithTimeInterval:5.0
                                                                   target:self
                                                                 selector:@selector(DespatchQueueMoveToServer)
                                                                 userInfo:nil
                                                                  repeats:YES];
        double locationInterval = 0.0;
        NSString * directory = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0];
        NSFileManager *fileManager = [NSFileManager defaultManager];
        NSString *locConfgFilePath = [NSString stringWithFormat:@"%@/%@/app_controller.json.txt", directory, [self GetAppName]];
        if([fileManager fileExistsAtPath:locConfgFilePath]){
            NSData *user_data = [NSData dataWithContentsOfFile:locConfgFilePath];
            NSError *jsonError = nil;
            NSDictionary *jsonDict = [NSJSONSerialization JSONObjectWithData:user_data options:0 error:&jsonError];
                if (!jsonError) {
                    NSDictionary *locationConfig = jsonDict[@"location_configuration"];
                    if (locationConfig) {
                        NSString *locationFetchInterval = locationConfig[@"location_fetch_interval_in_seconds"];
                        locationInterval = [locationFetchInterval doubleValue];
                        if(locationInterval ==0) {
                    NSLog(@"No location update should not be happnened..");
                } else {
                    self.locationManager = [[CLLocationManager alloc] init];
                    [self.locationManager setDelegate:self];
                    [self.locationManager setDistanceFilter:kCLDistanceFilterNone];
                    [self.locationManager setHeadingFilter:kCLHeadingFilterNone];
                    [self.locationManager requestAlwaysAuthorization];
                    [self.locationManager requestWhenInUseAuthorization];
                    CLAuthorizationStatus status = [CLLocationManager authorizationStatus];
                    if (status == kCLAuthorizationStatusAuthorizedAlways) {
                        // Location permission is granted, enable background location updates
                        if ([[[UIDevice currentDevice] systemVersion] floatValue] >= 9) {
                            _locationManager.allowsBackgroundLocationUpdates = YES;
                        }
                    }
                    [self.locationManager startUpdatingLocation];
                    [self KillTimers];
                    self.LocationTimer = [NSTimer scheduledTimerWithTimeInterval:locationInterval
                                                                        target:self
                                                                        selector:@selector(SendLocation)
                                                                        userInfo:nil
                                                                        repeats:YES];
                }
                } else {
                    NSLog(@"'location_configuration' key not found in JSON.");
                    // Handle the absence of the key as needed.
                }
            } else {
                NSLog(@"Error parsing JSON: %@", jsonError);
                // Handle JSON parsing error as needed.
            }
        } else {
            NSLog(@"There is no location config file..");
        }
        self.timeReaderTimer = [NSTimer scheduledTimerWithTimeInterval:60.0
                                                                target:self
                                                              selector:@selector(timeReader)
                                                              userInfo:nil
                                                               repeats:YES];
    } @catch (NSException *exception) {
        NSLog(@"Exception is : %@", exception.description);
    }
}

- (void)KillTimers {
    if([self.LocationTimer isValid]) {
        [self.LocationTimer invalidate];
    }
    if([self.timeReaderTimer isValid]) {
        [self.timeReaderTimer invalidate];
    }
    if([self.CheckSumTimer isValid]) {
        [self.CheckSumTimer invalidate];
    }
    if([self.QueueToServerTimer isValid]) {
        [self.QueueToServerTimer invalidate];
    }
    if([self.authTimer isValid]) {
        [self.authTimer invalidate];
    }
}

- (void)QueueProcessor:(CDVInvokedUrlCommand*)command {
    [self.commandDelegate runInBackground:^{
        NSString *breakIndication = @"false";
        NSString *statusIndication = @"false";
        CDVPluginResult *result = nil;
        NSString * directory = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0];
        NSError *error;
        NSFileManager *fileManager = [NSFileManager defaultManager];
        NSString *myAccountsFolderPath = [NSString stringWithFormat:@"%@/%@/%@", directory, [self GetAppName], @"my_accounts"];

        if([fileManager fileExistsAtPath:myAccountsFolderPath]) {
             NSArray *files = [fileManager contentsOfDirectoryAtPath:myAccountsFolderPath error:&error];
             if (files) {

                  NSMutableArray *myAccountsArray = [NSMutableArray array];
                  for (NSString *fileName in files) {
                    if ([fileName.pathExtension isEqualToString:@"json"]) {
                        NSString *filePath = [myAccountsFolderPath stringByAppendingPathComponent:fileName];
                        NSData *jsonData = [NSData dataWithContentsOfFile:filePath];
                        if (jsonData) {
                            NSError *jsonError;
                            NSDictionary *jsonDict = [NSJSONSerialization JSONObjectWithData:jsonData options:NSJSONReadingMutableContainers error:&jsonError];
                            if (!jsonError && jsonDict) {
                                [myAccountsArray addObject:jsonDict];
                            } else {
                                NSLog(@"Error parsing JSON file %@: %@", fileName, jsonError);
                            }
                        }
                    }
                }
                 InternetConnection *networkReachability = [InternetConnection reachabilityForInternetConnection];
                NetworkStatus networkStatus = [networkReachability currentReachabilityStatus];
                if(networkStatus != NotReachable) {
                    for( int index = 0; index < [myAccountsArray count]; index++ ) {
                        NSString *clientId = [myAccountsArray[index] valueForKey:@"client_id"];
                        NSString *countryCode = [myAccountsArray[index] valueForKey:@"country_code"];
                        NSString *clientUrl = [myAccountsArray[index] valueForKey:@"client_url"];
                        NSString *userID = [myAccountsArray[index] valueForKey:@"user_id"];
                        NSString *attachFolderPath = [NSString stringWithFormat:@"%@/%@/%@/%@/database/attachments", directory, [self GetAppName], clientId, countryCode];
                        NSString *queueFolderPath = [NSString stringWithFormat:@"%@/%@/%@/%@/database/queue", directory, [self GetAppName], clientId, countryCode];
                        NSArray *attachedFilesArr = [fileManager contentsOfDirectoryAtPath:attachFolderPath error:&error];
                        NSMutableArray *attachedFilesMutArr = [attachedFilesArr mutableCopy];
                        if([attachedFilesMutArr containsObject:@".DS_Store"]) {
                            [attachedFilesMutArr removeObject:@".DS_Store"];
                        }
                        NSString *databasePath = [NSString stringWithFormat:@"%@/%@/%@/%@/database", directory, [self GetAppName], clientId, countryCode];
                        if([fileManager fileExistsAtPath:databasePath]) {
                            for( int attachIndex = 0; attachIndex < [attachedFilesMutArr count]; attachIndex++ ) {
                                NSString * attachedFilesPath = [NSString stringWithFormat:@"%@/%@", attachFolderPath, attachedFilesMutArr[attachIndex]];
                                NSString *attachURL = [NSString stringWithFormat:@"%@/common/components/QueueManager/QueueUpload.aspx?file_path=attachments&client_id=%@&country_code=%@&user_id=%@&file_name=%@", clientUrl, clientId, countryCode, userID, attachedFilesMutArr[attachIndex]];
                                statusIndication = [self sendFilesToServer:attachedFilesPath fileName:attachedFilesMutArr[attachIndex] requestURL:attachURL];
                                if ([statusIndication isEqualToString:@"true"]) {
                                    breakIndication = @"true";
                                    break;
                                }
                            }
                            if ([statusIndication isEqualToString:@"false"]) {
                                NSArray *queueFilesArr = [fileManager contentsOfDirectoryAtPath:queueFolderPath error:&error];
                                NSMutableArray *queueFilesMutArr = [queueFilesArr mutableCopy];
                                if([queueFilesMutArr containsObject:@".DS_Store"]) {
                                    [queueFilesMutArr removeObject:@".DS_Store"];
                                }
                                for( int queueIndex = 0; queueIndex < [queueFilesMutArr count]; queueIndex++ ) {
                                    NSString *queueFilesPath = [NSString stringWithFormat:@"%@/%@", queueFolderPath, queueFilesMutArr[queueIndex]];
                                    NSString *queueURL = [NSString stringWithFormat:@"%@/common/components/QueueManager/QueueUpload.aspx?file_path=queue&client_id=%@&country_code=%@&user_id=%@&file_name=%@", clientUrl, clientId, countryCode, userID, queueFilesMutArr[queueIndex]];
                                    [self sendFilesToServer:queueFilesPath fileName:queueFilesMutArr[queueIndex] requestURL:queueURL];
                                }
                            }
                        } else {
                            NSLog(@"No database directory found at the path..");
                        }
                        if ([breakIndication isEqualToString:@"false"]) {
                            result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK];
                            [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
                        } else {
                            result = [CDVPluginResult resultWithStatus:CDVCommandStatus_ERROR];
                            [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
                        }
                    }
                } else {
                    NSLog(@"No Internet connection..");
                }
             }else{
                    NSLog(@"Error in reading files: %@", error);
             }
        }else {
            result = [CDVPluginResult resultWithStatus:CDVCommandStatus_ERROR];
            [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
        }
    }];
}
-(void)DespatchQueueMoveToServer {
    [self.commandDelegate runInBackground:^{
        NSString *statusIndication = @"false";
        NSString * directory = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0];
        NSError *error;
        NSFileManager *fileManager = [NSFileManager defaultManager];
        
        NSString *myAccountsFolderPath = [NSString stringWithFormat:@"%@/%@/%@", directory, [self GetAppName], @"my_accounts"];

          if([fileManager fileExistsAtPath:myAccountsFolderPath]) {
             NSArray *files = [fileManager contentsOfDirectoryAtPath:myAccountsFolderPath error:&error];
             if (files) {

                  NSMutableArray *myAccountsArray = [NSMutableArray array];
                  for (NSString *fileName in files) {
                    if ([fileName.pathExtension isEqualToString:@"json"]) {
                        NSString *filePath = [myAccountsFolderPath stringByAppendingPathComponent:fileName];
                        NSData *jsonData = [NSData dataWithContentsOfFile:filePath];
                        if (jsonData) {
                            NSError *jsonError;
                            NSDictionary *jsonDict = [NSJSONSerialization JSONObjectWithData:jsonData options:NSJSONReadingMutableContainers error:&jsonError];
                            if (!jsonError && jsonDict) {
                                [myAccountsArray addObject:jsonDict];
                            } else {
                                NSLog(@"Error parsing JSON file %@: %@", fileName, jsonError);
                            }
                        }
                    }
                }
                 InternetConnection *networkReachability = [InternetConnection reachabilityForInternetConnection];
                NetworkStatus networkStatus = [networkReachability currentReachabilityStatus];
                if(networkStatus != NotReachable) {
                    for( int index = 0; index < [myAccountsArray count]; index++ ) {
                        NSString *clientId = [myAccountsArray[index] valueForKey:@"client_id"];
                        NSString *countryCode = [myAccountsArray[index] valueForKey:@"country_code"];
                        NSString *clientUrl = [myAccountsArray[index] valueForKey:@"client_url"];
                        NSString *userID = [myAccountsArray[index] valueForKey:@"user_id"];
                        NSString *attachFolderPath = [NSString stringWithFormat:@"%@/%@/%@/%@/database/attachments", directory, [self GetAppName], clientId, countryCode];
                        NSString *queueFolderPath = [NSString stringWithFormat:@"%@/%@/%@/%@/database/queue", directory, [self GetAppName], clientId, countryCode];
                        NSArray *attachedFilesArr = [fileManager contentsOfDirectoryAtPath:attachFolderPath error:&error];
                        NSMutableArray *attachedFilesMutArr = [attachedFilesArr mutableCopy];
                        if([attachedFilesMutArr containsObject:@".DS_Store"]) {
                            [attachedFilesMutArr removeObject:@".DS_Store"];
                        }
                        NSString *databasePath = [NSString stringWithFormat:@"%@/%@/%@/%@/database", directory, [self GetAppName], clientId, countryCode];
                        if([fileManager fileExistsAtPath:databasePath]) {
                            for( int attachIndex = 0; attachIndex < [attachedFilesMutArr count]; attachIndex++ ) {
                                NSString * attachedFilesPath = [NSString stringWithFormat:@"%@/%@", attachFolderPath, attachedFilesMutArr[attachIndex]];
                                NSString *attachURL = [NSString stringWithFormat:@"%@/common/components/QueueManager/QueueUpload.aspx?file_path=attachments&client_id=%@&country_code=%@&user_id=%@&file_name=%@", clientUrl, clientId, countryCode, userID, attachedFilesMutArr[attachIndex]];
                                statusIndication = [self sendFilesToServer:attachedFilesPath fileName:attachedFilesMutArr[attachIndex] requestURL:attachURL];
                                if ([statusIndication isEqualToString:@"true"]) {
                                    break;
                                }
                            }
                            if ([statusIndication isEqualToString:@"false"]) {
                                NSArray *queueFilesArr = [fileManager contentsOfDirectoryAtPath:queueFolderPath error:&error];
                                NSMutableArray *queueFilesMutArr = [queueFilesArr mutableCopy];
                                if([queueFilesMutArr containsObject:@".DS_Store"]) {
                                    [queueFilesMutArr removeObject:@".DS_Store"];
                                }
                                for( int queueIndex = 0; queueIndex < [queueFilesMutArr count]; queueIndex++ ) {
                                    NSString *queueFilesPath = [NSString stringWithFormat:@"%@/%@", queueFolderPath, queueFilesMutArr[queueIndex]];
                                    NSString *queueURL = [NSString stringWithFormat:@"%@/common/components/QueueManager/QueueUpload.aspx?file_path=queue&client_id=%@&country_code=%@&user_id=%@&file_name=%@", clientUrl, clientId, countryCode, userID, queueFilesMutArr[queueIndex]];
                                    [self sendFilesToServer:queueFilesPath fileName:queueFilesMutArr[queueIndex] requestURL:queueURL];
                                }
                            }
                        } else {
                            NSLog(@"No database directory found at the path..");
                        }
                    }
                } else {
                    NSLog(@"No Internet connection..");
                }
             }else{
                    NSLog(@"Error in reading files: %@", error);
             }
        }else {
            NSLog(@"File not available at the path..");
        }
    }];
}

- (NSString *)sendFilesToServer:(NSString *)filePath fileName:(NSString *)fileName requestURL:(NSString *) requestURL {
    NSString *statusIndication = @"false";
    @try {
        if ([[NSFileManager defaultManager] fileExistsAtPath:filePath]){
            NSFileManager *fileManager = [NSFileManager defaultManager];
            NSError *jsonError;
            NSString *urlString =[NSString stringWithFormat:@"%@", requestURL];
            NSURL *url=[NSURL URLWithString:[[NSString stringWithFormat:@"%@", urlString] stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding]];
            NSMutableURLRequest *fileRequest = [[NSMutableURLRequest alloc] init];
            [fileRequest setCachePolicy:NSURLRequestReloadIgnoringLocalCacheData];
            [fileRequest setHTTPShouldHandleCookies:NO];
            [fileRequest setTimeoutInterval:240];
            [fileRequest setHTTPMethod:@"POST"];
            NSString *boundary = @"---------------------------14737809831466499882746641449";
            NSString *contentType = [NSString stringWithFormat:@"multipart/form-data; boundary=%@",boundary];
            [fileRequest addValue:contentType forHTTPHeaderField: @"Content-Type"];
            NSString *fileExtension = [[filePath pathExtension] lowercaseString];
            //UIImage *yourImage= [UIImage imageNamed:filePath];
            //NSData *imageData = UIImageJPEGRepresentation(yourImage, 1.0);
            NSData *imageData = [NSData dataWithContentsOfFile:filePath];
            NSMutableData *body = [NSMutableData data];
            [body appendData:[[NSString stringWithFormat:@"\r\n--%@\r\n", boundary] dataUsingEncoding:NSUTF8StringEncoding]];
            if (imageData)
                [body appendData:[[NSString stringWithFormat:@"%@%@%@", @"Content-Disposition: form-data; name=\"uploaded_file\"; filename=\"",fileName,@"\"\r\n"] dataUsingEncoding:NSUTF8StringEncoding]];
            NSString *imgMimeType = [NSString stringWithFormat:@"Content-Type: %@\r\n\r\n", [self contentTypeForImageData:fileExtension]];
            [body appendData:[imgMimeType dataUsingEncoding:NSUTF8StringEncoding]];
            if (imageData)
                [body appendData:[NSData dataWithData:imageData]];
            [body appendData:[[NSString stringWithFormat:@"\r\n--%@--\r\n", boundary] dataUsingEncoding:NSUTF8StringEncoding]];
            [fileRequest setHTTPBody:body];
            NSString *postLength = [NSString stringWithFormat:@"%lu", (unsigned long)[body length]];
            [fileRequest setValue:postLength forHTTPHeaderField:@"Content-Length"];
            [fileRequest setURL:url];
            NSURLResponse *response = nil;
            //[NSURLConnection connectionWithRequest:fileRequest delegate:self];
            NSData *responseData = [NSURLConnection sendSynchronousRequest:fileRequest returningResponse:&response error:&jsonError];
            NSString *responseString = [[NSString alloc] initWithData:responseData encoding:NSUTF8StringEncoding];
            NSString *returnedIndication = responseString;
            if([returnedIndication isEqualToString:@"true"]) {
                [fileManager removeItemAtPath:filePath error:&jsonError];
            } else {
                statusIndication = @"true";
            }
        } else {
            NSLog(@"Failed while sending the server");
        }
    } @catch (NSException *exception) {
        NSLog(@"Exception handled for http failure...");
        statusIndication = @"true";
    }
    return statusIndication;
}

-(void) AuthenticationRefresh {
    @try {
        InternetConnection *networkReachability = [InternetConnection reachabilityForInternetConnection];
        NetworkStatus networkStatus = [networkReachability currentReachabilityStatus];
        if(networkStatus != NotReachable) {
            NSString *directory = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0];
            NSFileManager *fileManager = [NSFileManager defaultManager];
            NSString *rootFolderPath = [NSString stringWithFormat:@"%@/%@/my_accounts_encrypted.txt", directory, [self GetAppName]];
            NSError *error;
            NSString *myAccountsContents = [NSString stringWithContentsOfFile:rootFolderPath encoding:NSUTF8StringEncoding error:&error];
            NSData *myAccountsData = [myAccountsContents dataUsingEncoding:NSUTF8StringEncoding];
            NSArray *myAccountsArray = [NSJSONSerialization JSONObjectWithData:myAccountsData options: NSJSONReadingMutableContainers error: &error];
            NSString *appInfoFilePath = [NSString stringWithFormat:@"%@/%@/app_info_encrypted.txt", directory, [self GetAppName]];
            NSString *appInfoContents = [NSString stringWithContentsOfFile:appInfoFilePath encoding:NSUTF8StringEncoding error:&error];
            NSData *appInfoData = [appInfoContents dataUsingEncoding:NSUTF8StringEncoding];
            NSDictionary *appInfoDict = [NSJSONSerialization JSONObjectWithData:appInfoData options:0 error:&error];
            NSString *app_id = appInfoDict[@"app_id"];
            NSString *platform = appInfoDict[@"platform"];
            NSString *store = appInfoDict[@"store"];
            for(int index = 0; index < [myAccountsArray count]; index++) {
                NSString *clientId = [myAccountsArray[index] valueForKey:@"client_id"];
                NSString *countryCode = [myAccountsArray[index] valueForKey:@"country_code"];
                NSString *userId = [myAccountsArray[index] valueForKey:@"user_id"];
                NSString *sessionId = [myAccountsArray[index] valueForKey:@"session_id"];
                NSString *localeId = [myAccountsArray[index] valueForKey:@"locale_id"];
                NSString *deviceID = [myAccountsArray[index] valueForKey:@"device_id"];
                NSString *clientUrl = [myAccountsArray[index] valueForKey:@"client_url"];
                NSString *cvsUrl = [myAccountsArray[index] valueForKey:@"cvs_url"];
                NSString *authIndFilePath = [NSString stringWithFormat:@"%@/%@/%@/%@/auth_indication_encrypted.txt", directory, [self GetAppName], clientId, countryCode];
                NSString *clientConfigFile = [NSString stringWithFormat:@"%@/%@/%@/%@/client_configuration_encrypted.txt", directory, [self GetAppName], clientId, countryCode];
                if([fileManager fileExistsAtPath:authIndFilePath] == YES) {
                    NSData *fileData = [NSData dataWithContentsOfFile:authIndFilePath];
                    NSMutableDictionary *fileDict = [NSJSONSerialization JSONObjectWithData:fileData options:NSJSONReadingMutableContainers error:nil];
                    NSString *deviceStatus = fileDict[@"validDevice"];
                    NSDictionary *attributes = [[NSFileManager defaultManager] attributesOfItemAtPath:authIndFilePath error:nil];
                    NSDateFormatter *dateFormatter = [self getCurrentDateTime];
                    [dateFormatter setDateFormat:@"yyyyMMdd"];
                    NSString *lastModified = [dateFormatter stringFromDate:[attributes fileModificationDate]];
                    NSString *currentDate = [dateFormatter stringFromDate:[NSDate date]];
                    int lastModifiedInt = [lastModified intValue];
                    int currentDateInt = [currentDate intValue];
                    if([deviceStatus isEqualToString:@"nostatus"] || lastModifiedInt != currentDateInt) {
                        @try {
                            NSError *jsonError;
                            NSString *getKeyApsx = [NSString stringWithFormat:@"%@/common/components/Keys/RetrieveKey.aspx", clientUrl];
                            NSString *keyContent = [NSString stringWithFormat:@"{\"client_id\":\"%@\",\"country_code\":\"%@\",\"purposeCode\":\"mobile_address_store\",\"version\":\"doubleo\"}",clientId, countryCode];
                            NSMutableURLRequest *authRequest = [[NSMutableURLRequest alloc] initWithURL:[NSURL URLWithString:getKeyApsx]];
                            [authRequest setValue:@"text/json" forHTTPHeaderField:@"Content-type"];
                            [authRequest setHTTPMethod : @"POST"];
                            [authRequest setHTTPBody : [keyContent dataUsingEncoding:NSUTF8StringEncoding]];
                            NSURLResponse *keyResponse;
                            NSData *keyResponseData = [NSURLConnection sendSynchronousRequest:authRequest returningResponse:&keyResponse error:&jsonError];
                            NSString *responseString = [[NSString alloc] initWithData:keyResponseData encoding:NSUTF8StringEncoding];
                            NSData *keyData = [responseString dataUsingEncoding:NSUTF8StringEncoding];
                            [keyData writeToFile:clientConfigFile atomically:true];
                        } @catch (NSException *exception) {
                            NSLog(@"Exception: %@", exception.reason);
                        }
                        [self triggerAuthenticationServices:clientId countryCode:countryCode userId:userId sessionId:sessionId localeId:localeId deviceID:deviceID clientUrl:clientUrl cvsUrl:cvsUrl authIndFilePath:authIndFilePath app_id:app_id platform:platform store:store];
                    }
                } else {
                    @try {
                        NSError *jsonError;
                        NSString *getKeyApsx = [NSString stringWithFormat:@"%@/common/components/Keys/RetrieveKey.aspx", clientUrl];
                        NSString *keyContent = [NSString stringWithFormat:@"{\"client_id\":\"%@\",\"country_code\":\"%@\",\"purposeCode\":\"mobile_address_store\"}",clientId, countryCode];
                        NSMutableURLRequest *authRequest = [[NSMutableURLRequest alloc] initWithURL:[NSURL URLWithString:getKeyApsx]];
                        [authRequest setValue:@"text/json" forHTTPHeaderField:@"Content-type"];
                        [authRequest setHTTPMethod : @"POST"];
                        [authRequest setHTTPBody : [keyContent dataUsingEncoding:NSUTF8StringEncoding]];
                        NSURLResponse *keyResponse;
                        NSData *keyResponseData = [NSURLConnection sendSynchronousRequest:authRequest returningResponse:&keyResponse error:&jsonError];
                        NSString *responseString = [[NSString alloc] initWithData:keyResponseData encoding:NSUTF8StringEncoding];
                        NSData *keyData = [responseString dataUsingEncoding:NSUTF8StringEncoding];
                        [keyData writeToFile:clientConfigFile atomically:true];
                    } @catch (NSException *exception) {
                        NSLog(@"Exception: %@", exception.reason);
                    }
                    [self triggerAuthenticationServices:clientId countryCode:countryCode userId:userId sessionId:sessionId localeId:localeId deviceID:deviceID clientUrl:clientUrl cvsUrl:cvsUrl authIndFilePath:authIndFilePath app_id:app_id platform:platform store:store];
                }
            }
        }
    } @catch (NSException *exception) {
        NSLog(@"Exception : %@", exception.description);
    }
}

- (void)triggerAuthenticationServices:(NSString *)clientId  countryCode:(NSString *)countryCode  userId:(NSString *)userId  sessionId:(NSString *)sessionId  localeId:(NSString *)localeId  deviceID:(NSString *)deviceID  clientUrl:(NSString *)clientUrl  cvsUrl:(NSString *)cvsUrl authIndFilePath:(NSString *)authIndFilePath app_id:(NSString *)app_id platform:(NSString *)platform store:(NSString *)store{
    @try {
        NSString *directory = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0];
        NSError *jsonError;
        NSString *authAspx = [NSString stringWithFormat:@"%@/get_auth_indication.aspx", cvsUrl];
        NSString *deviceAspx = [NSString stringWithFormat:@"%@/security/validate_device.aspx", clientUrl];
        NSString *authContent = [NSString stringWithFormat:@"<inputparam><context><sessionId>%@</sessionId><userId>%@</userId><client_id>%@</client_id><locale_id>%@</locale_id><country_code>%@</country_code><app_id>%@</app_id><platform>%@</platform><store>%@</store></context></inputparam>",sessionId, userId, clientId, localeId, countryCode, app_id, platform, store];
        NSString *deviceContent = [NSString stringWithFormat:@"<document><context><sessionId>%@</sessionId><userId>%@</userId><client_id>%@</client_id><locale_id>%@</locale_id><country_code>%@</country_code><inputparam><p_device_id>%@</p_device_id><p_company_id>%@</p_company_id><p_country_code>%@</p_country_code></inputparam></context></document>",sessionId, userId, clientId, localeId, countryCode, deviceID, clientId, countryCode];
        NSMutableURLRequest *authRequest = [[NSMutableURLRequest alloc] initWithURL:[NSURL URLWithString:authAspx]];
        [authRequest setValue:@"text/xml" forHTTPHeaderField:@"Content-type"];
        [authRequest setHTTPMethod : @"POST"];
        [authRequest setHTTPBody : [authContent dataUsingEncoding:NSUTF8StringEncoding]];
        NSURLResponse *authResponse;
        NSData *authResponseData = [NSURLConnection sendSynchronousRequest:authRequest returningResponse:&authResponse error:&jsonError];
        NSString *responseString = [[NSString alloc] initWithData:authResponseData encoding:NSUTF8StringEncoding];
        NSMutableDictionary * mutableDict = [[NSMutableDictionary alloc] init];
        mutableDict = [NSJSONSerialization JSONObjectWithData:[responseString dataUsingEncoding:NSUTF8StringEncoding] options:kNilOptions error:&jsonError];
        //For device authentication
        @try {
            NSData *deviceData = [deviceContent dataUsingEncoding:NSUTF8StringEncoding];
            NSMutableURLRequest *deviceRequest = [[NSMutableURLRequest alloc] initWithURL:[NSURL URLWithString:deviceAspx]];
            [deviceRequest setValue:@"text/xml" forHTTPHeaderField:@"Content-type"];
            [deviceRequest setHTTPMethod : @"POST"];
            [deviceRequest setHTTPBody : deviceData];
            NSURLResponse *deviceResponse;
            NSData *deviceResponseData = [NSURLConnection sendSynchronousRequest:deviceRequest returningResponse:&deviceResponse error:nil];
            if (deviceResponseData != nil) {
                NSString *xmlFile = [NSString stringWithFormat:@"%@/%@/%@/%@/resp.xml", directory, [self GetAppName], clientId, countryCode];
                [deviceResponseData writeToFile:xmlFile atomically:true];
                [XMLConverter convertXMLFile:xmlFile completion:^(BOOL success, NSDictionary *dictionary, NSError *error)
                 {
                     if (success) {
                         NSDictionary *documentDict = [dictionary objectForKey:@"document"];
                         NSDictionary *context = [documentDict objectForKey:@"context"];
                         NSDictionary *outputparam = [context objectForKey:@"outputparam"];
                         NSString *p_valid_device_ind = [outputparam objectForKey:@"p_valid_device_ind"];
                         NSMutableDictionary * deviceDict = [[NSMutableDictionary alloc] init];
                         [deviceDict setValue:mutableDict[@"appVersion"] forKey:@"appVersion"];
                         [deviceDict setValue:mutableDict[@"cvsRefresh"] forKey:@"cvsRefresh"];
                         [deviceDict setValue:p_valid_device_ind forKey:@"validDevice"];
                         NSData *jsonData = [NSJSONSerialization dataWithJSONObject:deviceDict options:NSJSONWritingPrettyPrinted error:nil];
                         [jsonData writeToFile:authIndFilePath atomically:true];
                     }
                 }];
            } else {
                NSMutableDictionary * deviceDict = [[NSMutableDictionary alloc] init];
                [deviceDict setValue:mutableDict[@"appVersion"] forKey:@"appVersion"];
                [deviceDict setValue:mutableDict[@"cvsRefresh"] forKey:@"cvsRefresh"];
                [deviceDict setValue:@"nostatus" forKey:@"validDevice"];
                NSData *jsonData = [NSJSONSerialization dataWithJSONObject:deviceDict options:NSJSONWritingPrettyPrinted error:nil];
                [jsonData writeToFile:authIndFilePath atomically:true];
            }
        } @catch (NSException *exception) {
            NSMutableDictionary * deviceDict = [[NSMutableDictionary alloc] init];
            [deviceDict setValue:mutableDict[@"appVersion"] forKey:@"appVersion"];
            [deviceDict setValue:mutableDict[@"cvsRefresh"] forKey:@"cvsRefresh"];
            [deviceDict setValue:@"nostatus" forKey:@"validDevice"];
            NSData *jsonData = [NSJSONSerialization dataWithJSONObject:deviceDict options:NSJSONWritingPrettyPrinted error:nil];
            [jsonData writeToFile:authIndFilePath atomically:true];
        }
    } @catch (NSException *exception) {
        NSLog(@"Exception : %@", exception.description);
    }
}
-(UIImage*)imageWithImage: (UIImage*) sourceImage scaledToWidth: (float) i_width
{
    float oldWidth = sourceImage.size.width;
    float scaleFactor = i_width / oldWidth;

    float newHeight = sourceImage.size.height * scaleFactor;
    float newWidth = oldWidth * scaleFactor;

    UIGraphicsBeginImageContext(CGSizeMake(newWidth, newHeight));
    [sourceImage drawInRect:CGRectMake(0, 0, newWidth, newHeight)];
    UIImage *newImage = UIGraphicsGetImageFromCurrentImageContext();
    UIGraphicsEndImageContext();
    return newImage;
}
- (UIImage*) scaleImage:(UIImage*)image toSize:(CGSize)newSize {
    CGSize scaledSize = newSize;
    float scaleFactor = 1.0;
    if( image.size.width > image.size.height ) {
        scaleFactor = image.size.width / image.size.height;
        scaledSize.width = newSize.width;
        scaledSize.height = newSize.height / scaleFactor;
    }
    else {
        scaleFactor = image.size.height / image.size.width;
        scaledSize.height = newSize.height;
        scaledSize.width = newSize.width / scaleFactor;
    }

    UIGraphicsBeginImageContextWithOptions( scaledSize, NO, 0.0 );
    CGRect scaledImageRect = CGRectMake( 0.0, 0.0, scaledSize.width, scaledSize.height );
    [image drawInRect:scaledImageRect];
    UIImage* scaledImage = UIGraphicsGetImageFromCurrentImageContext();
    UIGraphicsEndImageContext();

    return scaledImage;
}

#pragma mark - ImagePickerController Delegate

-(void)imagePickerController:(UIImagePickerController *)picker didFinishPickingMediaWithInfo:(NSDictionary *)info {
    if ([picker isEqual:ipc]) {
       // if(UI_USER_INTERFACE_IDIOM()==UIUserInterfaceIdiomPhone) {
            [picker dismissViewControllerAnimated:YES completion:nil];
       // } else {
        //    [popover dismissPopoverAnimated:YES];
        //}
        UIImageView *ivPickedImage = [[UIImageView alloc] init];
        ivPickedImage.image = [info objectForKey:UIImagePickerControllerOriginalImage];
        NSURL *refURL = (NSURL *)[info valueForKey:UIImagePickerControllerReferenceURL];
        // define the block to call when we get the asset based on the url (below)
        ALAssetsLibraryAssetForURLResultBlock resultblock = ^(ALAsset *imageAsset)
        {
            ALAssetRepresentation *imageRep = [imageAsset defaultRepresentation];
            NSString* directory = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES)[0];
            NSString *dest = [NSString stringWithFormat:@"%@/%@/%@",directory,[self GetAppName],@"images"];
            if (![[NSFileManager defaultManager] fileExistsAtPath:dest]){
                [[NSFileManager defaultManager] createDirectoryAtPath:dest withIntermediateDirectories:YES attributes:nil error:nil];
            }
            NSDate *now = [NSDate date];
            NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init];
            dateFormatter.dateFormat = @"yyyyMMddHHmmss";
            [dateFormatter setTimeZone:[NSTimeZone systemTimeZone]];
            NSString *gmtTime = [dateFormatter stringFromDate:now];
            NSString *destination = [NSString stringWithFormat:@"%@/%@.jpg", dest, gmtTime];
            NSLog(@"destination path: %@", destination);
            UIImage *img = ivPickedImage.image;
            NSData * data = UIImageJPEGRepresentation(img, 0.3);
            long imgSize = data.length;
            NSString *strImageSize = [NSString stringWithFormat:@"%ld", imgSize];
            NSString *extension = [[NSString stringWithFormat:@".%@",[destination pathExtension]] lowercaseString];
            [data writeToFile:destination atomically:YES];
            NSMutableDictionary * dict = [[NSMutableDictionary alloc] init];
            [dict setValue:[destination stringByDeletingLastPathComponent] forKey:@"filePath"];
            [dict setValue:[destination lastPathComponent] forKey:@"fileName"];
            [dict setValue:strImageSize forKey:@"fileSize"];
            [dict setValue:extension forKey:@"fileExtension"];
            CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsDictionary:dict];
            [self.commandDelegate sendPluginResult:result callbackId:self.callbackIdForImagePicker];
        };
        // get the asset library and fetch the asset based on the ref url (pass in block above)
        NSLog(@"refURL : %@", refURL);
        ALAssetsLibrary* assetslibrary = [[ALAssetsLibrary alloc] init];
        [assetslibrary assetForURL:refURL resultBlock:resultblock failureBlock:nil];
    } else if ([picker isEqual: cameraOpen]) {
        if ([imageAttachmentInd isEqualToString:@"true"]) {
            //if(UI_USER_INTERFACE_IDIOM()==UIUserInterfaceIdiomPhone) {
                [picker dismissViewControllerAnimated:YES completion:nil];
           // } else {
           //     [popover dismissPopoverAnimated:YES];
           // }
            UIImageView *ivPickedImage = [[UIImageView alloc] init];
            ivPickedImage.image = [info objectForKey:UIImagePickerControllerOriginalImage];
            NSURL *refURL = (NSURL *)[info valueForKey:UIImagePickerControllerReferenceURL];
            // define the block to call when we get the asset based on the url (below)
            ALAssetsLibraryAssetForURLResultBlock resultblock = ^(ALAsset *imageAsset) {
                UIImage *image = ivPickedImage.image;
                NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
                NSString *directory = [paths objectAtIndex:0];
                NSString* appRootPath = [directory stringByAppendingPathComponent:[self GetAppName]];
                NSString *imagesFolderPath = [appRootPath stringByAppendingPathComponent:imageDestinationPath];
                if (![[NSFileManager defaultManager] fileExistsAtPath:imagesFolderPath]){
                    [[NSFileManager defaultManager] createDirectoryAtPath:imagesFolderPath withIntermediateDirectories:YES attributes:nil error:nil];
                }
                NSDateFormatter *dateFormatter = [self getCurrentDateTime];
                [dateFormatter setDateFormat:@"yyyyMMddHHmmss"];
                NSString *fileName = [NSString stringWithFormat:@"%@.png", [dateFormatter stringFromDate:[NSDate date]]];
                NSString* imageSavedPath = [imagesFolderPath stringByAppendingPathComponent:fileName];
                NSData* imageData = UIImageJPEGRepresentation(image, 0.3);
                [imageData writeToFile:imageSavedPath atomically:YES];
                long imgSize = imageData.length;
                NSString *strImageSize = [NSString stringWithFormat:@"%ld", imgSize];
                NSString *extension = [[NSString stringWithFormat:@".%@",[imageSavedPath pathExtension]] lowercaseString];
                NSMutableDictionary * dict = [[NSMutableDictionary alloc] init];
                [dict setValue:[imageSavedPath stringByDeletingLastPathComponent] forKey:@"filePath"];
                [dict setValue:[imageSavedPath lastPathComponent] forKey:@"fileName"];
                [dict setValue:strImageSize forKey:@"fileSize"];
                [dict setValue:extension forKey:@"fileExtension"];
                CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsDictionary:dict];
                [self.commandDelegate sendPluginResult:result callbackId:self.callbackIdForImagePicker];
            };
            ALAssetsLibrary* assetslibrary = [[ALAssetsLibrary alloc] init];
            [assetslibrary assetForURL:refURL resultBlock:resultblock failureBlock:nil];
        } else {
            [picker dismissViewControllerAnimated:YES completion:nil];
            UIImageView *ivPickedImage = [[UIImageView alloc] init];
            ivPickedImage.image = [info objectForKey:UIImagePickerControllerOriginalImage];
            UIImage *finalImage = [self imageWithImage:ivPickedImage.image scaledToWidth:824.00];
            NSURL *refURL = (NSURL *)[info valueForKey:UIImagePickerControllerReferenceURL];
            ALAssetsLibraryAssetForURLResultBlock resultblock = ^(ALAsset *imageAsset)
            {
                NSData *imageData = UIImageJPEGRepresentation(finalImage, 0.1);
                NSString * base64String = [imageData base64EncodedStringWithOptions:0];
                CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsString:base64String];
                [self.commandDelegate sendPluginResult:result callbackId:self.callbackIdForImagePicker];
            };
            ALAssetsLibrary* assetslibrary = [[ALAssetsLibrary alloc] init];
            [assetslibrary assetForURL:refURL resultBlock:resultblock failureBlock:nil];
        }
    } else if ([picker isEqual:imagePicker]) {
        if ([imageAttachmentInd isEqualToString:@"true"]) {
            [picker dismissViewControllerAnimated:YES completion:nil];
            UIImageView *ivPickedImage = [[UIImageView alloc] init];
            ivPickedImage.image = [info objectForKey:UIImagePickerControllerOriginalImage];
            NSURL *refURL = (NSURL *)[info valueForKey:UIImagePickerControllerReferenceURL];
            // define the block to call when we get the asset based on the url (below)
            ALAssetsLibraryAssetForURLResultBlock resultblock = ^(ALAsset *imageAsset) {
                UIImage *image = ivPickedImage.image;
                NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
                NSString *directory = [paths objectAtIndex:0];
                NSString* appRootPath = [directory stringByAppendingPathComponent:[self GetAppName]];
                NSString *imagesFolderPath = [appRootPath stringByAppendingPathComponent:imageDestinationPath];
                if (![[NSFileManager defaultManager] fileExistsAtPath:imagesFolderPath]){
                    [[NSFileManager defaultManager] createDirectoryAtPath:imagesFolderPath withIntermediateDirectories:YES attributes:nil error:nil];
                }
                NSDateFormatter *dateFormatter = [self getCurrentDateTime];
                [dateFormatter setDateFormat:@"yyyyMMddHHmmss"];
                NSString *fileName = [NSString stringWithFormat:@"%@.png", [dateFormatter stringFromDate:[NSDate date]]];
                NSString* imageSavedPath = [imagesFolderPath stringByAppendingPathComponent:fileName];
                NSData* imageData = UIImageJPEGRepresentation(image, 0.3);
                [imageData writeToFile:imageSavedPath atomically:YES];
                long imgSize = imageData.length;
                NSString *strImageSize = [NSString stringWithFormat:@"%ld", imgSize];
                NSString *extension = [[NSString stringWithFormat:@".%@",[imageSavedPath pathExtension]] lowercaseString];
                NSMutableDictionary * dict = [[NSMutableDictionary alloc] init];
                [dict setValue:[imageSavedPath stringByDeletingLastPathComponent] forKey:@"filePath"];
                [dict setValue:[imageSavedPath lastPathComponent] forKey:@"fileName"];
                [dict setValue:strImageSize forKey:@"fileSize"];
                [dict setValue:extension forKey:@"fileExtension"];
                CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsDictionary:dict];
                [self.commandDelegate sendPluginResult:result callbackId:self.callbackIdForImagePicker];
             };
             // get the asset library and fetch the asset based on the ref url (pass in block above)
             NSLog(@"refURL : %@", refURL);
             ALAssetsLibrary* assetslibrary = [[ALAssetsLibrary alloc] init];
             [assetslibrary assetForURL:refURL resultBlock:resultblock failureBlock:nil];
        } else {
            [picker dismissViewControllerAnimated:YES completion:nil];
            UIImageView *ivPickedImage = [[UIImageView alloc] init];
            ivPickedImage.image = [info objectForKey:UIImagePickerControllerOriginalImage];
            UIImage *finalImage = [self imageWithImage:ivPickedImage.image scaledToWidth:824.00];
            NSURL *refURL = (NSURL *)[info valueForKey:UIImagePickerControllerReferenceURL];
            ALAssetsLibraryAssetForURLResultBlock resultblock = ^(ALAsset *imageAsset)
            {
                NSData *imageData = UIImageJPEGRepresentation(finalImage, 0.1);
                NSString * base64String = [imageData base64EncodedStringWithOptions:0];
                CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsString:base64String];
                [self.commandDelegate sendPluginResult:result callbackId:self.callbackIdForImagePicker];
            };
            ALAssetsLibrary* assetslibrary = [[ALAssetsLibrary alloc] init];
            [assetslibrary assetForURL:refURL resultBlock:resultblock failureBlock:nil];
        }
    } else if ([picker isEqual:liveCamera]) {
        //if(UI_USER_INTERFACE_IDIOM()==UIUserInterfaceIdiomPhone) {
            [picker dismissViewControllerAnimated:YES completion:nil];
       // } else {
       //     [popover dismissPopoverAnimated:YES];
       // }
        UIImageView *ivPickedImage = [[UIImageView alloc] init];
        ivPickedImage.image = [info objectForKey:UIImagePickerControllerOriginalImage];
        NSURL *refURL = (NSURL *)[info valueForKey:UIImagePickerControllerReferenceURL];
        // define the block to call when we get the asset based on the url (below)
        ALAssetsLibraryAssetForURLResultBlock resultblock = ^(ALAsset *imageAsset) {
            UIImage *image = ivPickedImage.image;
            NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
            NSString *directory = [paths objectAtIndex:0];
            NSString* appRootPath = [directory stringByAppendingPathComponent:[self GetAppName]];
            NSString *imagesFolderPath = [appRootPath stringByAppendingPathComponent:@"images"];
            if (![[NSFileManager defaultManager] fileExistsAtPath:imagesFolderPath]){
                [[NSFileManager defaultManager] createDirectoryAtPath:imagesFolderPath withIntermediateDirectories:YES attributes:nil error:nil];
            }
            NSDateFormatter *dateFormatter = [self getCurrentDateTime];
            [dateFormatter setDateFormat:@"yyyyMMddHHmmss"];
            NSString *fileName = [NSString stringWithFormat:@"%@.png", [dateFormatter stringFromDate:[NSDate date]]];
            NSString* imageSavedPath = [imagesFolderPath stringByAppendingPathComponent:fileName];
            NSData* imageData = UIImageJPEGRepresentation(image, 0.3);
            [imageData writeToFile:imageSavedPath atomically:YES];
            long imgSize = imageData.length;
            NSString *strImageSize = [NSString stringWithFormat:@"%ld", imgSize];
            NSString *extension = [[NSString stringWithFormat:@".%@",[imageSavedPath pathExtension]] lowercaseString];
            NSMutableDictionary * dict = [[NSMutableDictionary alloc] init];
            [dict setValue:[imageSavedPath stringByDeletingLastPathComponent] forKey:@"filePath"];
            [dict setValue:[imageSavedPath lastPathComponent] forKey:@"fileName"];
            [dict setValue:strImageSize forKey:@"fileSize"];
            [dict setValue:extension forKey:@"fileExtension"];
            CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsDictionary:dict];
            [self.commandDelegate sendPluginResult:result callbackId:self.callbackIdForImagePicker];
        };
        ALAssetsLibrary* assetslibrary = [[ALAssetsLibrary alloc] init];
        [assetslibrary assetForURL:refURL resultBlock:resultblock failureBlock:nil];
    }
}

-(void)imagePickerControllerDidCancel:(UIImagePickerController *)picker
{
    [picker dismissViewControllerAnimated:YES completion:nil];
    CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_ERROR];
    [self.commandDelegate sendPluginResult:result callbackId:self.callbackIdForImagePicker];
}

- (void)didReceiveMemoryWarning
{
    // Dispose of any resources that can be recreated.
}

- (void)UpdateNew:(CDVInvokedUrlCommand*)command {
    NSDictionary* infoDictionary = [[NSBundle mainBundle] infoDictionary];
    NSString* appID = infoDictionary[@"CFBundleIdentifier"];
    NSURL* url = [NSURL URLWithString:[NSString stringWithFormat:@"http://itunes.apple.com/lookup?bundleId=%@", appID]];
    NSData* data = [NSData dataWithContentsOfURL:url];
    NSDictionary* lookup = [NSJSONSerialization JSONObjectWithData:data options:0 error:nil];
    NSString * trackViewUrl =  lookup[@"results"][0][@"trackViewUrl"];
    [[UIApplication sharedApplication] openURL:[NSURL URLWithString:trackViewUrl]];
    CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_ERROR];
    [self.commandDelegate sendPluginResult:result callbackId:self.callbackIdForAppUpdate];
}

-(CGRect)rectForView {
    UIInterfaceOrientation orientation = [[UIApplication sharedApplication] statusBarOrientation];
    BOOL landscape = (orientation == UIInterfaceOrientationLandscapeLeft || orientation == UIInterfaceOrientationLandscapeRight);
    if(landscape){
        return CGRectMake( 0.0f, 0.0f, [UIScreen mainScreen].bounds.size.height, [[UIScreen mainScreen]bounds].size.width);
    }
    return CGRectMake( 0.0f, 0.0f, [[UIScreen mainScreen]bounds].size.width, [UIScreen mainScreen].bounds.size.height);
}

- (void)handleTapGesture:(UITapGestureRecognizer *)gesture
{
    CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK];
    [result setKeepCallbackAsBool:true];
    if (!spinnerIsFixed.boolValue) {
        [result setKeepCallbackAsBool:false];
        [self hide];
    }
    [self.commandDelegate sendPluginResult:result callbackId:spinnerCallbackId];
}

- (UIView *)overlay {
    if (!_overlay) {
        _overlay = [[UIView alloc] initWithFrame:self.rectForView];
        _overlay.backgroundColor = [UIColor colorWithRed:0 green:0 blue:0 alpha:0.60];
        _indicator = [[UIActivityIndicatorView alloc] initWithActivityIndicatorStyle:UIActivityIndicatorViewStyleWhiteLarge];
        _indicator.center = _overlay.center;
        [_indicator startAnimating];
        [_overlay addSubview:_indicator];
        
        UITapGestureRecognizer *tapRecognizer = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(handleTapGesture:)];
        [_overlay addGestureRecognizer: tapRecognizer];
    }
    return _overlay;
}

- (void)Spinner:(CDVInvokedUrlCommand *)command {
    NSMutableDictionary * dict = [[command arguments] objectAtIndex:0];
    NSNumber *spinnerInd = dict[@"show"];
    NSString *comapareString = dict[@"show"];
    if([comapareString isEqualToString:@"true"]) {
        spinnerCallbackId = command.callbackId;
        //If there is a loading mask yet we hide it
        [self hide];
        spinnerIsFixed = spinnerInd;
        UIViewController *rootViewController = [[[[UIApplication sharedApplication] delegate] window] rootViewController];
        [rootViewController.view addSubview:self.overlay];
        //[[UIApplication sharedApplication] beginIgnoringInteractionEvents];
    } else {
        [self hide];
    }
    CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK];
    [self.commandDelegate sendPluginResult:result callbackId:self.successCallBackForSpinner];
}

- (void) hide {
    if (_overlay) {
        [self.indicator stopAnimating];
        [self.indicator removeFromSuperview];
        [self.overlay removeFromSuperview];
        _indicator = nil;
        _overlay = nil;
    }
}

#pragma mark - PRIVATE METHODS

- (NSString *)GetAppName {
    NSString *packageName = [[NSBundle mainBundle] bundleIdentifier];
    NSArray *splitedArray = [packageName componentsSeparatedByString:@"."];
    return splitedArray[2];
}

- (void)GetPackageName:(CDVInvokedUrlCommand*)command {
    NSString *bundleIdentifier = [[NSBundle mainBundle] bundleIdentifier];
    CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsString:bundleIdentifier];
    [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
}

//----------- APPVERSION PLUGIN -----------//
- (void)AppVersion:(CDVInvokedUrlCommand*)command {
    NSDictionary *infoDict = [[NSBundle mainBundle] infoDictionary];
    NSString *appVersion = [infoDict objectForKey:@"CFBundleShortVersionString"];
    NSNumber *buildNumber = [infoDict objectForKey:@"CFBundleVersion"];
    NSDictionary *dict = @{@"version":appVersion,@"build":buildNumber};
    CDVPluginResult* pluginResult = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsDictionary:dict];
    [self.commandDelegate sendPluginResult:pluginResult callbackId:command.callbackId];
}

//----------- TO GET DEVICE INFORMATIONS -----------//
- (NSString*)modelVersion
{
#if TARGET_IPHONE_SIMULATOR
    NSString* platform = NSProcessInfo.processInfo.environment[@"SIMULATOR_MODEL_IDENTIFIER"];
#else
    size_t size;
    
    sysctlbyname("hw.machine", NULL, &size, NULL, 0);
    char* machine = malloc(size);
    sysctlbyname("hw.machine", machine, &size, NULL, 0);
    NSString* platform = [NSString stringWithUTF8String:machine];
    free(machine);
#endif
    return platform;
}

- (NSString*)uniqueAppInstanceIdentifier:(UIDevice*)device {
    NSUserDefaults* userDefaults = [NSUserDefaults standardUserDefaults];
    static NSString* UUID_KEY = @"CDVUUID";
    
    // Check user defaults first to maintain backwards compaitibility with previous versions
    // which didn't user identifierForVendor
    NSString* app_uuid = [userDefaults stringForKey:UUID_KEY];
    if (app_uuid == nil) {
        if ([device respondsToSelector:@selector(identifierForVendor)]) {
            app_uuid = [[device identifierForVendor] UUIDString];
        } else {
            CFUUIDRef uuid = CFUUIDCreate(NULL);
            app_uuid = (__bridge_transfer NSString *)CFUUIDCreateString(NULL, uuid);
            CFRelease(uuid);
        }
        
        [userDefaults setObject:app_uuid forKey:UUID_KEY];
        [userDefaults synchronize];
    }
    return app_uuid;
}

- (void)getMyAccountsData:(CDVInvokedUrlCommand *)command{
    NSMutableDictionary * dict = [[command arguments] objectAtIndex:0];
    NSString *dir = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0];
    NSString *folderPath = [NSString stringWithFormat:@"%@/%@", dir, dict[@"folderPath"]];
    CDVPluginResult* pluginResult = nil;
    NSMutableArray* dataArray = [NSMutableArray array];
    NSError* error = nil;
    NSFileManager* fileManager = [NSFileManager defaultManager];
    if ([fileManager fileExistsAtPath:folderPath isDirectory:nil]) {
        NSArray* files = [fileManager contentsOfDirectoryAtPath:folderPath error:&error];
        if (files) {
            for (NSString* fileName in files) {
                if ([fileName.pathExtension isEqualToString:@"json"]) {
                    NSString* filePath = [folderPath stringByAppendingPathComponent:fileName];
                    NSData* jsonData = [NSData dataWithContentsOfFile:filePath];
                    if (jsonData) {
                        NSString* jsonString = [[NSString alloc] initWithData:jsonData encoding:NSUTF8StringEncoding];
                        [dataArray addObject:jsonString];
                    }
                }
            }
        } else {
            NSLog(@"Error reading folder contents: %@", error);
        }
    }
    NSString *jsonArrayString = [NSString stringWithFormat:@"[%@]", [dataArray componentsJoinedByString:@","]];
    CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsString:jsonArrayString];
    [self.commandDelegate sendPluginResult:result callbackId:command.callbackId];
}

- (void)DeviceInfo:(CDVInvokedUrlCommand*)command {
    NSString * directory = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0];
    NSLog(@"Documents Path : %@", directory);
    NSDictionary* deviceProperties = [self deviceProperties];
    CDVPluginResult* pluginResult = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsDictionary:deviceProperties];
    [self.commandDelegate sendPluginResult:pluginResult callbackId:command.callbackId];
}

- (NSDictionary*)deviceProperties {
    UIDevice* device = [UIDevice currentDevice];
    return @{
             @"manufacturer": @"Apple",
             @"model": [device model],
             @"platform": @"iOS",
             @"version": [device systemVersion],
             @"uuid": [self uniqueAppInstanceIdentifier:device],
             @"cordova": [[self class] cordovaVersion],
             @"isVirtual": @([self isVirtual]),
             @"applicationName": [[[NSBundle mainBundle] infoDictionary] objectForKey:@"CFBundleDisplayName"]
             };
}

+ (NSString*)cordovaVersion {
    return CDV_VERSION;
}

- (BOOL)isVirtual {
#if TARGET_OS_SIMULATOR
    return true;
#elif TARGET_IPHONE_SIMULATOR
    return true;
#else
    return false;
#endif
}

- (void)OpenFileWithViewer:(CDVInvokedUrlCommand *)command {
    self.fileOpenCallbackId = command.callbackId;
    [self.commandDelegate runInBackground:^{
        CDVPluginResult* commandResult = nil;
        NSString *filePath = [command.arguments objectAtIndex:0];
        if (filePath != nil && [filePath length] > 0) {
            NSURL *url = [NSURL URLWithString:filePath];
            NSError *err;
            if (url.isFileURL && [url checkResourceIsReachableAndReturnError:&err] == YES) {
                self.fileUrl = url;
                QLPreviewController *previewCtrl = [[QLPreviewController alloc] init];
                previewCtrl.delegate = self;
                previewCtrl.dataSource = self;
                [previewCtrl.navigationItem setRightBarButtonItem:nil];
                dispatch_async(dispatch_get_main_queue(), ^{
                    [self.viewController presentViewController:previewCtrl animated:YES completion:nil];
                });
                commandResult = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsString:@"Success"];
                [commandResult setKeepCallback:[NSNumber numberWithBool:YES]];
            } else {
                NSLog(@"Invalid file URL");
                commandResult = [CDVPluginResult resultWithStatus:CDVCommandStatus_ERROR messageAsString:@"Invalid file URL"];
            }
        } else {
            NSLog(@"Missing URL argument");
            commandResult = [CDVPluginResult resultWithStatus:CDVCommandStatus_ERROR messageAsString:@"Missing URL argument"];
        }
        [self.commandDelegate sendPluginResult:commandResult callbackId:command.callbackId];
    }];
}

#pragma - QLPreviewControllerDataSource Protocol

- (NSInteger)numberOfPreviewItemsInPreviewController:
(QLPreviewController *)controller {
    return 1;
}

- (id<QLPreviewItem>)previewController:(QLPreviewController *)controller
                    previewItemAtIndex:(NSInteger)index {
    return self;
}

- (void)previewControllerDidDismiss:(QLPreviewController *)controller {
    CDVPluginResult* pluginResult = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsString:@"resume"];
    [pluginResult setKeepCallback:[NSNumber numberWithBool:YES]];
    [self.commandDelegate sendPluginResult:pluginResult callbackId:self.fileOpenCallbackId];
    self.fileOpenCallbackId = nil;
}

#pragma - QLPreviewItem Protocol

- (NSURL *)previewItemURL {
    return self.fileUrl;
}
@end




